/* gitg-date.c generated by valac 0.56.17, the Vala compiler
 * generated from gitg-date.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2013 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gdesktop-enums.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GITG_DATE_0_PROPERTY,
	GITG_DATE_DATE_STRING_PROPERTY,
	GITG_DATE_DATE_PROPERTY,
	GITG_DATE_NUM_PROPERTIES
};
static GParamSpec* gitg_date_properties[GITG_DATE_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GitgDatePrivate {
	GDateTime* d_datetime;
	gchar* _date_string;
};

static gint GitgDate_private_offset;
static gpointer gitg_date_parent_class = NULL;
static GRegex* gitg_date_s_rfc2822;
static GRegex* gitg_date_s_rfc2822 = NULL;
static GRegex* gitg_date_s_iso8601;
static GRegex* gitg_date_s_iso8601 = NULL;
static GRegex* gitg_date_s_internal;
static GRegex* gitg_date_s_internal = NULL;
static GSettings* gitg_date_s_gnome_interface_settings;
static GSettings* gitg_date_s_gnome_interface_settings = NULL;
static gboolean gitg_date_s_tried_gnome_interface_settings;
static gboolean gitg_date_s_tried_gnome_interface_settings = FALSE;
static gchar** gitg_date_s_months;
static gint gitg_date_s_months_length1;
static gchar** gitg_date_s_months = NULL;
static gint gitg_date_s_months_length1 = 0;
static gint _gitg_date_s_months_size_ = 0;
static GInitableIface * gitg_date_g_initable_parent_iface = NULL;

static gboolean gitg_date_fetch_and_set_int (GMatchInfo* info,
                                      const gchar* name,
                                      gint* retval);
static gboolean gitg_date_fetch_and_set_double (GMatchInfo* info,
                                         const gchar* name,
                                         gdouble* retval);
static GDateTime* gitg_date_parse_internal (GMatchInfo* info,
                                     GError** error);
static GDateTime* gitg_date_parse_iso8601 (GMatchInfo* info,
                                    GError** error);
static GDateTime* gitg_date_parse_rfc2822 (GMatchInfo* info,
                                    GError** error);
static gboolean gitg_date_real_init (GInitable* base,
                              GCancellable* cancellable,
                              GError** error);
static gboolean gitg_date_get_is_24h (GitgDate* self);
static void gitg_date_finalize (GObject * obj);
static GType gitg_date_get_type_once (void);
static void _vala_gitg_date_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_gitg_date_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

GQuark
gitg_date_error_quark (void)
{
	return g_quark_from_static_string ("gitg-date-error-quark");
}

 G_GNUC_NO_INLINE static GType
gitg_date_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GITG_DATE_ERROR_INVALID_FORMAT, "GITG_DATE_ERROR_INVALID_FORMAT", "invalid-format"}, {0, NULL, NULL}};
	GType gitg_date_error_type_id;
	gitg_date_error_type_id = g_enum_register_static ("GitgDateError", values);
	return gitg_date_error_type_id;
}

GType
gitg_date_error_get_type (void)
{
	static gsize gitg_date_error_type_id__once = 0;
	if (g_once_init_enter (&gitg_date_error_type_id__once)) {
		GType gitg_date_error_type_id;
		gitg_date_error_type_id = gitg_date_error_get_type_once ();
		g_once_init_leave (&gitg_date_error_type_id__once, gitg_date_error_type_id);
	}
	return gitg_date_error_type_id__once;
}

static inline gpointer
gitg_date_get_instance_private (GitgDate* self)
{
	return G_STRUCT_MEMBER_P (self, GitgDate_private_offset);
}

static gboolean
gitg_date_fetch_and_set_int (GMatchInfo* info,
                             const gchar* name,
                             gint* retval)
{
	gchar* val = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
	gboolean result;
#line 139 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 139 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 141 "../libgitg/gitg-date.vala"
	_tmp0_ = g_match_info_fetch_named (info, name);
#line 141 "../libgitg/gitg-date.vala"
	val = _tmp0_;
#line 143 "../libgitg/gitg-date.vala"
	_tmp2_ = val;
#line 143 "../libgitg/gitg-date.vala"
	if (_tmp2_ == NULL) {
#line 143 "../libgitg/gitg-date.vala"
		_tmp1_ = TRUE;
#line 170 "gitg-date.c"
	} else {
		const gchar* _tmp3_;
#line 143 "../libgitg/gitg-date.vala"
		_tmp3_ = val;
#line 143 "../libgitg/gitg-date.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") == 0;
#line 177 "gitg-date.c"
	}
#line 143 "../libgitg/gitg-date.vala"
	if (_tmp1_) {
#line 145 "../libgitg/gitg-date.vala"
		result = FALSE;
#line 145 "../libgitg/gitg-date.vala"
		_g_free0 (val);
#line 145 "../libgitg/gitg-date.vala"
		return result;
#line 187 "gitg-date.c"
	}
#line 148 "../libgitg/gitg-date.vala"
	_tmp4_ = val;
#line 148 "../libgitg/gitg-date.vala"
	*retval = atoi (_tmp4_);
#line 149 "../libgitg/gitg-date.vala"
	result = TRUE;
#line 149 "../libgitg/gitg-date.vala"
	_g_free0 (val);
#line 149 "../libgitg/gitg-date.vala"
	return result;
#line 199 "gitg-date.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 212 "gitg-date.c"
}

static gboolean
gitg_date_fetch_and_set_double (GMatchInfo* info,
                                const gchar* name,
                                gdouble* retval)
{
	gchar* val = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 152 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 152 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 154 "../libgitg/gitg-date.vala"
	_tmp0_ = g_match_info_fetch_named (info, name);
#line 154 "../libgitg/gitg-date.vala"
	val = _tmp0_;
#line 156 "../libgitg/gitg-date.vala"
	_tmp1_ = val;
#line 156 "../libgitg/gitg-date.vala"
	if (_tmp1_ == NULL) {
#line 158 "../libgitg/gitg-date.vala"
		result = FALSE;
#line 158 "../libgitg/gitg-date.vala"
		_g_free0 (val);
#line 158 "../libgitg/gitg-date.vala"
		return result;
#line 243 "gitg-date.c"
	}
#line 161 "../libgitg/gitg-date.vala"
	_tmp2_ = val;
#line 161 "../libgitg/gitg-date.vala"
	*retval = double_parse (_tmp2_);
#line 162 "../libgitg/gitg-date.vala"
	result = TRUE;
#line 162 "../libgitg/gitg-date.vala"
	_g_free0 (val);
#line 162 "../libgitg/gitg-date.vala"
	return result;
#line 255 "gitg-date.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 778 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 779 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 779 "glib-2.0.vapi"
	return result;
#line 269 "gitg-date.c"
}

static GTimeZone*
vala_g_time_zone_new_identifier (const gchar* identifier,
                                 GError** error)
{
	GTimeZone* self;
	GError* _inner_error0_ = NULL;
#line 3432 "glib-2.0.vapi"
	self = (GTimeZone*) g_time_zone_new_identifier (identifier);
#line 3433 "glib-2.0.vapi"
	if (((GTimeZone*) self) == NULL) {
#line 282 "gitg-date.c"
		GError* _tmp0_;
#line 3434 "glib-2.0.vapi"
		_tmp0_ = g_error_new_literal (G_CONVERT_ERROR, G_CONVERT_ERROR_ILLEGAL_SEQUENCE, "Invalid identifier argument");
#line 3434 "glib-2.0.vapi"
		_inner_error0_ = _tmp0_;
#line 3434 "glib-2.0.vapi"
		g_propagate_error (error, _inner_error0_);
#line 3434 "glib-2.0.vapi"
		_g_time_zone_unref0 (self);
#line 3434 "glib-2.0.vapi"
		return NULL;
#line 294 "gitg-date.c"
	}
#line 3431 "glib-2.0.vapi"
	return self;
#line 298 "gitg-date.c"
}

static GDateTime*
gitg_date_parse_internal (GMatchInfo* info,
                          GError** error)
{
	gchar* timestamp = NULL;
	gchar* _tmp0_;
	gint64 unixt = 0LL;
	const gchar* _tmp1_;
	gchar* tzs = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	GDateTime* result;
#line 165 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 167 "../libgitg/gitg-date.vala"
	_tmp0_ = g_match_info_fetch_named (info, "timestamp");
#line 167 "../libgitg/gitg-date.vala"
	timestamp = _tmp0_;
#line 168 "../libgitg/gitg-date.vala"
	_tmp1_ = timestamp;
#line 168 "../libgitg/gitg-date.vala"
	unixt = int64_parse (_tmp1_, (guint) 0);
#line 170 "../libgitg/gitg-date.vala"
	_tmp2_ = g_match_info_fetch_named (info, "tz");
#line 170 "../libgitg/gitg-date.vala"
	tzs = _tmp2_;
#line 172 "../libgitg/gitg-date.vala"
	_tmp4_ = tzs;
#line 172 "../libgitg/gitg-date.vala"
	if (_tmp4_ != NULL) {
#line 333 "gitg-date.c"
		const gchar* _tmp5_;
#line 172 "../libgitg/gitg-date.vala"
		_tmp5_ = tzs;
#line 172 "../libgitg/gitg-date.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "") != 0;
#line 339 "gitg-date.c"
	} else {
#line 172 "../libgitg/gitg-date.vala"
		_tmp3_ = FALSE;
#line 343 "gitg-date.c"
	}
#line 172 "../libgitg/gitg-date.vala"
	if (_tmp3_) {
#line 347 "gitg-date.c"
		GDateTime* ret = NULL;
		GDateTime* _tmp6_;
		GTimeZone* _tmp7_ = NULL;
		const gchar* _tmp8_;
		GTimeZone* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
#line 174 "../libgitg/gitg-date.vala"
		_tmp6_ = g_date_time_new_from_unix_utc (unixt);
#line 174 "../libgitg/gitg-date.vala"
		ret = _tmp6_;
#line 175 "../libgitg/gitg-date.vala"
		_tmp8_ = tzs;
#line 175 "../libgitg/gitg-date.vala"
		_tmp9_ = vala_g_time_zone_new_identifier (_tmp8_, &_inner_error0_);
#line 175 "../libgitg/gitg-date.vala"
		_tmp7_ = _tmp9_;
#line 175 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 175 "../libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error0_);
#line 175 "../libgitg/gitg-date.vala"
			_g_date_time_unref0 (ret);
#line 175 "../libgitg/gitg-date.vala"
			_g_free0 (tzs);
#line 175 "../libgitg/gitg-date.vala"
			_g_free0 (timestamp);
#line 175 "../libgitg/gitg-date.vala"
			return NULL;
#line 377 "gitg-date.c"
		}
#line 175 "../libgitg/gitg-date.vala"
		_tmp10_ = ret;
#line 175 "../libgitg/gitg-date.vala"
		_tmp11_ = g_date_time_to_timezone (_tmp10_, _tmp7_);
#line 175 "../libgitg/gitg-date.vala"
		result = _tmp11_;
#line 175 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (_tmp7_);
#line 175 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (ret);
#line 175 "../libgitg/gitg-date.vala"
		_g_free0 (tzs);
#line 175 "../libgitg/gitg-date.vala"
		_g_free0 (timestamp);
#line 175 "../libgitg/gitg-date.vala"
		return result;
#line 395 "gitg-date.c"
	} else {
		GDateTime* _tmp12_;
#line 179 "../libgitg/gitg-date.vala"
		_tmp12_ = g_date_time_new_from_unix_local (unixt);
#line 179 "../libgitg/gitg-date.vala"
		result = _tmp12_;
#line 179 "../libgitg/gitg-date.vala"
		_g_free0 (tzs);
#line 179 "../libgitg/gitg-date.vala"
		_g_free0 (timestamp);
#line 179 "../libgitg/gitg-date.vala"
		return result;
#line 408 "gitg-date.c"
	}
}

static GDateTime*
gitg_date_parse_iso8601 (GMatchInfo* info,
                         GError** error)
{
	GTimeZone* tz = NULL;
	GTimeZone* _tmp0_;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gdouble seconds = 0.0;
	gchar* tzs = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GTimeZone* _tmp10_;
	GDateTime* _tmp11_;
	GError* _inner_error0_ = NULL;
	GDateTime* result;
#line 183 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 185 "../libgitg/gitg-date.vala"
	_tmp0_ = g_time_zone_new_utc ();
#line 185 "../libgitg/gitg-date.vala"
	tz = _tmp0_;
#line 187 "../libgitg/gitg-date.vala"
	year = 0;
#line 188 "../libgitg/gitg-date.vala"
	month = 1;
#line 189 "../libgitg/gitg-date.vala"
	day = 1;
#line 190 "../libgitg/gitg-date.vala"
	hour = 0;
#line 191 "../libgitg/gitg-date.vala"
	minute = 0;
#line 192 "../libgitg/gitg-date.vala"
	seconds = 0.0;
#line 194 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "year", &year);
#line 195 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "month", &month);
#line 196 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "day", &day);
#line 197 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "hour", &hour);
#line 198 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "minute", &minute);
#line 199 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_double (info, "seconds", &seconds);
#line 201 "../libgitg/gitg-date.vala"
	_tmp1_ = g_match_info_fetch_named (info, "tz");
#line 201 "../libgitg/gitg-date.vala"
	tzs = _tmp1_;
#line 203 "../libgitg/gitg-date.vala"
	_tmp3_ = tzs;
#line 203 "../libgitg/gitg-date.vala"
	if (_tmp3_ != NULL) {
#line 470 "gitg-date.c"
		const gchar* _tmp4_;
#line 203 "../libgitg/gitg-date.vala"
		_tmp4_ = tzs;
#line 203 "../libgitg/gitg-date.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 476 "gitg-date.c"
	} else {
#line 203 "../libgitg/gitg-date.vala"
		_tmp2_ = FALSE;
#line 480 "gitg-date.c"
	}
#line 203 "../libgitg/gitg-date.vala"
	if (_tmp2_) {
#line 484 "gitg-date.c"
		GTimeZone* _tmp5_ = NULL;
		const gchar* _tmp6_;
		GTimeZone* _tmp7_;
		GTimeZone* _tmp8_;
#line 205 "../libgitg/gitg-date.vala"
		_tmp6_ = tzs;
#line 205 "../libgitg/gitg-date.vala"
		_tmp7_ = vala_g_time_zone_new_identifier (_tmp6_, &_inner_error0_);
#line 205 "../libgitg/gitg-date.vala"
		_tmp5_ = _tmp7_;
#line 205 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "../libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error0_);
#line 205 "../libgitg/gitg-date.vala"
			_g_free0 (tzs);
#line 205 "../libgitg/gitg-date.vala"
			_g_time_zone_unref0 (tz);
#line 205 "../libgitg/gitg-date.vala"
			return NULL;
#line 505 "gitg-date.c"
		}
#line 205 "../libgitg/gitg-date.vala"
		_tmp8_ = _tmp5_;
#line 205 "../libgitg/gitg-date.vala"
		_tmp5_ = NULL;
#line 205 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 205 "../libgitg/gitg-date.vala"
		tz = _tmp8_;
#line 203 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (_tmp5_);
#line 517 "gitg-date.c"
	} else {
		GTimeZone* _tmp9_;
#line 209 "../libgitg/gitg-date.vala"
		_tmp9_ = g_time_zone_new_local ();
#line 209 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 209 "../libgitg/gitg-date.vala"
		tz = _tmp9_;
#line 526 "gitg-date.c"
	}
#line 212 "../libgitg/gitg-date.vala"
	_tmp10_ = tz;
#line 212 "../libgitg/gitg-date.vala"
	_tmp11_ = g_date_time_new (_tmp10_, year, month, day, hour, minute, seconds);
#line 212 "../libgitg/gitg-date.vala"
	result = _tmp11_;
#line 212 "../libgitg/gitg-date.vala"
	_g_free0 (tzs);
#line 212 "../libgitg/gitg-date.vala"
	_g_time_zone_unref0 (tz);
#line 212 "../libgitg/gitg-date.vala"
	return result;
#line 540 "gitg-date.c"
}

static GDateTime*
gitg_date_parse_rfc2822 (GMatchInfo* info,
                         GError** error)
{
	GTimeZone* tz = NULL;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gdouble seconds = 0.0;
	gchar* monthstr = NULL;
	gchar* _tmp0_;
	gchar* tzs = NULL;
	gchar* _tmp11_;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp13_;
	GTimeZone* _tmp20_;
	GDateTime* _tmp21_;
	GError* _inner_error0_ = NULL;
	GDateTime* result;
#line 215 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 218 "../libgitg/gitg-date.vala"
	year = 0;
#line 219 "../libgitg/gitg-date.vala"
	month = 0;
#line 220 "../libgitg/gitg-date.vala"
	day = 1;
#line 221 "../libgitg/gitg-date.vala"
	hour = 0;
#line 222 "../libgitg/gitg-date.vala"
	minute = 0;
#line 223 "../libgitg/gitg-date.vala"
	seconds = (gdouble) 0;
#line 225 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "year", &year);
#line 227 "../libgitg/gitg-date.vala"
	_tmp0_ = g_match_info_fetch_named (info, "month");
#line 227 "../libgitg/gitg-date.vala"
	monthstr = _tmp0_;
#line 584 "gitg-date.c"
	{
		gint i = 0;
#line 229 "../libgitg/gitg-date.vala"
		i = 0;
#line 589 "gitg-date.c"
		{
			gboolean _tmp1_ = FALSE;
#line 229 "../libgitg/gitg-date.vala"
			_tmp1_ = TRUE;
#line 229 "../libgitg/gitg-date.vala"
			while (TRUE) {
#line 596 "gitg-date.c"
				gchar** _tmp3_;
				gint _tmp3__length1;
				gboolean _tmp4_ = FALSE;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
#line 229 "../libgitg/gitg-date.vala"
				if (!_tmp1_) {
#line 605 "gitg-date.c"
					gint _tmp2_;
#line 229 "../libgitg/gitg-date.vala"
					i = i + 1;
#line 229 "../libgitg/gitg-date.vala"
					_tmp2_ = i;
#line 611 "gitg-date.c"
				}
#line 229 "../libgitg/gitg-date.vala"
				_tmp1_ = FALSE;
#line 229 "../libgitg/gitg-date.vala"
				_tmp3_ = gitg_date_s_months;
#line 229 "../libgitg/gitg-date.vala"
				_tmp3__length1 = gitg_date_s_months_length1;
#line 229 "../libgitg/gitg-date.vala"
				if (!(i < _tmp3__length1)) {
#line 229 "../libgitg/gitg-date.vala"
					break;
#line 623 "gitg-date.c"
				}
#line 231 "../libgitg/gitg-date.vala"
				_tmp5_ = gitg_date_s_months;
#line 231 "../libgitg/gitg-date.vala"
				_tmp5__length1 = gitg_date_s_months_length1;
#line 231 "../libgitg/gitg-date.vala"
				_tmp6_ = _tmp5_[i];
#line 231 "../libgitg/gitg-date.vala"
				if (_tmp6_ != NULL) {
#line 633 "gitg-date.c"
					gchar** _tmp7_;
					gint _tmp7__length1;
					const gchar* _tmp8_;
					const gchar* _tmp9_;
#line 231 "../libgitg/gitg-date.vala"
					_tmp7_ = gitg_date_s_months;
#line 231 "../libgitg/gitg-date.vala"
					_tmp7__length1 = gitg_date_s_months_length1;
#line 231 "../libgitg/gitg-date.vala"
					_tmp8_ = _tmp7_[i];
#line 231 "../libgitg/gitg-date.vala"
					_tmp9_ = monthstr;
#line 231 "../libgitg/gitg-date.vala"
					_tmp4_ = g_strcmp0 (_tmp8_, _tmp9_) == 0;
#line 648 "gitg-date.c"
				} else {
#line 231 "../libgitg/gitg-date.vala"
					_tmp4_ = FALSE;
#line 652 "gitg-date.c"
				}
#line 231 "../libgitg/gitg-date.vala"
				if (_tmp4_) {
#line 233 "../libgitg/gitg-date.vala"
					month = i;
#line 234 "../libgitg/gitg-date.vala"
					break;
#line 660 "gitg-date.c"
				}
			}
		}
	}
#line 238 "../libgitg/gitg-date.vala"
	if (month == 0) {
#line 667 "gitg-date.c"
		GError* _tmp10_;
#line 240 "../libgitg/gitg-date.vala"
		_tmp10_ = g_error_new_literal (GITG_DATE_ERROR, GITG_DATE_ERROR_INVALID_FORMAT, "Invalid month specified");
#line 240 "../libgitg/gitg-date.vala"
		_inner_error0_ = _tmp10_;
#line 240 "../libgitg/gitg-date.vala"
		g_propagate_error (error, _inner_error0_);
#line 240 "../libgitg/gitg-date.vala"
		_g_free0 (monthstr);
#line 240 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 240 "../libgitg/gitg-date.vala"
		return NULL;
#line 681 "gitg-date.c"
	}
#line 243 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "day", &day);
#line 244 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "hour", &hour);
#line 245 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_int (info, "minute", &minute);
#line 246 "../libgitg/gitg-date.vala"
	gitg_date_fetch_and_set_double (info, "seconds", &seconds);
#line 248 "../libgitg/gitg-date.vala"
	_tmp11_ = g_match_info_fetch_named (info, "tz");
#line 248 "../libgitg/gitg-date.vala"
	tzs = _tmp11_;
#line 250 "../libgitg/gitg-date.vala"
	_tmp13_ = tzs;
#line 250 "../libgitg/gitg-date.vala"
	if (_tmp13_ != NULL) {
#line 699 "gitg-date.c"
		const gchar* _tmp14_;
#line 250 "../libgitg/gitg-date.vala"
		_tmp14_ = tzs;
#line 250 "../libgitg/gitg-date.vala"
		_tmp12_ = g_strcmp0 (_tmp14_, "") != 0;
#line 705 "gitg-date.c"
	} else {
#line 250 "../libgitg/gitg-date.vala"
		_tmp12_ = FALSE;
#line 709 "gitg-date.c"
	}
#line 250 "../libgitg/gitg-date.vala"
	if (_tmp12_) {
#line 713 "gitg-date.c"
		GTimeZone* _tmp15_ = NULL;
		const gchar* _tmp16_;
		GTimeZone* _tmp17_;
		GTimeZone* _tmp18_;
#line 252 "../libgitg/gitg-date.vala"
		_tmp16_ = tzs;
#line 252 "../libgitg/gitg-date.vala"
		_tmp17_ = vala_g_time_zone_new_identifier (_tmp16_, &_inner_error0_);
#line 252 "../libgitg/gitg-date.vala"
		_tmp15_ = _tmp17_;
#line 252 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 252 "../libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error0_);
#line 252 "../libgitg/gitg-date.vala"
			_g_free0 (tzs);
#line 252 "../libgitg/gitg-date.vala"
			_g_free0 (monthstr);
#line 252 "../libgitg/gitg-date.vala"
			_g_time_zone_unref0 (tz);
#line 252 "../libgitg/gitg-date.vala"
			return NULL;
#line 736 "gitg-date.c"
		}
#line 252 "../libgitg/gitg-date.vala"
		_tmp18_ = _tmp15_;
#line 252 "../libgitg/gitg-date.vala"
		_tmp15_ = NULL;
#line 252 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 252 "../libgitg/gitg-date.vala"
		tz = _tmp18_;
#line 250 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (_tmp15_);
#line 748 "gitg-date.c"
	} else {
		GTimeZone* _tmp19_;
#line 256 "../libgitg/gitg-date.vala"
		_tmp19_ = g_time_zone_new_local ();
#line 256 "../libgitg/gitg-date.vala"
		_g_time_zone_unref0 (tz);
#line 256 "../libgitg/gitg-date.vala"
		tz = _tmp19_;
#line 757 "gitg-date.c"
	}
#line 259 "../libgitg/gitg-date.vala"
	_tmp20_ = tz;
#line 259 "../libgitg/gitg-date.vala"
	_tmp21_ = g_date_time_new (_tmp20_, year, month, day, hour, minute, seconds);
#line 259 "../libgitg/gitg-date.vala"
	result = _tmp21_;
#line 259 "../libgitg/gitg-date.vala"
	_g_free0 (tzs);
#line 259 "../libgitg/gitg-date.vala"
	_g_free0 (monthstr);
#line 259 "../libgitg/gitg-date.vala"
	_g_time_zone_unref0 (tz);
#line 259 "../libgitg/gitg-date.vala"
	return result;
#line 773 "gitg-date.c"
}

static gboolean
gitg_date_real_init (GInitable* base,
                     GCancellable* cancellable,
                     GError** error)
{
	GitgDate * self;
	GMatchInfo* info = NULL;
	GRegex* _tmp0_;
	const gchar* _tmp1_;
	GMatchInfo* _tmp2_ = NULL;
	gboolean _tmp3_;
	GRegex* _tmp9_;
	const gchar* _tmp10_;
	GMatchInfo* _tmp11_ = NULL;
	gboolean _tmp12_;
	GRegex* _tmp18_;
	const gchar* _tmp19_;
	GMatchInfo* _tmp20_ = NULL;
	gboolean _tmp21_;
	GError* _tmp27_;
	gboolean _tmp28_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 274 "../libgitg/gitg-date.vala"
	self = (GitgDate*) base;
#line 278 "../libgitg/gitg-date.vala"
	_tmp0_ = gitg_date_s_internal;
#line 278 "../libgitg/gitg-date.vala"
	_tmp1_ = self->priv->_date_string;
#line 278 "../libgitg/gitg-date.vala"
	_tmp3_ = g_regex_match (_tmp0_, _tmp1_, 0, &_tmp2_);
#line 278 "../libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 278 "../libgitg/gitg-date.vala"
	info = _tmp2_;
#line 278 "../libgitg/gitg-date.vala"
	if (_tmp3_) {
#line 813 "gitg-date.c"
		GDateTime* _tmp4_ = NULL;
		GMatchInfo* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp8_;
#line 280 "../libgitg/gitg-date.vala"
		_tmp5_ = info;
#line 280 "../libgitg/gitg-date.vala"
		_tmp6_ = gitg_date_parse_internal (_tmp5_, &_inner_error0_);
#line 280 "../libgitg/gitg-date.vala"
		_tmp4_ = _tmp6_;
#line 280 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 826 "gitg-date.c"
			gboolean _tmp7_ = FALSE;
#line 280 "../libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error0_);
#line 280 "../libgitg/gitg-date.vala"
			_g_match_info_unref0 (info);
#line 280 "../libgitg/gitg-date.vala"
			return _tmp7_;
#line 834 "gitg-date.c"
		}
#line 280 "../libgitg/gitg-date.vala"
		_tmp8_ = _tmp4_;
#line 280 "../libgitg/gitg-date.vala"
		_tmp4_ = NULL;
#line 280 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (self->priv->d_datetime);
#line 280 "../libgitg/gitg-date.vala"
		self->priv->d_datetime = _tmp8_;
#line 282 "../libgitg/gitg-date.vala"
		result = TRUE;
#line 282 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (_tmp4_);
#line 282 "../libgitg/gitg-date.vala"
		_g_match_info_unref0 (info);
#line 282 "../libgitg/gitg-date.vala"
		return result;
#line 852 "gitg-date.c"
	}
#line 285 "../libgitg/gitg-date.vala"
	_tmp9_ = gitg_date_s_iso8601;
#line 285 "../libgitg/gitg-date.vala"
	_tmp10_ = self->priv->_date_string;
#line 285 "../libgitg/gitg-date.vala"
	_tmp12_ = g_regex_match (_tmp9_, _tmp10_, 0, &_tmp11_);
#line 285 "../libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 285 "../libgitg/gitg-date.vala"
	info = _tmp11_;
#line 285 "../libgitg/gitg-date.vala"
	if (_tmp12_) {
#line 866 "gitg-date.c"
		GDateTime* _tmp13_ = NULL;
		GMatchInfo* _tmp14_;
		GDateTime* _tmp15_;
		GDateTime* _tmp17_;
#line 287 "../libgitg/gitg-date.vala"
		_tmp14_ = info;
#line 287 "../libgitg/gitg-date.vala"
		_tmp15_ = gitg_date_parse_iso8601 (_tmp14_, &_inner_error0_);
#line 287 "../libgitg/gitg-date.vala"
		_tmp13_ = _tmp15_;
#line 287 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 879 "gitg-date.c"
			gboolean _tmp16_ = FALSE;
#line 287 "../libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error0_);
#line 287 "../libgitg/gitg-date.vala"
			_g_match_info_unref0 (info);
#line 287 "../libgitg/gitg-date.vala"
			return _tmp16_;
#line 887 "gitg-date.c"
		}
#line 287 "../libgitg/gitg-date.vala"
		_tmp17_ = _tmp13_;
#line 287 "../libgitg/gitg-date.vala"
		_tmp13_ = NULL;
#line 287 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (self->priv->d_datetime);
#line 287 "../libgitg/gitg-date.vala"
		self->priv->d_datetime = _tmp17_;
#line 289 "../libgitg/gitg-date.vala"
		result = TRUE;
#line 289 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (_tmp13_);
#line 289 "../libgitg/gitg-date.vala"
		_g_match_info_unref0 (info);
#line 289 "../libgitg/gitg-date.vala"
		return result;
#line 905 "gitg-date.c"
	}
#line 292 "../libgitg/gitg-date.vala"
	_tmp18_ = gitg_date_s_rfc2822;
#line 292 "../libgitg/gitg-date.vala"
	_tmp19_ = self->priv->_date_string;
#line 292 "../libgitg/gitg-date.vala"
	_tmp21_ = g_regex_match (_tmp18_, _tmp19_, 0, &_tmp20_);
#line 292 "../libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 292 "../libgitg/gitg-date.vala"
	info = _tmp20_;
#line 292 "../libgitg/gitg-date.vala"
	if (_tmp21_) {
#line 919 "gitg-date.c"
		GDateTime* _tmp22_ = NULL;
		GMatchInfo* _tmp23_;
		GDateTime* _tmp24_;
		GDateTime* _tmp26_;
#line 294 "../libgitg/gitg-date.vala"
		_tmp23_ = info;
#line 294 "../libgitg/gitg-date.vala"
		_tmp24_ = gitg_date_parse_rfc2822 (_tmp23_, &_inner_error0_);
#line 294 "../libgitg/gitg-date.vala"
		_tmp22_ = _tmp24_;
#line 294 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 932 "gitg-date.c"
			gboolean _tmp25_ = FALSE;
#line 294 "../libgitg/gitg-date.vala"
			g_propagate_error (error, _inner_error0_);
#line 294 "../libgitg/gitg-date.vala"
			_g_match_info_unref0 (info);
#line 294 "../libgitg/gitg-date.vala"
			return _tmp25_;
#line 940 "gitg-date.c"
		}
#line 294 "../libgitg/gitg-date.vala"
		_tmp26_ = _tmp22_;
#line 294 "../libgitg/gitg-date.vala"
		_tmp22_ = NULL;
#line 294 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (self->priv->d_datetime);
#line 294 "../libgitg/gitg-date.vala"
		self->priv->d_datetime = _tmp26_;
#line 296 "../libgitg/gitg-date.vala"
		result = TRUE;
#line 296 "../libgitg/gitg-date.vala"
		_g_date_time_unref0 (_tmp22_);
#line 296 "../libgitg/gitg-date.vala"
		_g_match_info_unref0 (info);
#line 296 "../libgitg/gitg-date.vala"
		return result;
#line 958 "gitg-date.c"
	}
#line 299 "../libgitg/gitg-date.vala"
	_tmp27_ = g_error_new_literal (GITG_DATE_ERROR, GITG_DATE_ERROR_INVALID_FORMAT, "Invalid date format");
#line 299 "../libgitg/gitg-date.vala"
	_inner_error0_ = _tmp27_;
#line 299 "../libgitg/gitg-date.vala"
	g_propagate_error (error, _inner_error0_);
#line 299 "../libgitg/gitg-date.vala"
	_g_match_info_unref0 (info);
#line 299 "../libgitg/gitg-date.vala"
	return _tmp28_;
#line 970 "gitg-date.c"
}

GitgDate*
gitg_date_construct (GType object_type,
                     const gchar* date,
                     GError** error)
{
	GitgDate * self = NULL;
	GError* _inner_error0_ = NULL;
#line 302 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 304 "../libgitg/gitg-date.vala"
	self = (GitgDate*) g_object_new (object_type, "date-string", date, NULL);
#line 305 "../libgitg/gitg-date.vala"
	g_initable_init (G_TYPE_CHECK_INSTANCE_CAST (self, g_initable_get_type (), GInitable), NULL, &_inner_error0_);
#line 305 "../libgitg/gitg-date.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 305 "../libgitg/gitg-date.vala"
		g_propagate_error (error, _inner_error0_);
#line 305 "../libgitg/gitg-date.vala"
		_g_object_unref0 (self);
#line 305 "../libgitg/gitg-date.vala"
		return NULL;
#line 994 "gitg-date.c"
	}
#line 302 "../libgitg/gitg-date.vala"
	return self;
#line 998 "gitg-date.c"
}

GitgDate*
gitg_date_new (const gchar* date,
               GError** error)
{
#line 302 "../libgitg/gitg-date.vala"
	return gitg_date_construct (GITG_TYPE_DATE, date, error);
#line 1007 "gitg-date.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 337 "../libgitg/gitg-date.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 1015 "gitg-date.c"
}

gchar*
gitg_date_for_display (GitgDate* self)
{
	GDateTime* dt = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GTimeSpan t = 0LL;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GTimeSpan _tmp5_;
	gchar* result;
#line 335 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "../libgitg/gitg-date.vala"
	_tmp0_ = self->priv->d_datetime;
#line 337 "../libgitg/gitg-date.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 337 "../libgitg/gitg-date.vala"
	dt = _tmp1_;
#line 338 "../libgitg/gitg-date.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 338 "../libgitg/gitg-date.vala"
	_tmp3_ = _tmp2_;
#line 338 "../libgitg/gitg-date.vala"
	_tmp4_ = dt;
#line 338 "../libgitg/gitg-date.vala"
	_tmp5_ = g_date_time_difference (_tmp3_, _tmp4_);
#line 338 "../libgitg/gitg-date.vala"
	_g_date_time_unref0 (_tmp3_);
#line 338 "../libgitg/gitg-date.vala"
	t = _tmp5_;
#line 340 "../libgitg/gitg-date.vala"
	if (((gdouble) t) < (G_TIME_SPAN_MINUTE * 29.5)) {
#line 1052 "gitg-date.c"
		gint rounded_minutes = 0;
#line 342 "../libgitg/gitg-date.vala"
		rounded_minutes = (gint) round ((gdouble) (((gfloat) t) / G_TIME_SPAN_MINUTE));
#line 344 "../libgitg/gitg-date.vala"
		if (rounded_minutes == 0) {
#line 1058 "gitg-date.c"
			gchar* _tmp6_;
#line 346 "../libgitg/gitg-date.vala"
			_tmp6_ = g_strdup (_ ("Now"));
#line 346 "../libgitg/gitg-date.vala"
			result = _tmp6_;
#line 346 "../libgitg/gitg-date.vala"
			_g_date_time_unref0 (dt);
#line 346 "../libgitg/gitg-date.vala"
			return result;
#line 1068 "gitg-date.c"
		} else {
			gchar* _tmp7_;
#line 350 "../libgitg/gitg-date.vala"
			_tmp7_ = g_strdup_printf (ngettext ("A minute ago", "%d minutes ago", (gulong) rounded_minutes), rounded_minutes);
#line 350 "../libgitg/gitg-date.vala"
			result = _tmp7_;
#line 350 "../libgitg/gitg-date.vala"
			_g_date_time_unref0 (dt);
#line 350 "../libgitg/gitg-date.vala"
			return result;
#line 1079 "gitg-date.c"
		}
	} else {
#line 353 "../libgitg/gitg-date.vala"
		if (t < (G_TIME_SPAN_MINUTE * 45)) {
#line 1084 "gitg-date.c"
			gchar* _tmp8_;
#line 355 "../libgitg/gitg-date.vala"
			_tmp8_ = g_strdup (_ ("Half an hour ago"));
#line 355 "../libgitg/gitg-date.vala"
			result = _tmp8_;
#line 355 "../libgitg/gitg-date.vala"
			_g_date_time_unref0 (dt);
#line 355 "../libgitg/gitg-date.vala"
			return result;
#line 1094 "gitg-date.c"
		} else {
#line 357 "../libgitg/gitg-date.vala"
			if (((gdouble) t) < (G_TIME_SPAN_HOUR * 23.5)) {
#line 1098 "gitg-date.c"
				gint rounded_hours = 0;
				gchar* _tmp9_;
#line 359 "../libgitg/gitg-date.vala"
				rounded_hours = (gint) round ((gdouble) (((gfloat) t) / G_TIME_SPAN_HOUR));
#line 360 "../libgitg/gitg-date.vala"
				_tmp9_ = g_strdup_printf (ngettext ("An hour ago", "%d hours ago", (gulong) rounded_hours), rounded_hours);
#line 360 "../libgitg/gitg-date.vala"
				result = _tmp9_;
#line 360 "../libgitg/gitg-date.vala"
				_g_date_time_unref0 (dt);
#line 360 "../libgitg/gitg-date.vala"
				return result;
#line 1111 "gitg-date.c"
			} else {
#line 362 "../libgitg/gitg-date.vala"
				if (t < (G_TIME_SPAN_DAY * 7)) {
#line 1115 "gitg-date.c"
					gint rounded_days = 0;
					gchar* _tmp10_;
#line 364 "../libgitg/gitg-date.vala"
					rounded_days = (gint) round ((gdouble) (((gfloat) t) / G_TIME_SPAN_DAY));
#line 365 "../libgitg/gitg-date.vala"
					_tmp10_ = g_strdup_printf (ngettext ("A day ago", "%d days ago", (gulong) rounded_days), rounded_days);
#line 365 "../libgitg/gitg-date.vala"
					result = _tmp10_;
#line 365 "../libgitg/gitg-date.vala"
					_g_date_time_unref0 (dt);
#line 365 "../libgitg/gitg-date.vala"
					return result;
#line 1128 "gitg-date.c"
				} else {
					GDateTime* _tmp11_;
					GDateTime* _tmp12_;
					GDateTime* _tmp13_;
					gboolean _tmp14_;
#line 367 "../libgitg/gitg-date.vala"
					_tmp11_ = dt;
#line 367 "../libgitg/gitg-date.vala"
					_tmp12_ = g_date_time_new_now_local ();
#line 367 "../libgitg/gitg-date.vala"
					_tmp13_ = _tmp12_;
#line 367 "../libgitg/gitg-date.vala"
					_tmp14_ = g_date_time_get_year (_tmp11_) == g_date_time_get_year (_tmp13_);
#line 367 "../libgitg/gitg-date.vala"
					_g_date_time_unref0 (_tmp13_);
#line 367 "../libgitg/gitg-date.vala"
					if (_tmp14_) {
#line 1146 "gitg-date.c"
						gboolean _tmp15_;
						gboolean _tmp16_;
#line 369 "../libgitg/gitg-date.vala"
						_tmp15_ = gitg_date_get_is_24h (self);
#line 369 "../libgitg/gitg-date.vala"
						_tmp16_ = _tmp15_;
#line 369 "../libgitg/gitg-date.vala"
						if (_tmp16_) {
#line 1155 "gitg-date.c"
							GDateTime* _tmp17_;
							gchar* _tmp18_;
#line 374 "../libgitg/gitg-date.vala"
							_tmp17_ = dt;
#line 374 "../libgitg/gitg-date.vala"
							_tmp18_ = g_date_time_format (_tmp17_, _ ("%b %e, %H∶%M"));
#line 374 "../libgitg/gitg-date.vala"
							result = _tmp18_;
#line 374 "../libgitg/gitg-date.vala"
							_g_date_time_unref0 (dt);
#line 374 "../libgitg/gitg-date.vala"
							return result;
#line 1168 "gitg-date.c"
						} else {
							GDateTime* _tmp19_;
							gchar* _tmp20_;
#line 381 "../libgitg/gitg-date.vala"
							_tmp19_ = dt;
#line 381 "../libgitg/gitg-date.vala"
							_tmp20_ = g_date_time_format (_tmp19_, _ ("%b %e, %I∶%M %p"));
#line 381 "../libgitg/gitg-date.vala"
							result = _tmp20_;
#line 381 "../libgitg/gitg-date.vala"
							_g_date_time_unref0 (dt);
#line 381 "../libgitg/gitg-date.vala"
							return result;
#line 1182 "gitg-date.c"
						}
					} else {
						gboolean _tmp21_;
						gboolean _tmp22_;
#line 386 "../libgitg/gitg-date.vala"
						_tmp21_ = gitg_date_get_is_24h (self);
#line 386 "../libgitg/gitg-date.vala"
						_tmp22_ = _tmp21_;
#line 386 "../libgitg/gitg-date.vala"
						if (_tmp22_) {
#line 1193 "gitg-date.c"
							GDateTime* _tmp23_;
							gchar* _tmp24_;
#line 391 "../libgitg/gitg-date.vala"
							_tmp23_ = dt;
#line 391 "../libgitg/gitg-date.vala"
							_tmp24_ = g_date_time_format (_tmp23_, _ ("%b %e %Y, %H∶%M"));
#line 391 "../libgitg/gitg-date.vala"
							result = _tmp24_;
#line 391 "../libgitg/gitg-date.vala"
							_g_date_time_unref0 (dt);
#line 391 "../libgitg/gitg-date.vala"
							return result;
#line 1206 "gitg-date.c"
						} else {
							GDateTime* _tmp25_;
							gchar* _tmp26_;
#line 398 "../libgitg/gitg-date.vala"
							_tmp25_ = dt;
#line 398 "../libgitg/gitg-date.vala"
							_tmp26_ = g_date_time_format (_tmp25_, _ ("%b %e %Y, %I∶%M %p"));
#line 398 "../libgitg/gitg-date.vala"
							result = _tmp26_;
#line 398 "../libgitg/gitg-date.vala"
							_g_date_time_unref0 (dt);
#line 398 "../libgitg/gitg-date.vala"
							return result;
#line 1220 "gitg-date.c"
						}
					}
				}
			}
		}
	}
}

GitgDate*
gitg_date_construct_for_date_time (GType object_type,
                                   GDateTime* dt)
{
	GitgDate * self = NULL;
	GDateTime* _tmp0_;
#line 403 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (dt != NULL, NULL);
#line 403 "../libgitg/gitg-date.vala"
	self = (GitgDate*) g_object_new (object_type, NULL);
#line 405 "../libgitg/gitg-date.vala"
	_tmp0_ = _g_date_time_ref0 (dt);
#line 405 "../libgitg/gitg-date.vala"
	_g_date_time_unref0 (self->priv->d_datetime);
#line 405 "../libgitg/gitg-date.vala"
	self->priv->d_datetime = _tmp0_;
#line 403 "../libgitg/gitg-date.vala"
	return self;
#line 1247 "gitg-date.c"
}

GitgDate*
gitg_date_new_for_date_time (GDateTime* dt)
{
#line 403 "../libgitg/gitg-date.vala"
	return gitg_date_construct_for_date_time (GITG_TYPE_DATE, dt);
#line 1255 "gitg-date.c"
}

GDateTime*
gitg_date_parse (const gchar* date,
                 GError** error)
{
	GitgDate* _tmp0_ = NULL;
	GitgDate* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GError* _inner_error0_ = NULL;
	GDateTime* result;
#line 408 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 410 "../libgitg/gitg-date.vala"
	_tmp1_ = gitg_date_new (date, &_inner_error0_);
#line 410 "../libgitg/gitg-date.vala"
	_tmp0_ = _tmp1_;
#line 410 "../libgitg/gitg-date.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 410 "../libgitg/gitg-date.vala"
		g_propagate_error (error, _inner_error0_);
#line 410 "../libgitg/gitg-date.vala"
		return NULL;
#line 1281 "gitg-date.c"
	}
#line 410 "../libgitg/gitg-date.vala"
	_tmp2_ = gitg_date_get_date (_tmp0_);
#line 410 "../libgitg/gitg-date.vala"
	_tmp3_ = _tmp2_;
#line 410 "../libgitg/gitg-date.vala"
	_tmp4_ = _g_date_time_ref0 (_tmp3_);
#line 410 "../libgitg/gitg-date.vala"
	result = _tmp4_;
#line 410 "../libgitg/gitg-date.vala"
	_g_object_unref0 (_tmp0_);
#line 410 "../libgitg/gitg-date.vala"
	return result;
#line 1295 "gitg-date.c"
}

const gchar*
gitg_date_get_date_string (GitgDate* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 266 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 266 "../libgitg/gitg-date.vala"
	_tmp0_ = self->priv->_date_string;
#line 266 "../libgitg/gitg-date.vala"
	result = _tmp0_;
#line 266 "../libgitg/gitg-date.vala"
	return result;
#line 1311 "gitg-date.c"
}

void
gitg_date_set_date_string (GitgDate* self,
                           const gchar* value)
{
	gchar* old_value;
#line 266 "../libgitg/gitg-date.vala"
	g_return_if_fail (self != NULL);
#line 266 "../libgitg/gitg-date.vala"
	old_value = gitg_date_get_date_string (self);
#line 266 "../libgitg/gitg-date.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1325 "gitg-date.c"
		gchar* _tmp0_;
#line 266 "../libgitg/gitg-date.vala"
		_tmp0_ = g_strdup (value);
#line 266 "../libgitg/gitg-date.vala"
		_g_free0 (self->priv->_date_string);
#line 266 "../libgitg/gitg-date.vala"
		self->priv->_date_string = _tmp0_;
#line 266 "../libgitg/gitg-date.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_date_properties[GITG_DATE_DATE_STRING_PROPERTY]);
#line 1335 "gitg-date.c"
	}
}

GDateTime*
gitg_date_get_date (GitgDate* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 271 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 271 "../libgitg/gitg-date.vala"
	_tmp0_ = self->priv->d_datetime;
#line 271 "../libgitg/gitg-date.vala"
	result = _tmp0_;
#line 271 "../libgitg/gitg-date.vala"
	return result;
#line 1352 "gitg-date.c"
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
#line 314 "../libgitg/gitg-date.vala"
	return self ? g_settings_schema_source_ref (self) : NULL;
#line 1360 "gitg-date.c"
}

static gboolean
gitg_date_get_is_24h (GitgDate* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GSettings* _tmp1_;
	GSettings* _tmp13_;
	GSettings* _tmp14_;
#line 310 "../libgitg/gitg-date.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 312 "../libgitg/gitg-date.vala"
	_tmp1_ = gitg_date_s_gnome_interface_settings;
#line 312 "../libgitg/gitg-date.vala"
	if (_tmp1_ == NULL) {
#line 312 "../libgitg/gitg-date.vala"
		_tmp0_ = !gitg_date_s_tried_gnome_interface_settings;
#line 1379 "gitg-date.c"
	} else {
#line 312 "../libgitg/gitg-date.vala"
		_tmp0_ = FALSE;
#line 1383 "gitg-date.c"
	}
#line 312 "../libgitg/gitg-date.vala"
	if (_tmp0_) {
#line 1387 "gitg-date.c"
		GSettingsSchemaSource* source = NULL;
		GSettingsSchemaSource* _tmp2_;
		GSettingsSchemaSource* _tmp3_;
		gchar* schema_id = NULL;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		GSettingsSchemaSource* _tmp6_;
#line 314 "../libgitg/gitg-date.vala"
		_tmp2_ = g_settings_schema_source_get_default ();
#line 314 "../libgitg/gitg-date.vala"
		_tmp3_ = _g_settings_schema_source_ref0 (_tmp2_);
#line 314 "../libgitg/gitg-date.vala"
		source = _tmp3_;
#line 316 "../libgitg/gitg-date.vala"
		gitg_date_s_tried_gnome_interface_settings = TRUE;
#line 318 "../libgitg/gitg-date.vala"
		_tmp4_ = g_strdup ("org.gnome.desktop.interface");
#line 318 "../libgitg/gitg-date.vala"
		schema_id = _tmp4_;
#line 320 "../libgitg/gitg-date.vala"
		_tmp6_ = source;
#line 320 "../libgitg/gitg-date.vala"
		if (_tmp6_ != NULL) {
#line 1411 "gitg-date.c"
			GSettingsSchemaSource* _tmp7_;
			const gchar* _tmp8_;
			GSettingsSchema* _tmp9_;
			GSettingsSchema* _tmp10_;
#line 320 "../libgitg/gitg-date.vala"
			_tmp7_ = source;
#line 320 "../libgitg/gitg-date.vala"
			_tmp8_ = schema_id;
#line 320 "../libgitg/gitg-date.vala"
			_tmp9_ = g_settings_schema_source_lookup (_tmp7_, _tmp8_, TRUE);
#line 320 "../libgitg/gitg-date.vala"
			_tmp10_ = _tmp9_;
#line 320 "../libgitg/gitg-date.vala"
			_tmp5_ = _tmp10_ != NULL;
#line 320 "../libgitg/gitg-date.vala"
			_g_settings_schema_unref0 (_tmp10_);
#line 1428 "gitg-date.c"
		} else {
#line 320 "../libgitg/gitg-date.vala"
			_tmp5_ = FALSE;
#line 1432 "gitg-date.c"
		}
#line 320 "../libgitg/gitg-date.vala"
		if (_tmp5_) {
#line 1436 "gitg-date.c"
			const gchar* _tmp11_;
			GSettings* _tmp12_;
#line 322 "../libgitg/gitg-date.vala"
			_tmp11_ = schema_id;
#line 322 "../libgitg/gitg-date.vala"
			_tmp12_ = g_settings_new (_tmp11_);
#line 322 "../libgitg/gitg-date.vala"
			_g_object_unref0 (gitg_date_s_gnome_interface_settings);
#line 322 "../libgitg/gitg-date.vala"
			gitg_date_s_gnome_interface_settings = _tmp12_;
#line 1447 "gitg-date.c"
		}
#line 312 "../libgitg/gitg-date.vala"
		_g_free0 (schema_id);
#line 312 "../libgitg/gitg-date.vala"
		_g_settings_schema_source_unref0 (source);
#line 1453 "gitg-date.c"
	}
#line 326 "../libgitg/gitg-date.vala"
	_tmp13_ = gitg_date_s_gnome_interface_settings;
#line 326 "../libgitg/gitg-date.vala"
	if (_tmp13_ == NULL) {
#line 328 "../libgitg/gitg-date.vala"
		result = FALSE;
#line 328 "../libgitg/gitg-date.vala"
		return result;
#line 1463 "gitg-date.c"
	}
#line 331 "../libgitg/gitg-date.vala"
	_tmp14_ = gitg_date_s_gnome_interface_settings;
#line 331 "../libgitg/gitg-date.vala"
	result = g_settings_get_enum (_tmp14_, "clock-format") == ((gint) G_DESKTOP_CLOCK_FORMAT_24H);
#line 331 "../libgitg/gitg-date.vala"
	return result;
#line 1471 "gitg-date.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 1484 "gitg-date.c"
}

static void
gitg_date_class_init (GitgDateClass * klass,
                      gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	GError* _inner_error0_ = NULL;
#line 28 "../libgitg/gitg-date.vala"
	gitg_date_parent_class = g_type_class_peek_parent (klass);
#line 28 "../libgitg/gitg-date.vala"
	g_type_class_adjust_private_offset (klass, &GitgDate_private_offset);
#line 28 "../libgitg/gitg-date.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_date_get_property;
#line 28 "../libgitg/gitg-date.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_date_set_property;
#line 28 "../libgitg/gitg-date.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_date_finalize;
#line 28 "../libgitg/gitg-date.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DATE_DATE_STRING_PROPERTY, gitg_date_properties[GITG_DATE_DATE_STRING_PROPERTY] = g_param_spec_string ("date-string", "date-string", "date-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../libgitg/gitg-date.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DATE_DATE_PROPERTY, gitg_date_properties[GITG_DATE_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 37 "../libgitg/gitg-date.vala"
	_tmp0_ = g_strdup ("Jan");
#line 37 "../libgitg/gitg-date.vala"
	_tmp1_ = g_strdup ("Feb");
#line 37 "../libgitg/gitg-date.vala"
	_tmp2_ = g_strdup ("Mar");
#line 37 "../libgitg/gitg-date.vala"
	_tmp3_ = g_strdup ("Apr");
#line 37 "../libgitg/gitg-date.vala"
	_tmp4_ = g_strdup ("May");
#line 37 "../libgitg/gitg-date.vala"
	_tmp5_ = g_strdup ("Jun");
#line 37 "../libgitg/gitg-date.vala"
	_tmp6_ = g_strdup ("Jul");
#line 37 "../libgitg/gitg-date.vala"
	_tmp7_ = g_strdup ("Aug");
#line 37 "../libgitg/gitg-date.vala"
	_tmp8_ = g_strdup ("Sep");
#line 37 "../libgitg/gitg-date.vala"
	_tmp9_ = g_strdup ("Oct");
#line 37 "../libgitg/gitg-date.vala"
	_tmp10_ = g_strdup ("Nov");
#line 37 "../libgitg/gitg-date.vala"
	_tmp11_ = g_strdup ("Dec");
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_ = g_new0 (gchar*, 13 + 1);
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[0] = NULL;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[1] = _tmp0_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[2] = _tmp1_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[3] = _tmp2_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[4] = _tmp3_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[5] = _tmp4_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[6] = _tmp5_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[7] = _tmp6_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[8] = _tmp7_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[9] = _tmp8_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[10] = _tmp9_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[11] = _tmp10_;
#line 37 "../libgitg/gitg-date.vala"
	_tmp12_[12] = _tmp11_;
#line 37 "../libgitg/gitg-date.vala"
	gitg_date_s_months = _tmp12_;
#line 37 "../libgitg/gitg-date.vala"
	gitg_date_s_months_length1 = 13;
#line 37 "../libgitg/gitg-date.vala"
	_gitg_date_s_months_size_ = gitg_date_s_months_length1;
#line 1577 "gitg-date.c"
	{
		GRegex* _tmp13_ = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GRegex* _tmp16_;
		GRegex* _tmp17_;
		GRegex* _tmp18_;
		GRegex* _tmp19_ = NULL;
		gchar* _tmp20_;
		gchar* _tmp21_;
		GRegex* _tmp22_;
		GRegex* _tmp23_;
		GRegex* _tmp24_;
		GRegex* _tmp25_ = NULL;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GRegex* _tmp28_;
		GRegex* _tmp29_;
		GRegex* _tmp30_;
#line 58 "../libgitg/gitg-date.vala"
		_tmp14_ = g_strconcat ("^\n" \
"			(?<year>[0-9]{4})\n" \
"			(?:\n" \
"				[-.]?(?:\n" \
"					(?<month>[0-9]{2})\n" \
"					(?:\n" \
"						[-.]?(?<day>[0-9]{2})\n" \
"					)?\n" \
"				|\n" \
"					W(?<week>[0-9]{2})\n" \
"					(?:\n" \
"						[-.]?(?<weekday>[0-9])\n" \
"					)?\n" \
"				)\n" \
"				(?:\n" \
"					[T ](?<hour>[0-9]{2})\n" \
"					(?:\n" \
"						:?\n" \
"						(?<minute>[0-9]{2})\n" \
"						(?:\n" \
"							:?\n" \
"							(?<seconds>[0-9]{2})\n" \
"							(?<tz>\n" \
"								(?<tzutc>Z) |\n" \
"								[+-](?<tzhour>[0-9]{2})\n" \
"								(?:\n" \
"									:?\n" \
"									(?<tzminute>[0-9]{2})\n" \
"								)?\n" \
"							)?\n" \
"						)?\n" \
"					)?\n" \
"				)?\n" \
"			)?\n" \
"		", "$", NULL);
#line 58 "../libgitg/gitg-date.vala"
		_tmp15_ = _tmp14_;
#line 58 "../libgitg/gitg-date.vala"
		_tmp16_ = g_regex_new (_tmp15_, G_REGEX_EXTENDED, 0, &_inner_error0_);
#line 58 "../libgitg/gitg-date.vala"
		_tmp17_ = _tmp16_;
#line 58 "../libgitg/gitg-date.vala"
		_g_free0 (_tmp15_);
#line 58 "../libgitg/gitg-date.vala"
		_tmp13_ = _tmp17_;
#line 58 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1611 "gitg-date.c"
			goto __catch0_g_error;
		}
#line 58 "../libgitg/gitg-date.vala"
		_tmp18_ = _tmp13_;
#line 58 "../libgitg/gitg-date.vala"
		_tmp13_ = NULL;
#line 58 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (gitg_date_s_iso8601);
#line 58 "../libgitg/gitg-date.vala"
		gitg_date_s_iso8601 = _tmp18_;
#line 94 "../libgitg/gitg-date.vala"
		_tmp20_ = g_strconcat ("^\n" \
"			(?:\n" \
"				[\\s]*(?<dayofweek>Mon|Tue|Wed|Thu|Fri|Sat|Sun)\n" \
"				,\n" \
"			)?\n" \
"			[\\s]*(?<day>[0-9]{1,2})\n" \
"			[\\s]+\n" \
"				(?<month>Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\n" \
"			[\\s]+\n" \
"				(?<year>[0-9]{4})\n" \
"			[\\s]+\n" \
"				(?<hour>[0-9]{2})\n" \
"				:\n" \
"				(?<minute>[0-9]{2})\n" \
"				(?:\n" \
"					:\n" \
"					(?<seconds>[0-9]{2})\n" \
"				)?\n" \
"			[\\s]+\n" \
"			(?<tz>\n" \
"				[+-]\n" \
"				(?<tzhour>[0-9]{2})\n" \
"				(?<tzminute>[0-9]{2})\n" \
"			)\n" \
"		", "$", NULL);
#line 94 "../libgitg/gitg-date.vala"
		_tmp21_ = _tmp20_;
#line 94 "../libgitg/gitg-date.vala"
		_tmp22_ = g_regex_new (_tmp21_, G_REGEX_EXTENDED, 0, &_inner_error0_);
#line 94 "../libgitg/gitg-date.vala"
		_tmp23_ = _tmp22_;
#line 94 "../libgitg/gitg-date.vala"
		_g_free0 (_tmp21_);
#line 94 "../libgitg/gitg-date.vala"
		_tmp19_ = _tmp23_;
#line 94 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../libgitg/gitg-date.vala"
			_g_regex_unref0 (_tmp13_);
#line 1638 "gitg-date.c"
			goto __catch0_g_error;
		}
#line 94 "../libgitg/gitg-date.vala"
		_tmp24_ = _tmp19_;
#line 94 "../libgitg/gitg-date.vala"
		_tmp19_ = NULL;
#line 94 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (gitg_date_s_rfc2822);
#line 94 "../libgitg/gitg-date.vala"
		gitg_date_s_rfc2822 = _tmp24_;
#line 120 "../libgitg/gitg-date.vala"
		_tmp26_ = g_strconcat ("^\n" \
"			@?\n" \
"			(?<timestamp>[0-9]+)\n" \
"			[ ](?<tz>\n" \
"				[+-](?<tzhour>[0-9]{2})\n" \
"				(?:\n" \
"					:?\n" \
"					(?<tzminute>[0-9]{2})?\n" \
"				)\n" \
"			)\n" \
"		", "$", NULL);
#line 120 "../libgitg/gitg-date.vala"
		_tmp27_ = _tmp26_;
#line 120 "../libgitg/gitg-date.vala"
		_tmp28_ = g_regex_new (_tmp27_, G_REGEX_EXTENDED, 0, &_inner_error0_);
#line 120 "../libgitg/gitg-date.vala"
		_tmp29_ = _tmp28_;
#line 120 "../libgitg/gitg-date.vala"
		_g_free0 (_tmp27_);
#line 120 "../libgitg/gitg-date.vala"
		_tmp25_ = _tmp29_;
#line 120 "../libgitg/gitg-date.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../libgitg/gitg-date.vala"
			_g_regex_unref0 (_tmp19_);
#line 120 "../libgitg/gitg-date.vala"
			_g_regex_unref0 (_tmp13_);
#line 1667 "gitg-date.c"
			goto __catch0_g_error;
		}
#line 120 "../libgitg/gitg-date.vala"
		_tmp30_ = _tmp25_;
#line 120 "../libgitg/gitg-date.vala"
		_tmp25_ = NULL;
#line 120 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (gitg_date_s_internal);
#line 120 "../libgitg/gitg-date.vala"
		gitg_date_s_internal = _tmp30_;
#line 55 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (_tmp25_);
#line 55 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (_tmp19_);
#line 55 "../libgitg/gitg-date.vala"
		_g_regex_unref0 (_tmp13_);
#line 1684 "gitg-date.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
#line 55 "../libgitg/gitg-date.vala"
		e = _inner_error0_;
#line 55 "../libgitg/gitg-date.vala"
		_inner_error0_ = NULL;
#line 135 "../libgitg/gitg-date.vala"
		_tmp31_ = e;
#line 135 "../libgitg/gitg-date.vala"
		_tmp32_ = _tmp31_->message;
#line 135 "../libgitg/gitg-date.vala"
		_tmp33_ = string_to_string (_tmp32_);
#line 135 "../libgitg/gitg-date.vala"
		_tmp34_ = g_strconcat ("Failed to compile date regex: ", _tmp33_, NULL);
#line 135 "../libgitg/gitg-date.vala"
		_tmp35_ = _tmp34_;
#line 135 "../libgitg/gitg-date.vala"
		g_warning ("gitg-date.vala:135: %s", _tmp35_);
#line 135 "../libgitg/gitg-date.vala"
		_g_free0 (_tmp35_);
#line 55 "../libgitg/gitg-date.vala"
		_g_error_free0 (e);
#line 1715 "gitg-date.c"
	}
	__finally0:
#line 55 "../libgitg/gitg-date.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../libgitg/gitg-date.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 55 "../libgitg/gitg-date.vala"
		g_clear_error (&_inner_error0_);
#line 1724 "gitg-date.c"
	}
}

static void
gitg_date_g_initable_interface_init (GInitableIface * iface,
                                     gpointer iface_data)
{
#line 28 "../libgitg/gitg-date.vala"
	gitg_date_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "../libgitg/gitg-date.vala"
	iface->init = (gboolean (*) (GInitable*, GCancellable*, GError**)) gitg_date_real_init;
#line 1736 "gitg-date.c"
}

static void
gitg_date_instance_init (GitgDate * self,
                         gpointer klass)
{
#line 28 "../libgitg/gitg-date.vala"
	self->priv = gitg_date_get_instance_private (self);
#line 1745 "gitg-date.c"
}

static void
gitg_date_finalize (GObject * obj)
{
	GitgDate * self;
#line 28 "../libgitg/gitg-date.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_DATE, GitgDate);
#line 262 "../libgitg/gitg-date.vala"
	_g_date_time_unref0 (self->priv->d_datetime);
#line 264 "../libgitg/gitg-date.vala"
	_g_free0 (self->priv->_date_string);
#line 28 "../libgitg/gitg-date.vala"
	G_OBJECT_CLASS (gitg_date_parent_class)->finalize (obj);
#line 1760 "gitg-date.c"
}

 G_GNUC_NO_INLINE static GType
gitg_date_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GitgDateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_date_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgDate), 0, (GInstanceInitFunc) gitg_date_instance_init, NULL };
	static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) gitg_date_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gitg_date_type_id;
	gitg_date_type_id = g_type_register_static (G_TYPE_OBJECT, "GitgDate", &g_define_type_info, 0);
	g_type_add_interface_static (gitg_date_type_id, g_initable_get_type (), &g_initable_info);
	GitgDate_private_offset = g_type_add_instance_private (gitg_date_type_id, sizeof (GitgDatePrivate));
	return gitg_date_type_id;
}

GType
gitg_date_get_type (void)
{
	static gsize gitg_date_type_id__once = 0;
	if (g_once_init_enter (&gitg_date_type_id__once)) {
		GType gitg_date_type_id;
		gitg_date_type_id = gitg_date_get_type_once ();
		g_once_init_leave (&gitg_date_type_id__once, gitg_date_type_id);
	}
	return gitg_date_type_id__once;
}

static void
_vala_gitg_date_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	GitgDate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DATE, GitgDate);
#line 28 "../libgitg/gitg-date.vala"
	switch (property_id) {
#line 28 "../libgitg/gitg-date.vala"
		case GITG_DATE_DATE_STRING_PROPERTY:
#line 28 "../libgitg/gitg-date.vala"
		g_value_set_string (value, gitg_date_get_date_string (self));
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 28 "../libgitg/gitg-date.vala"
		case GITG_DATE_DATE_PROPERTY:
#line 28 "../libgitg/gitg-date.vala"
		g_value_set_boxed (value, gitg_date_get_date (self));
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 1809 "gitg-date.c"
		default:
#line 28 "../libgitg/gitg-date.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 1815 "gitg-date.c"
	}
}

static void
_vala_gitg_date_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	GitgDate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DATE, GitgDate);
#line 28 "../libgitg/gitg-date.vala"
	switch (property_id) {
#line 28 "../libgitg/gitg-date.vala"
		case GITG_DATE_DATE_STRING_PROPERTY:
#line 28 "../libgitg/gitg-date.vala"
		gitg_date_set_date_string (self, g_value_get_string (value));
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 1835 "gitg-date.c"
		default:
#line 28 "../libgitg/gitg-date.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../libgitg/gitg-date.vala"
		break;
#line 1841 "gitg-date.c"
	}
}

