/* gitg-diff-view-file-selectable.c generated by valac 0.56.17, the Vala compiler
 * generated from gitg-diff-view-file-selectable.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2015 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <gtksourceview/gtksource.h>
#include "libgitg.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef enum  {
	GITG_DIFF_SELECTION_MODE_NONE,
	GITG_DIFF_SELECTION_MODE_SELECTING,
	GITG_DIFF_SELECTION_MODE_DESELECTING
} GitgDiffSelectionMode;

#define GITG_TYPE_DIFF_SELECTION_MODE (gitg_diff_selection_mode_get_type ())

#define GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE (gitg_diff_view_file_selectable_get_type ())
#define GITG_DIFF_VIEW_FILE_SELECTABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE, GitgDiffViewFileSelectable))
#define GITG_DIFF_VIEW_FILE_SELECTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE, GitgDiffViewFileSelectableClass))
#define GITG_IS_DIFF_VIEW_FILE_SELECTABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE))
#define GITG_IS_DIFF_VIEW_FILE_SELECTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE))
#define GITG_DIFF_VIEW_FILE_SELECTABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE, GitgDiffViewFileSelectableClass))

typedef struct _GitgDiffViewFileSelectable GitgDiffViewFileSelectable;
typedef struct _GitgDiffViewFileSelectableClass GitgDiffViewFileSelectableClass;
typedef struct _GitgDiffViewFileSelectablePrivate GitgDiffViewFileSelectablePrivate;
enum  {
	GITG_DIFF_VIEW_FILE_SELECTABLE_0_PROPERTY,
	GITG_DIFF_VIEW_FILE_SELECTABLE_SOURCE_VIEW_PROPERTY,
	GITG_DIFF_VIEW_FILE_SELECTABLE_HAS_SELECTION_PROPERTY,
	GITG_DIFF_VIEW_FILE_SELECTABLE_NUM_PROPERTIES
};
static GParamSpec* gitg_diff_view_file_selectable_properties[GITG_DIFF_VIEW_FILE_SELECTABLE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GitgDiffViewFileSelectable {
	GObject parent_instance;
	GitgDiffViewFileSelectablePrivate * priv;
};

struct _GitgDiffViewFileSelectableClass {
	GObjectClass parent_class;
};

struct _GitgDiffViewFileSelectablePrivate {
	gchar* d_selection_category;
	GtkTextTag* d_selection_tag;
	GitgDiffSelectionMode d_selection_mode;
	GtkTextMark* d_start_selection_mark;
	GtkTextMark* d_end_selection_mark;
	GeeHashMap* d_originally_selected;
	GdkCursor* d_cursor_ptr;
	GdkCursor* d_cursor_hand;
	gboolean d_is_rubber_band;
	GtkSourceView* _source_view;
	gboolean _has_selection;
};

static gint GitgDiffViewFileSelectable_private_offset;
static gpointer gitg_diff_view_file_selectable_parent_class = NULL;

VALA_EXTERN GType gitg_diff_selection_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gitg_diff_view_file_selectable_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gint* gitg_diff_view_file_selectable_get_selected_lines (GitgDiffViewFileSelectable* self,
                                                         gint* result_length1);
VALA_EXTERN GtkSourceView* gitg_diff_view_file_selectable_get_source_view (GitgDiffViewFileSelectable* self);
static void _vala_array_add6 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
VALA_EXTERN GitgDiffViewFileSelectable* gitg_diff_view_file_selectable_new (GtkSourceView* source_view);
VALA_EXTERN GitgDiffViewFileSelectable* gitg_diff_view_file_selectable_construct (GType object_type,
                                                                      GtkSourceView* source_view);
static void gitg_diff_view_file_selectable_update_cursor (GitgDiffViewFileSelectable* self,
                                                   GdkCursor* cursor);
static void gitg_diff_view_file_selectable_update_theme (GitgDiffViewFileSelectable* self);
static gboolean gitg_diff_view_file_selectable_get_line_selected (GitgDiffViewFileSelectable* self,
                                                           GtkTextIter* iter);
static gboolean gitg_diff_view_file_selectable_get_line_is_diff (GitgDiffViewFileSelectable* self,
                                                          GtkTextIter* iter);
static gboolean gitg_diff_view_file_selectable_get_line_is_hunk (GitgDiffViewFileSelectable* self,
                                                          GtkTextIter* iter);
static gboolean gitg_diff_view_file_selectable_get_iter_from_pointer_position (GitgDiffViewFileSelectable* self,
                                                                        GtkTextIter* iter);
static gboolean gitg_diff_view_file_selectable_get_iter_from_event_position (GitgDiffViewFileSelectable* self,
                                                                      GtkTextIter* iter,
                                                                      gint x,
                                                                      gint y);
static void gitg_diff_view_file_selectable_update_selection_range (GitgDiffViewFileSelectable* self,
                                                            GtkTextIter* start,
                                                            GtkTextIter* end,
                                                            gboolean select);
static void gitg_diff_view_file_selectable_clear_original_selection (GitgDiffViewFileSelectable* self,
                                                              GtkTextIter* start,
                                                              GtkTextIter* end,
                                                              gboolean include_end);
static void gitg_diff_view_file_selectable_forward_to_hunk_end (GitgDiffViewFileSelectable* self,
                                                         GtkTextIter* iter);
static gboolean gitg_diff_view_file_selectable_hunk_is_all_selected (GitgDiffViewFileSelectable* self,
                                                              GtkTextIter* iter);
static void gitg_diff_view_file_selectable_update_selection_hunk (GitgDiffViewFileSelectable* self,
                                                           GtkTextIter* iter,
                                                           gboolean select);
static gboolean gitg_diff_view_file_selectable_button_press_event_on_view (GitgDiffViewFileSelectable* self,
                                                                    GdkEventButton* event);
static void gitg_diff_view_file_selectable_update_selection (GitgDiffViewFileSelectable* self,
                                                      GtkTextIter* cursor);
static gboolean gitg_diff_view_file_selectable_update_selection_event (GitgDiffViewFileSelectable* self,
                                                                GdkModifierType state,
                                                                gint x,
                                                                gint y);
static GdkCursor* gitg_diff_view_file_selectable_get_cursor_hand (GitgDiffViewFileSelectable* self);
static GdkCursor* gitg_diff_view_file_selectable_get_cursor_ptr (GitgDiffViewFileSelectable* self);
static gboolean gitg_diff_view_file_selectable_motion_notify_event_on_view (GitgDiffViewFileSelectable* self,
                                                                     GdkEventMotion* event);
static gboolean gitg_diff_view_file_selectable_leave_notify_event_on_view (GitgDiffViewFileSelectable* self,
                                                                    GdkEventCrossing* event);
static gboolean gitg_diff_view_file_selectable_enter_notify_event_on_view (GitgDiffViewFileSelectable* self,
                                                                    GdkEventCrossing* event);
static void gitg_diff_view_file_selectable_update_has_selection (GitgDiffViewFileSelectable* self);
VALA_EXTERN gboolean gitg_diff_view_file_selectable_get_has_selection (GitgDiffViewFileSelectable* self);
static void gitg_diff_view_file_selectable_set_has_selection (GitgDiffViewFileSelectable* self,
                                                       gboolean value);
static gboolean gitg_diff_view_file_selectable_button_release_event_on_view (GitgDiffViewFileSelectable* self,
                                                                      GdkEventButton* event);
VALA_EXTERN void gitg_diff_view_file_selectable_set_source_view (GitgDiffViewFileSelectable* self,
                                                     GtkSourceView* value);
static GObject * gitg_diff_view_file_selectable_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static gboolean _gitg_diff_view_file_selectable_button_press_event_on_view_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                                   GdkEventButton* event,
                                                                                                   gpointer self);
static gboolean _gitg_diff_view_file_selectable_motion_notify_event_on_view_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                                     GdkEventMotion* event,
                                                                                                     gpointer self);
static gboolean _gitg_diff_view_file_selectable_leave_notify_event_on_view_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                                                   GdkEventCrossing* event,
                                                                                                   gpointer self);
static gboolean _gitg_diff_view_file_selectable_enter_notify_event_on_view_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                                                   GdkEventCrossing* event,
                                                                                                   gpointer self);
static gboolean _gitg_diff_view_file_selectable_button_release_event_on_view_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                                       GdkEventButton* event,
                                                                                                       gpointer self);
static void _gitg_diff_view_file_selectable___lambda51_ (GitgDiffViewFileSelectable* self);
static void __gitg_diff_view_file_selectable___lambda51__gtk_widget_realize (GtkWidget* _sender,
                                                                      gpointer self);
static void _gitg_diff_view_file_selectable___lambda52_ (GitgDiffViewFileSelectable* self);
static void __gitg_diff_view_file_selectable___lambda52__g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void _gitg_diff_view_file_selectable_update_theme_gtk_widget_style_updated (GtkWidget* _sender,
                                                                            gpointer self);
static void gitg_diff_view_file_selectable_finalize (GObject * obj);
static GType gitg_diff_view_file_selectable_get_type_once (void);
static void _vala_gitg_diff_view_file_selectable_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_gitg_diff_view_file_selectable_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);

 G_GNUC_NO_INLINE static GType
gitg_diff_selection_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{GITG_DIFF_SELECTION_MODE_NONE, "GITG_DIFF_SELECTION_MODE_NONE", "none"}, {GITG_DIFF_SELECTION_MODE_SELECTING, "GITG_DIFF_SELECTION_MODE_SELECTING", "selecting"}, {GITG_DIFF_SELECTION_MODE_DESELECTING, "GITG_DIFF_SELECTION_MODE_DESELECTING", "deselecting"}, {0, NULL, NULL}};
	GType gitg_diff_selection_mode_type_id;
	gitg_diff_selection_mode_type_id = g_enum_register_static ("GitgDiffSelectionMode", values);
	return gitg_diff_selection_mode_type_id;
}

GType
gitg_diff_selection_mode_get_type (void)
{
	static gsize gitg_diff_selection_mode_type_id__once = 0;
	if (g_once_init_enter (&gitg_diff_selection_mode_type_id__once)) {
		GType gitg_diff_selection_mode_type_id;
		gitg_diff_selection_mode_type_id = gitg_diff_selection_mode_get_type_once ();
		g_once_init_leave (&gitg_diff_selection_mode_type_id__once, gitg_diff_selection_mode_type_id);
	}
	return gitg_diff_selection_mode_type_id__once;
}

static inline gpointer
gitg_diff_view_file_selectable_get_instance_private (GitgDiffViewFileSelectable* self)
{
	return G_STRUCT_MEMBER_P (self, GitgDiffViewFileSelectable_private_offset);
}

static void
_vala_array_add6 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 59 "../libgitg/gitg-diff-view-file-selectable.vala"
	if ((*length) == (*size)) {
#line 59 "../libgitg/gitg-diff-view-file-selectable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 59 "../libgitg/gitg-diff-view-file-selectable.vala"
		*array = g_renew (gint, *array, *size);
#line 240 "gitg-diff-view-file-selectable.c"
	}
#line 59 "../libgitg/gitg-diff-view-file-selectable.vala"
	(*array)[(*length)++] = value;
#line 244 "gitg-diff-view-file-selectable.c"
}

gint*
gitg_diff_view_file_selectable_get_selected_lines (GitgDiffViewFileSelectable* self,
                                                   gint* result_length1)
{
	gint* ret = NULL;
	gint* _tmp0_;
	gint ret_length1;
	gint _ret_size_;
	GtkTextIter iter = {0};
	GtkSourceBuffer* buffer = NULL;
	GtkSourceView* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GtkSourceBuffer* _tmp4_;
	GtkTextIter _tmp5_ = {0};
	gint* _tmp9_;
	gint _tmp9__length1;
	gint* result;
#line 48 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = g_new0 (gint, 0);
#line 50 "../libgitg/gitg-diff-view-file-selectable.vala"
	ret = _tmp0_;
#line 50 "../libgitg/gitg-diff-view-file-selectable.vala"
	ret_length1 = 0;
#line 50 "../libgitg/gitg-diff-view-file-selectable.vala"
	_ret_size_ = ret_length1;
#line 53 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = self->priv->_source_view;
#line 53 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp1_);
#line 53 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = _tmp2_;
#line 53 "../libgitg/gitg-diff-view-file-selectable.vala"
	buffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_source_buffer_get_type (), GtkSourceBuffer);
#line 55 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = buffer;
#line 55 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_buffer_get_start_iter ((GtkTextBuffer*) _tmp4_, &_tmp5_);
#line 55 "../libgitg/gitg-diff-view-file-selectable.vala"
	iter = _tmp5_;
#line 57 "../libgitg/gitg-diff-view-file-selectable.vala"
	while (TRUE) {
#line 291 "gitg-diff-view-file-selectable.c"
		GtkSourceBuffer* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_;
#line 57 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp6_ = buffer;
#line 57 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp7_ = self->priv->d_selection_category;
#line 57 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp8_ = gtk_source_buffer_forward_iter_to_source_mark (_tmp6_, &iter, _tmp7_);
#line 57 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (!_tmp8_) {
#line 57 "../libgitg/gitg-diff-view-file-selectable.vala"
			break;
#line 305 "gitg-diff-view-file-selectable.c"
		}
#line 59 "../libgitg/gitg-diff-view-file-selectable.vala"
		_vala_array_add6 (&ret, &ret_length1, &_ret_size_, gtk_text_iter_get_line (&iter));
#line 309 "gitg-diff-view-file-selectable.c"
	}
#line 62 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp9_ = ret;
#line 62 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp9__length1 = ret_length1;
#line 62 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (result_length1) {
#line 62 "../libgitg/gitg-diff-view-file-selectable.vala"
		*result_length1 = _tmp9__length1;
#line 319 "gitg-diff-view-file-selectable.c"
	}
#line 62 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = _tmp9_;
#line 62 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 325 "gitg-diff-view-file-selectable.c"
}

GitgDiffViewFileSelectable*
gitg_diff_view_file_selectable_construct (GType object_type,
                                          GtkSourceView* source_view)
{
	GitgDiffViewFileSelectable * self = NULL;
#line 65 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (source_view != NULL, NULL);
#line 67 "../libgitg/gitg-diff-view-file-selectable.vala"
	self = (GitgDiffViewFileSelectable*) g_object_new (object_type, "source-view", source_view, NULL);
#line 65 "../libgitg/gitg-diff-view-file-selectable.vala"
	return self;
#line 339 "gitg-diff-view-file-selectable.c"
}

GitgDiffViewFileSelectable*
gitg_diff_view_file_selectable_new (GtkSourceView* source_view)
{
#line 65 "../libgitg/gitg-diff-view-file-selectable.vala"
	return gitg_diff_view_file_selectable_construct (GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE, source_view);
#line 347 "gitg-diff-view-file-selectable.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 128 "../libgitg/gitg-diff-view-file-selectable.vala"
	return self ? g_object_ref (self) : NULL;
#line 355 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_update_cursor (GitgDiffViewFileSelectable* self,
                                              GdkCursor* cursor)
{
	GdkWindow* window = NULL;
	GtkSourceView* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GdkWindow* _tmp4_;
#line 126 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 126 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (cursor != NULL);
#line 128 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->_source_view;
#line 128 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = gtk_text_view_get_window ((GtkTextView*) _tmp0_, GTK_TEXT_WINDOW_TEXT);
#line 128 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 128 "../libgitg/gitg-diff-view-file-selectable.vala"
	window = _tmp2_;
#line 130 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = window;
#line 130 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp3_ == NULL) {
#line 132 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (window);
#line 132 "../libgitg/gitg-diff-view-file-selectable.vala"
		return;
#line 388 "gitg-diff-view-file-selectable.c"
	}
#line 135 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = window;
#line 135 "../libgitg/gitg-diff-view-file-selectable.vala"
	gdk_window_set_cursor (_tmp4_, cursor);
#line 126 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (window);
#line 396 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_update_theme (GitgDiffViewFileSelectable* self)
{
	GtkSourceMarkAttributes* selection_attributes = NULL;
	GtkSourceMarkAttributes* _tmp0_;
	GtkStyleContext* context = NULL;
	GtkSourceView* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GdkRGBA theme_selected_bg_color = {0};
	GdkRGBA theme_selected_fg_color = {0};
	GtkStyleContext* _tmp4_;
	GdkRGBA _tmp5_ = {0};
	gboolean _tmp6_;
	GtkStyleContext* _tmp9_;
	GdkRGBA _tmp10_ = {0};
	gboolean _tmp11_;
	GtkSourceView* _tmp14_;
	const gchar* _tmp15_;
	GtkSourceMarkAttributes* _tmp16_;
#line 138 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 140 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = gtk_source_mark_attributes_new ();
#line 140 "../libgitg/gitg-diff-view-file-selectable.vala"
	selection_attributes = _tmp0_;
#line 141 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = self->priv->_source_view;
#line 141 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 141 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 141 "../libgitg/gitg-diff-view-file-selectable.vala"
	context = _tmp3_;
#line 145 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = context;
#line 145 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp6_ = gtk_style_context_lookup_color (_tmp4_, "theme_selected_bg_color", &_tmp5_);
#line 145 "../libgitg/gitg-diff-view-file-selectable.vala"
	theme_selected_bg_color = _tmp5_;
#line 145 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp6_) {
#line 441 "gitg-diff-view-file-selectable.c"
		GtkSourceMarkAttributes* _tmp7_;
		GdkRGBA _tmp8_;
#line 147 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp7_ = selection_attributes;
#line 147 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp8_ = theme_selected_bg_color;
#line 147 "../libgitg/gitg-diff-view-file-selectable.vala"
		g_object_set (_tmp7_, "background", &_tmp8_, NULL);
#line 450 "gitg-diff-view-file-selectable.c"
	}
#line 150 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp9_ = context;
#line 150 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp11_ = gtk_style_context_lookup_color (_tmp9_, "theme_selected_fg_color", &_tmp10_);
#line 150 "../libgitg/gitg-diff-view-file-selectable.vala"
	theme_selected_fg_color = _tmp10_;
#line 150 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp11_) {
#line 460 "gitg-diff-view-file-selectable.c"
		GtkTextTag* _tmp12_;
		GdkRGBA _tmp13_;
#line 152 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp12_ = self->priv->d_selection_tag;
#line 152 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp13_ = theme_selected_fg_color;
#line 152 "../libgitg/gitg-diff-view-file-selectable.vala"
		g_object_set (_tmp12_, "foreground-rgba", &_tmp13_, NULL);
#line 469 "gitg-diff-view-file-selectable.c"
	}
#line 155 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp14_ = self->priv->_source_view;
#line 155 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp15_ = self->priv->d_selection_category;
#line 155 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp16_ = selection_attributes;
#line 155 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_source_view_set_mark_attributes (_tmp14_, _tmp15_, _tmp16_, 0);
#line 138 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (context);
#line 138 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (selection_attributes);
#line 483 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_get_line_selected (GitgDiffViewFileSelectable* self,
                                                  GtkTextIter* iter)
{
	GtkTextIter start = {0};
	GtkTextIter _tmp0_;
	GtkSourceBuffer* buffer = NULL;
	GtkSourceView* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GtkTextIter _tmp4_;
	const gchar* _tmp5_;
	GSList* _tmp6_;
	GSList* _tmp7_;
	gboolean _tmp8_;
	gboolean result;
#line 158 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 160 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = *iter;
#line 160 "../libgitg/gitg-diff-view-file-selectable.vala"
	start = _tmp0_;
#line 162 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_iter_set_line_offset (&start, 0);
#line 164 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = self->priv->_source_view;
#line 164 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp1_);
#line 164 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = _tmp2_;
#line 164 "../libgitg/gitg-diff-view-file-selectable.vala"
	buffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_source_buffer_get_type (), GtkSourceBuffer);
#line 166 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = start;
#line 166 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = self->priv->d_selection_category;
#line 166 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp6_ = gtk_source_buffer_get_source_marks_at_iter (buffer, &_tmp4_, _tmp5_);
#line 166 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp7_ = _tmp6_;
#line 166 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp8_ = _tmp7_ != NULL;
#line 166 "../libgitg/gitg-diff-view-file-selectable.vala"
	(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_slist_free (_tmp7_), NULL));
#line 166 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = _tmp8_;
#line 166 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 536 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_get_line_is_diff (GitgDiffViewFileSelectable* self,
                                                 GtkTextIter* iter)
{
	GtkTextIter start = {0};
	GtkTextIter _tmp0_;
	GtkSourceBuffer* buffer = NULL;
	GtkSourceView* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkSourceBuffer* _tmp5_;
	GtkTextIter _tmp6_;
	GSList* _tmp7_;
	GSList* _tmp8_;
	gboolean _tmp9_;
	gboolean result;
#line 169 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 169 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 171 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = *iter;
#line 171 "../libgitg/gitg-diff-view-file-selectable.vala"
	start = _tmp0_;
#line 173 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_iter_set_line_offset (&start, 0);
#line 175 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = self->priv->_source_view;
#line 175 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp1_);
#line 175 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = _tmp2_;
#line 175 "../libgitg/gitg-diff-view-file-selectable.vala"
	buffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_source_buffer_get_type (), GtkSourceBuffer);
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = buffer;
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp6_ = start;
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp7_ = gtk_source_buffer_get_source_marks_at_iter (_tmp5_, &_tmp6_, "added");
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp8_ = _tmp7_;
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp9_ = _tmp8_ != NULL;
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
	(_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_slist_free (_tmp8_), NULL));
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp9_) {
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp4_ = TRUE;
#line 590 "gitg-diff-view-file-selectable.c"
	} else {
		GtkSourceBuffer* _tmp10_;
		GtkTextIter _tmp11_;
		GSList* _tmp12_;
		GSList* _tmp13_;
#line 178 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp10_ = buffer;
#line 178 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp11_ = start;
#line 178 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp12_ = gtk_source_buffer_get_source_marks_at_iter (_tmp10_, &_tmp11_, "removed");
#line 178 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp13_ = _tmp12_;
#line 178 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp4_ = _tmp13_ != NULL;
#line 178 "../libgitg/gitg-diff-view-file-selectable.vala"
		(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_slist_free (_tmp13_), NULL));
#line 608 "gitg-diff-view-file-selectable.c"
	}
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = _tmp4_;
#line 177 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 614 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_get_line_is_hunk (GitgDiffViewFileSelectable* self,
                                                 GtkTextIter* iter)
{
	GtkTextIter start = {0};
	GtkTextIter _tmp0_;
	GtkSourceBuffer* buffer = NULL;
	GtkSourceView* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GtkTextIter _tmp4_;
	GSList* _tmp5_;
	GSList* _tmp6_;
	gboolean _tmp7_;
	gboolean result;
#line 181 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 181 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 183 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = *iter;
#line 183 "../libgitg/gitg-diff-view-file-selectable.vala"
	start = _tmp0_;
#line 185 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_iter_set_line_offset (&start, 0);
#line 187 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = self->priv->_source_view;
#line 187 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp1_);
#line 187 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = _tmp2_;
#line 187 "../libgitg/gitg-diff-view-file-selectable.vala"
	buffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_source_buffer_get_type (), GtkSourceBuffer);
#line 189 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = start;
#line 189 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = gtk_source_buffer_get_source_marks_at_iter (buffer, &_tmp4_, "header");
#line 189 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp6_ = _tmp5_;
#line 189 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp7_ = _tmp6_ != NULL;
#line 189 "../libgitg/gitg-diff-view-file-selectable.vala"
	(_tmp6_ == NULL) ? NULL : (_tmp6_ = (g_slist_free (_tmp6_), NULL));
#line 189 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = _tmp7_;
#line 189 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 664 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_get_iter_from_pointer_position (GitgDiffViewFileSelectable* self,
                                                               GtkTextIter* iter)
{
	GtkTextIter _vala_iter = {0};
	GdkWindow* win = NULL;
	GtkSourceView* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gint x = 0;
	gint y = 0;
	gint width = 0;
	gint height = 0;
	GtkTextIter dummy_iter = {0};
	GtkTextIter _tmp3_;
	GdkWindow* _tmp4_;
	GdkWindow* _tmp5_;
	GdkDevice* pointer = NULL;
	GdkDisplay* _tmp6_;
	GdkSeat* _tmp7_;
	GdkDevice* _tmp8_;
	GdkDevice* _tmp9_;
	GdkWindow* _tmp10_;
	GdkDevice* _tmp11_;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GtkTextIter _tmp17_ = {0};
	gboolean _tmp18_;
	gboolean result;
#line 192 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 194 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->_source_view;
#line 194 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = gtk_text_view_get_window ((GtkTextView*) _tmp0_, GTK_TEXT_WINDOW_TEXT);
#line 194 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 194 "../libgitg/gitg-diff-view-file-selectable.vala"
	win = _tmp2_;
#line 199 "../libgitg/gitg-diff-view-file-selectable.vala"
	memset (&dummy_iter, 0, sizeof (GtkTextIter));
#line 200 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = dummy_iter;
#line 200 "../libgitg/gitg-diff-view-file-selectable.vala"
	_vala_iter = _tmp3_;
#line 202 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = win;
#line 202 "../libgitg/gitg-diff-view-file-selectable.vala"
	width = gdk_window_get_width (_tmp4_);
#line 203 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = win;
#line 203 "../libgitg/gitg-diff-view-file-selectable.vala"
	height = gdk_window_get_height (_tmp5_);
#line 205 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp6_ = gdk_display_get_default ();
#line 205 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp7_ = gdk_display_get_default_seat (_tmp6_);
#line 205 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp8_ = gdk_seat_get_pointer (_tmp7_);
#line 205 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 205 "../libgitg/gitg-diff-view-file-selectable.vala"
	pointer = _tmp9_;
#line 206 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp10_ = win;
#line 206 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp11_ = pointer;
#line 206 "../libgitg/gitg-diff-view-file-selectable.vala"
	gdk_window_get_device_position (_tmp10_, _tmp11_, &_tmp12_, &_tmp13_, NULL);
#line 206 "../libgitg/gitg-diff-view-file-selectable.vala"
	x = _tmp12_;
#line 206 "../libgitg/gitg-diff-view-file-selectable.vala"
	y = _tmp13_;
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (x < 0) {
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp16_ = TRUE;
#line 747 "gitg-diff-view-file-selectable.c"
	} else {
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp16_ = y < 0;
#line 751 "gitg-diff-view-file-selectable.c"
	}
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp16_) {
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp15_ = TRUE;
#line 757 "gitg-diff-view-file-selectable.c"
	} else {
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp15_ = x > width;
#line 761 "gitg-diff-view-file-selectable.c"
	}
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp15_) {
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp14_ = TRUE;
#line 767 "gitg-diff-view-file-selectable.c"
	} else {
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp14_ = y > height;
#line 771 "gitg-diff-view-file-selectable.c"
	}
#line 208 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp14_) {
#line 210 "../libgitg/gitg-diff-view-file-selectable.vala"
		result = FALSE;
#line 210 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (pointer);
#line 210 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (win);
#line 210 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (iter) {
#line 210 "../libgitg/gitg-diff-view-file-selectable.vala"
			*iter = _vala_iter;
#line 785 "gitg-diff-view-file-selectable.c"
		}
#line 210 "../libgitg/gitg-diff-view-file-selectable.vala"
		return result;
#line 789 "gitg-diff-view-file-selectable.c"
	}
#line 213 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp18_ = gitg_diff_view_file_selectable_get_iter_from_event_position (self, &_tmp17_, x, y);
#line 213 "../libgitg/gitg-diff-view-file-selectable.vala"
	_vala_iter = _tmp17_;
#line 213 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = _tmp18_;
#line 213 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (pointer);
#line 213 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (win);
#line 213 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (iter) {
#line 213 "../libgitg/gitg-diff-view-file-selectable.vala"
		*iter = _vala_iter;
#line 805 "gitg-diff-view-file-selectable.c"
	}
#line 213 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 809 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_get_iter_from_event_position (GitgDiffViewFileSelectable* self,
                                                             GtkTextIter* iter,
                                                             gint x,
                                                             gint y)
{
	GtkTextIter _vala_iter = {0};
	gint win_x = 0;
	gint win_y = 0;
	GtkSourceView* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GtkSourceView* _tmp3_;
	GtkTextIter _tmp4_ = {0};
	gboolean result;
#line 216 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 220 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->_source_view;
#line 220 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_view_window_to_buffer_coords ((GtkTextView*) _tmp0_, GTK_TEXT_WINDOW_TEXT, x, y, &_tmp1_, &_tmp2_);
#line 220 "../libgitg/gitg-diff-view-file-selectable.vala"
	win_x = _tmp1_;
#line 220 "../libgitg/gitg-diff-view-file-selectable.vala"
	win_y = _tmp2_;
#line 221 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = self->priv->_source_view;
#line 221 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_view_get_line_at_y ((GtkTextView*) _tmp3_, &_tmp4_, win_y, NULL);
#line 221 "../libgitg/gitg-diff-view-file-selectable.vala"
	_vala_iter = _tmp4_;
#line 223 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = TRUE;
#line 223 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (iter) {
#line 223 "../libgitg/gitg-diff-view-file-selectable.vala"
		*iter = _vala_iter;
#line 849 "gitg-diff-view-file-selectable.c"
	}
#line 223 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 853 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_update_selection_range (GitgDiffViewFileSelectable* self,
                                                       GtkTextIter* start,
                                                       GtkTextIter* end,
                                                       gboolean select)
{
	GtkSourceBuffer* buffer = NULL;
	GtkSourceView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextIter real_start = {0};
	GtkTextIter real_end = {0};
	GtkTextIter _tmp3_;
	GtkTextIter _tmp4_;
	GtkTextIter _tmp5_;
	gint start_line = 0;
	gint end_line = 0;
	GtkTextIter current = {0};
	GtkTextIter _tmp9_;
#line 226 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 226 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (start != NULL);
#line 226 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (end != NULL);
#line 228 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->_source_view;
#line 228 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp0_);
#line 228 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = _tmp1_;
#line 228 "../libgitg/gitg-diff-view-file-selectable.vala"
	buffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_source_buffer_get_type (), GtkSourceBuffer);
#line 232 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = *start;
#line 232 "../libgitg/gitg-diff-view-file-selectable.vala"
	real_start = _tmp3_;
#line 233 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = *end;
#line 233 "../libgitg/gitg-diff-view-file-selectable.vala"
	real_end = _tmp4_;
#line 235 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = real_end;
#line 235 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (gtk_text_iter_compare (&real_start, &_tmp5_) > 0) {
#line 901 "gitg-diff-view-file-selectable.c"
		GtkTextIter tmp = {0};
		GtkTextIter _tmp6_;
		GtkTextIter _tmp7_;
		GtkTextIter _tmp8_;
#line 237 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp6_ = real_end;
#line 237 "../libgitg/gitg-diff-view-file-selectable.vala"
		tmp = _tmp6_;
#line 239 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp7_ = real_start;
#line 239 "../libgitg/gitg-diff-view-file-selectable.vala"
		real_end = _tmp7_;
#line 240 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp8_ = tmp;
#line 240 "../libgitg/gitg-diff-view-file-selectable.vala"
		real_start = _tmp8_;
#line 918 "gitg-diff-view-file-selectable.c"
	}
#line 243 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_iter_set_line_offset (&real_start, 0);
#line 245 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (!gtk_text_iter_ends_line (&real_end)) {
#line 247 "../libgitg/gitg-diff-view-file-selectable.vala"
		gtk_text_iter_forward_to_line_end (&real_end);
#line 926 "gitg-diff-view-file-selectable.c"
	}
#line 250 "../libgitg/gitg-diff-view-file-selectable.vala"
	start_line = gtk_text_iter_get_line (&real_start);
#line 251 "../libgitg/gitg-diff-view-file-selectable.vala"
	end_line = gtk_text_iter_get_line (&real_end);
#line 253 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp9_ = real_start;
#line 253 "../libgitg/gitg-diff-view-file-selectable.vala"
	current = _tmp9_;
#line 255 "../libgitg/gitg-diff-view-file-selectable.vala"
	while (TRUE) {
#line 938 "gitg-diff-view-file-selectable.c"
		GtkTextIter _tmp10_;
		gint _tmp22_;
#line 255 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (!(start_line <= end_line)) {
#line 255 "../libgitg/gitg-diff-view-file-selectable.vala"
			break;
#line 945 "gitg-diff-view-file-selectable.c"
		}
#line 257 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp10_ = current;
#line 257 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (gitg_diff_view_file_selectable_get_line_is_diff (self, &_tmp10_)) {
#line 951 "gitg-diff-view-file-selectable.c"
			GeeHashMap* _tmp11_;
#line 259 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp11_ = self->priv->d_originally_selected;
#line 259 "../libgitg/gitg-diff-view-file-selectable.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp11_, (gpointer) ((gintptr) start_line))) {
#line 957 "gitg-diff-view-file-selectable.c"
				GeeHashMap* _tmp12_;
				GtkTextIter _tmp13_;
#line 261 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp12_ = self->priv->d_originally_selected;
#line 261 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp13_ = current;
#line 261 "../libgitg/gitg-diff-view-file-selectable.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, (gpointer) ((gintptr) start_line), (gpointer) ((gintptr) gitg_diff_view_file_selectable_get_line_selected (self, &_tmp13_)));
#line 966 "gitg-diff-view-file-selectable.c"
			}
#line 264 "../libgitg/gitg-diff-view-file-selectable.vala"
			if (select) {
#line 970 "gitg-diff-view-file-selectable.c"
				GtkSourceBuffer* _tmp14_;
				const gchar* _tmp15_;
				GtkTextIter _tmp16_;
				GtkTextIter line_end = {0};
				GtkTextIter _tmp17_;
				GtkSourceBuffer* _tmp18_;
				GtkTextTag* _tmp19_;
				GtkTextIter _tmp20_;
				GtkTextIter _tmp21_;
#line 266 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp14_ = buffer;
#line 266 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp15_ = self->priv->d_selection_category;
#line 266 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp16_ = current;
#line 266 "../libgitg/gitg-diff-view-file-selectable.vala"
				gtk_source_buffer_create_source_mark (_tmp14_, NULL, _tmp15_, &_tmp16_);
#line 268 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp17_ = current;
#line 268 "../libgitg/gitg-diff-view-file-selectable.vala"
				line_end = _tmp17_;
#line 270 "../libgitg/gitg-diff-view-file-selectable.vala"
				if (!gtk_text_iter_ends_line (&line_end)) {
#line 272 "../libgitg/gitg-diff-view-file-selectable.vala"
					gtk_text_iter_forward_to_line_end (&line_end);
#line 996 "gitg-diff-view-file-selectable.c"
				}
#line 275 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp18_ = buffer;
#line 275 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp19_ = self->priv->d_selection_tag;
#line 275 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp20_ = current;
#line 275 "../libgitg/gitg-diff-view-file-selectable.vala"
				_tmp21_ = line_end;
#line 275 "../libgitg/gitg-diff-view-file-selectable.vala"
				gtk_text_buffer_apply_tag ((GtkTextBuffer*) _tmp18_, _tmp19_, &_tmp20_, &_tmp21_);
#line 1008 "gitg-diff-view-file-selectable.c"
			}
		}
#line 279 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (!gtk_text_iter_forward_line (&current)) {
#line 281 "../libgitg/gitg-diff-view-file-selectable.vala"
			break;
#line 1015 "gitg-diff-view-file-selectable.c"
		}
#line 284 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp22_ = start_line;
#line 284 "../libgitg/gitg-diff-view-file-selectable.vala"
		start_line = _tmp22_ + 1;
#line 1021 "gitg-diff-view-file-selectable.c"
	}
#line 287 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (!select) {
#line 1025 "gitg-diff-view-file-selectable.c"
		GtkSourceBuffer* _tmp23_;
		GtkTextIter _tmp24_;
		GtkTextIter _tmp25_;
		const gchar* _tmp26_;
		GtkSourceBuffer* _tmp27_;
		GtkTextTag* _tmp28_;
		GtkTextIter _tmp29_;
		GtkTextIter _tmp30_;
#line 289 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp23_ = buffer;
#line 289 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp24_ = real_start;
#line 289 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp25_ = real_end;
#line 289 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp26_ = self->priv->d_selection_category;
#line 289 "../libgitg/gitg-diff-view-file-selectable.vala"
		gtk_source_buffer_remove_source_marks (_tmp23_, &_tmp24_, &_tmp25_, _tmp26_);
#line 290 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp27_ = buffer;
#line 290 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp28_ = self->priv->d_selection_tag;
#line 290 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp29_ = real_start;
#line 290 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp30_ = real_end;
#line 290 "../libgitg/gitg-diff-view-file-selectable.vala"
		gtk_text_buffer_remove_tag ((GtkTextBuffer*) _tmp27_, _tmp28_, &_tmp29_, &_tmp30_);
#line 1054 "gitg-diff-view-file-selectable.c"
	}
}

static void
gitg_diff_view_file_selectable_clear_original_selection (GitgDiffViewFileSelectable* self,
                                                         GtkTextIter* start,
                                                         GtkTextIter* end,
                                                         gboolean include_end)
{
	GtkTextIter current = {0};
	GtkTextIter _tmp0_;
	gint end_line = 0;
	gint current_line = 0;
#line 294 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 294 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (start != NULL);
#line 294 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (end != NULL);
#line 296 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = *start;
#line 296 "../libgitg/gitg-diff-view-file-selectable.vala"
	current = _tmp0_;
#line 297 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_iter_set_line_offset (&current, 0);
#line 299 "../libgitg/gitg-diff-view-file-selectable.vala"
	end_line = gtk_text_iter_get_line (end);
#line 300 "../libgitg/gitg-diff-view-file-selectable.vala"
	current_line = gtk_text_iter_get_line (&current);
#line 302 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (include_end) {
#line 1086 "gitg-diff-view-file-selectable.c"
		gint _tmp1_;
#line 304 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp1_ = end_line;
#line 304 "../libgitg/gitg-diff-view-file-selectable.vala"
		end_line = _tmp1_ + 1;
#line 1092 "gitg-diff-view-file-selectable.c"
	}
#line 307 "../libgitg/gitg-diff-view-file-selectable.vala"
	while (TRUE) {
#line 1096 "gitg-diff-view-file-selectable.c"
		gboolean originally_selected = FALSE;
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
		GtkTextIter _tmp4_;
		GtkTextIter _tmp5_;
		gint _tmp6_;
#line 307 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (!(current_line < end_line)) {
#line 307 "../libgitg/gitg-diff-view-file-selectable.vala"
			break;
#line 1107 "gitg-diff-view-file-selectable.c"
		}
#line 309 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp2_ = self->priv->d_originally_selected;
#line 309 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) current_line));
#line 309 "../libgitg/gitg-diff-view-file-selectable.vala"
		originally_selected = (gboolean) ((gintptr) _tmp3_);
#line 311 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp4_ = current;
#line 311 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp5_ = current;
#line 311 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_update_selection_range (self, &_tmp4_, &_tmp5_, originally_selected);
#line 313 "../libgitg/gitg-diff-view-file-selectable.vala"
		gtk_text_iter_forward_line (&current);
#line 314 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp6_ = current_line;
#line 314 "../libgitg/gitg-diff-view-file-selectable.vala"
		current_line = _tmp6_ + 1;
#line 1127 "gitg-diff-view-file-selectable.c"
	}
}

static void
gitg_diff_view_file_selectable_forward_to_hunk_end (GitgDiffViewFileSelectable* self,
                                                    GtkTextIter* iter)
{
	GtkSourceBuffer* buffer = NULL;
	GtkSourceView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkSourceBuffer* _tmp3_;
	gboolean _tmp4_;
#line 318 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 318 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (iter != NULL);
#line 320 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_iter_forward_line (iter);
#line 322 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->_source_view;
#line 322 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp0_);
#line 322 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = _tmp1_;
#line 322 "../libgitg/gitg-diff-view-file-selectable.vala"
	buffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_source_buffer_get_type (), GtkSourceBuffer);
#line 324 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = buffer;
#line 324 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = gtk_source_buffer_forward_iter_to_source_mark (_tmp3_, iter, "header");
#line 324 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (!_tmp4_) {
#line 326 "../libgitg/gitg-diff-view-file-selectable.vala"
		gtk_text_iter_forward_to_end (iter);
#line 1163 "gitg-diff-view-file-selectable.c"
	}
}

static gboolean
gitg_diff_view_file_selectable_hunk_is_all_selected (GitgDiffViewFileSelectable* self,
                                                     GtkTextIter* iter)
{
	GtkTextIter start = {0};
	GtkTextIter _tmp0_;
	GtkTextIter end = {0};
	GtkTextIter _tmp1_;
	gboolean result;
#line 330 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 330 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 332 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = *iter;
#line 332 "../libgitg/gitg-diff-view-file-selectable.vala"
	start = _tmp0_;
#line 333 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_iter_forward_line (&start);
#line 335 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = *iter;
#line 335 "../libgitg/gitg-diff-view-file-selectable.vala"
	end = _tmp1_;
#line 336 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_forward_to_hunk_end (self, &end);
#line 338 "../libgitg/gitg-diff-view-file-selectable.vala"
	while (TRUE) {
#line 1194 "gitg-diff-view-file-selectable.c"
		GtkTextIter _tmp2_;
		gboolean _tmp3_ = FALSE;
		GtkTextIter _tmp4_;
#line 338 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp2_ = end;
#line 338 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (!(gtk_text_iter_compare (&start, &_tmp2_) <= 0)) {
#line 338 "../libgitg/gitg-diff-view-file-selectable.vala"
			break;
#line 1204 "gitg-diff-view-file-selectable.c"
		}
#line 340 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp4_ = start;
#line 340 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (gitg_diff_view_file_selectable_get_line_is_diff (self, &_tmp4_)) {
#line 1210 "gitg-diff-view-file-selectable.c"
			GtkTextIter _tmp5_;
#line 340 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp5_ = start;
#line 340 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp3_ = !gitg_diff_view_file_selectable_get_line_selected (self, &_tmp5_);
#line 1216 "gitg-diff-view-file-selectable.c"
		} else {
#line 340 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp3_ = FALSE;
#line 1220 "gitg-diff-view-file-selectable.c"
		}
#line 340 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (_tmp3_) {
#line 342 "../libgitg/gitg-diff-view-file-selectable.vala"
			result = FALSE;
#line 342 "../libgitg/gitg-diff-view-file-selectable.vala"
			return result;
#line 1228 "gitg-diff-view-file-selectable.c"
		}
#line 345 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (!gtk_text_iter_forward_line (&start)) {
#line 347 "../libgitg/gitg-diff-view-file-selectable.vala"
			break;
#line 1234 "gitg-diff-view-file-selectable.c"
		}
	}
#line 351 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = TRUE;
#line 351 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1241 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_update_selection_hunk (GitgDiffViewFileSelectable* self,
                                                      GtkTextIter* iter,
                                                      gboolean select)
{
	GtkTextIter end = {0};
	GtkTextIter _tmp0_;
	GtkTextIter _tmp1_;
	GtkTextIter _tmp2_;
#line 354 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 354 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (iter != NULL);
#line 356 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = *iter;
#line 356 "../libgitg/gitg-diff-view-file-selectable.vala"
	end = _tmp0_;
#line 357 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_forward_to_hunk_end (self, &end);
#line 359 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = *iter;
#line 359 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = end;
#line 359 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_update_selection_range (self, &_tmp1_, &_tmp2_, select);
#line 1269 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_button_press_event_on_view (GitgDiffViewFileSelectable* self,
                                                           GdkEventButton* event)
{
	GtkTextIter iter = {0};
	GtkTextIter _tmp0_ = {0};
	gboolean _tmp1_;
	GtkTextBuffer* buffer = NULL;
	GtkSourceView* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GtkTextBuffer* _tmp4_;
	GtkTextBuffer* _tmp5_;
	GtkTextIter _tmp7_;
	gboolean select = FALSE;
	GtkTextIter _tmp10_;
	GeeHashMap* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextMark* _tmp13_;
	GtkTextIter _tmp14_;
	GtkTextBuffer* _tmp15_;
	GtkTextMark* _tmp16_;
	GtkTextIter _tmp17_;
	GtkTextIter _tmp18_;
	gboolean result;
#line 362 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 362 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 364 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (event->button != ((guint) 1)) {
#line 366 "../libgitg/gitg-diff-view-file-selectable.vala"
		result = FALSE;
#line 366 "../libgitg/gitg-diff-view-file-selectable.vala"
		return result;
#line 1306 "gitg-diff-view-file-selectable.c"
	}
#line 371 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = gitg_diff_view_file_selectable_get_iter_from_pointer_position (self, &_tmp0_);
#line 371 "../libgitg/gitg-diff-view-file-selectable.vala"
	iter = _tmp0_;
#line 371 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (!_tmp1_) {
#line 373 "../libgitg/gitg-diff-view-file-selectable.vala"
		result = FALSE;
#line 373 "../libgitg/gitg-diff-view-file-selectable.vala"
		return result;
#line 1318 "gitg-diff-view-file-selectable.c"
	}
#line 376 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = self->priv->_source_view;
#line 376 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp2_);
#line 376 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = _tmp3_;
#line 376 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 376 "../libgitg/gitg-diff-view-file-selectable.vala"
	buffer = _tmp5_;
#line 378 "../libgitg/gitg-diff-view-file-selectable.vala"
	if ((event->state & GDK_SHIFT_MASK) != 0) {
#line 1332 "gitg-diff-view-file-selectable.c"
		GtkTextIter _tmp6_;
#line 380 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp6_ = iter;
#line 380 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_update_selection (self, &_tmp6_);
#line 381 "../libgitg/gitg-diff-view-file-selectable.vala"
		result = TRUE;
#line 381 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (buffer);
#line 381 "../libgitg/gitg-diff-view-file-selectable.vala"
		return result;
#line 1344 "gitg-diff-view-file-selectable.c"
	}
#line 384 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp7_ = iter;
#line 384 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (gitg_diff_view_file_selectable_get_line_is_hunk (self, &_tmp7_)) {
#line 1350 "gitg-diff-view-file-selectable.c"
		GtkTextIter _tmp8_;
		GtkTextIter _tmp9_;
#line 386 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp8_ = iter;
#line 386 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp9_ = iter;
#line 386 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_update_selection_hunk (self, &_tmp8_, !gitg_diff_view_file_selectable_hunk_is_all_selected (self, &_tmp9_));
#line 387 "../libgitg/gitg-diff-view-file-selectable.vala"
		result = TRUE;
#line 387 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (buffer);
#line 387 "../libgitg/gitg-diff-view-file-selectable.vala"
		return result;
#line 1365 "gitg-diff-view-file-selectable.c"
	}
#line 390 "../libgitg/gitg-diff-view-file-selectable.vala"
	self->priv->d_is_rubber_band = TRUE;
#line 392 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp10_ = iter;
#line 392 "../libgitg/gitg-diff-view-file-selectable.vala"
	select = !gitg_diff_view_file_selectable_get_line_selected (self, &_tmp10_);
#line 394 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (select) {
#line 396 "../libgitg/gitg-diff-view-file-selectable.vala"
		self->priv->d_selection_mode = GITG_DIFF_SELECTION_MODE_SELECTING;
#line 1377 "gitg-diff-view-file-selectable.c"
	} else {
#line 400 "../libgitg/gitg-diff-view-file-selectable.vala"
		self->priv->d_selection_mode = GITG_DIFF_SELECTION_MODE_DESELECTING;
#line 1381 "gitg-diff-view-file-selectable.c"
	}
#line 403 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp11_ = self->priv->d_originally_selected;
#line 403 "../libgitg/gitg-diff-view-file-selectable.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp11_);
#line 405 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp12_ = buffer;
#line 405 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp13_ = self->priv->d_start_selection_mark;
#line 405 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp14_ = iter;
#line 405 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_buffer_move_mark (_tmp12_, _tmp13_, &_tmp14_);
#line 406 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp15_ = buffer;
#line 406 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp16_ = self->priv->d_end_selection_mark;
#line 406 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp17_ = iter;
#line 406 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_buffer_move_mark (_tmp15_, _tmp16_, &_tmp17_);
#line 408 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp18_ = iter;
#line 408 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_update_selection (self, &_tmp18_);
#line 410 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = TRUE;
#line 410 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (buffer);
#line 410 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1413 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_update_selection (GitgDiffViewFileSelectable* self,
                                                 GtkTextIter* cursor)
{
	GtkTextBuffer* buffer = NULL;
	GtkSourceView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp4_;
	GtkTextMark* _tmp5_;
	GtkTextIter _tmp6_ = {0};
	GtkTextBuffer* _tmp7_;
	GtkTextMark* _tmp8_;
	GtkTextIter _tmp9_ = {0};
	GtkTextIter _tmp17_;
	GtkTextIter _tmp18_;
	GtkTextBuffer* _tmp19_;
	GtkTextMark* _tmp20_;
	GtkTextIter _tmp21_;
#line 413 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 413 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (cursor != NULL);
#line 415 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->_source_view;
#line 415 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp0_);
#line 415 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = _tmp1_;
#line 415 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 415 "../libgitg/gitg-diff-view-file-selectable.vala"
	buffer = _tmp3_;
#line 419 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = buffer;
#line 419 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = self->priv->d_start_selection_mark;
#line 419 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_buffer_get_iter_at_mark (_tmp4_, &_tmp6_, _tmp5_);
#line 419 "../libgitg/gitg-diff-view-file-selectable.vala"
	start = _tmp6_;
#line 420 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp7_ = buffer;
#line 420 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp8_ = self->priv->d_end_selection_mark;
#line 420 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_buffer_get_iter_at_mark (_tmp7_, &_tmp9_, _tmp8_);
#line 420 "../libgitg/gitg-diff-view-file-selectable.vala"
	end = _tmp9_;
#line 423 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (gtk_text_iter_get_line (&start) < gtk_text_iter_get_line (&end)) {
#line 1470 "gitg-diff-view-file-selectable.c"
		GtkTextIter _tmp10_ = {0};
		GtkTextIter next = {0};
		GtkTextIter _tmp13_;
		GtkTextIter _tmp14_;
#line 425 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (gtk_text_iter_get_line (&start) < gtk_text_iter_get_line (cursor)) {
#line 1477 "gitg-diff-view-file-selectable.c"
			GtkTextIter _tmp11_;
#line 425 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp11_ = *cursor;
#line 425 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp10_ = _tmp11_;
#line 1483 "gitg-diff-view-file-selectable.c"
		} else {
			GtkTextIter _tmp12_;
#line 425 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp12_ = start;
#line 425 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp10_ = _tmp12_;
#line 1490 "gitg-diff-view-file-selectable.c"
		}
#line 425 "../libgitg/gitg-diff-view-file-selectable.vala"
		next = _tmp10_;
#line 426 "../libgitg/gitg-diff-view-file-selectable.vala"
		gtk_text_iter_forward_line (&next);
#line 428 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp13_ = next;
#line 428 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp14_ = end;
#line 428 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_clear_original_selection (self, &_tmp13_, &_tmp14_, TRUE);
#line 1502 "gitg-diff-view-file-selectable.c"
	} else {
		GtkTextIter _tmp15_;
		GtkTextIter _tmp16_;
#line 432 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp15_ = end;
#line 432 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp16_ = *cursor;
#line 432 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_clear_original_selection (self, &_tmp15_, &_tmp16_, FALSE);
#line 1512 "gitg-diff-view-file-selectable.c"
	}
#line 435 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp17_ = start;
#line 435 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp18_ = *cursor;
#line 435 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_update_selection_range (self, &_tmp17_, &_tmp18_, self->priv->d_selection_mode == GITG_DIFF_SELECTION_MODE_SELECTING);
#line 436 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp19_ = buffer;
#line 436 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp20_ = self->priv->d_end_selection_mark;
#line 436 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp21_ = *cursor;
#line 436 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_buffer_move_mark (_tmp19_, _tmp20_, &_tmp21_);
#line 413 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (buffer);
#line 1530 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_update_selection_event (GitgDiffViewFileSelectable* self,
                                                       GdkModifierType state,
                                                       gint x,
                                                       gint y)
{
	GtkTextIter iter = {0};
	GtkTextIter _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkTextIter _tmp12_;
	gboolean result;
#line 439 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 443 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = gitg_diff_view_file_selectable_get_iter_from_event_position (self, &_tmp0_, x, y);
#line 443 "../libgitg/gitg-diff-view-file-selectable.vala"
	iter = _tmp0_;
#line 443 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (!_tmp1_) {
#line 445 "../libgitg/gitg-diff-view-file-selectable.vala"
		result = FALSE;
#line 445 "../libgitg/gitg-diff-view-file-selectable.vala"
		return result;
#line 1557 "gitg-diff-view-file-selectable.c"
	}
#line 448 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (self->priv->d_is_rubber_band) {
#line 448 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp2_ = TRUE;
#line 1563 "gitg-diff-view-file-selectable.c"
	} else {
		gboolean _tmp3_ = FALSE;
		GtkTextIter _tmp4_;
#line 448 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp4_ = iter;
#line 448 "../libgitg/gitg-diff-view-file-selectable.vala"
		if (gitg_diff_view_file_selectable_get_line_is_diff (self, &_tmp4_)) {
#line 448 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp3_ = TRUE;
#line 1573 "gitg-diff-view-file-selectable.c"
		} else {
			GtkTextIter _tmp5_;
#line 448 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp5_ = iter;
#line 448 "../libgitg/gitg-diff-view-file-selectable.vala"
			_tmp3_ = gitg_diff_view_file_selectable_get_line_is_hunk (self, &_tmp5_);
#line 1580 "gitg-diff-view-file-selectable.c"
		}
#line 448 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp2_ = _tmp3_;
#line 1584 "gitg-diff-view-file-selectable.c"
	}
#line 448 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp2_) {
#line 1588 "gitg-diff-view-file-selectable.c"
		GdkCursor* _tmp6_;
		GdkCursor* _tmp7_;
		GdkCursor* _tmp8_;
#line 450 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp6_ = gitg_diff_view_file_selectable_get_cursor_hand (self);
#line 450 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp7_ = _tmp6_;
#line 450 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp8_ = _tmp7_;
#line 450 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_update_cursor (self, _tmp8_);
#line 450 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (_tmp8_);
#line 1602 "gitg-diff-view-file-selectable.c"
	} else {
		GdkCursor* _tmp9_;
		GdkCursor* _tmp10_;
		GdkCursor* _tmp11_;
#line 454 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp9_ = gitg_diff_view_file_selectable_get_cursor_ptr (self);
#line 454 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp10_ = _tmp9_;
#line 454 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp11_ = _tmp10_;
#line 454 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_update_cursor (self, _tmp11_);
#line 454 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (_tmp11_);
#line 1617 "gitg-diff-view-file-selectable.c"
	}
#line 457 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (!self->priv->d_is_rubber_band) {
#line 459 "../libgitg/gitg-diff-view-file-selectable.vala"
		result = FALSE;
#line 459 "../libgitg/gitg-diff-view-file-selectable.vala"
		return result;
#line 1625 "gitg-diff-view-file-selectable.c"
	}
#line 462 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp12_ = iter;
#line 462 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_update_selection (self, &_tmp12_);
#line 463 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = TRUE;
#line 463 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1635 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_motion_notify_event_on_view (GitgDiffViewFileSelectable* self,
                                                            GdkEventMotion* event)
{
	gboolean result;
#line 466 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 466 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 468 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = gitg_diff_view_file_selectable_update_selection_event (self, event->state, (gint) event->x, (gint) event->y);
#line 468 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1651 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_leave_notify_event_on_view (GitgDiffViewFileSelectable* self,
                                                           GdkEventCrossing* event)
{
	gboolean result;
#line 471 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 471 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 473 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = gitg_diff_view_file_selectable_update_selection_event (self, event->state, (gint) event->x, (gint) event->y);
#line 473 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1667 "gitg-diff-view-file-selectable.c"
}

static gboolean
gitg_diff_view_file_selectable_enter_notify_event_on_view (GitgDiffViewFileSelectable* self,
                                                           GdkEventCrossing* event)
{
	gboolean result;
#line 476 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 476 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 478 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = gitg_diff_view_file_selectable_update_selection_event (self, event->state, (gint) event->x, (gint) event->y);
#line 478 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1683 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_update_has_selection (GitgDiffViewFileSelectable* self)
{
	GtkSourceBuffer* buffer = NULL;
	GtkSourceView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextIter iter = {0};
	GtkSourceBuffer* _tmp3_;
	GtkTextIter _tmp4_ = {0};
	gboolean something_selected = FALSE;
	GtkTextIter _tmp5_;
	gboolean _tmp9_;
#line 481 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 483 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->_source_view;
#line 483 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp0_);
#line 483 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = _tmp1_;
#line 483 "../libgitg/gitg-diff-view-file-selectable.vala"
	buffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_source_buffer_get_type (), GtkSourceBuffer);
#line 486 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = buffer;
#line 486 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_buffer_get_start_iter ((GtkTextBuffer*) _tmp3_, &_tmp4_);
#line 486 "../libgitg/gitg-diff-view-file-selectable.vala"
	iter = _tmp4_;
#line 488 "../libgitg/gitg-diff-view-file-selectable.vala"
	something_selected = FALSE;
#line 490 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = iter;
#line 490 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (gitg_diff_view_file_selectable_get_line_selected (self, &_tmp5_)) {
#line 492 "../libgitg/gitg-diff-view-file-selectable.vala"
		something_selected = TRUE;
#line 1723 "gitg-diff-view-file-selectable.c"
	} else {
		GtkSourceBuffer* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_;
#line 496 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp6_ = buffer;
#line 496 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp7_ = self->priv->d_selection_category;
#line 496 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp8_ = gtk_source_buffer_forward_iter_to_source_mark (_tmp6_, &iter, _tmp7_);
#line 496 "../libgitg/gitg-diff-view-file-selectable.vala"
		something_selected = _tmp8_;
#line 1736 "gitg-diff-view-file-selectable.c"
	}
#line 499 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp9_ = self->priv->_has_selection;
#line 499 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (something_selected != _tmp9_) {
#line 501 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_set_has_selection (self, something_selected);
#line 1744 "gitg-diff-view-file-selectable.c"
	}
}

static gboolean
gitg_diff_view_file_selectable_button_release_event_on_view (GitgDiffViewFileSelectable* self,
                                                             GdkEventButton* event)
{
	gboolean result;
#line 505 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 505 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 507 "../libgitg/gitg-diff-view-file-selectable.vala"
	self->priv->d_is_rubber_band = FALSE;
#line 509 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (event->button != ((guint) 1)) {
#line 511 "../libgitg/gitg-diff-view-file-selectable.vala"
		result = FALSE;
#line 511 "../libgitg/gitg-diff-view-file-selectable.vala"
		return result;
#line 1765 "gitg-diff-view-file-selectable.c"
	}
#line 514 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_update_has_selection (self);
#line 516 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = TRUE;
#line 516 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1773 "gitg-diff-view-file-selectable.c"
}

GtkSourceView*
gitg_diff_view_file_selectable_get_source_view (GitgDiffViewFileSelectable* self)
{
	GtkSourceView* result;
	GtkSourceView* _tmp0_;
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->_source_view;
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = _tmp0_;
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1789 "gitg-diff-view-file-selectable.c"
}

void
gitg_diff_view_file_selectable_set_source_view (GitgDiffViewFileSelectable* self,
                                                GtkSourceView* value)
{
	GtkSourceView* old_value;
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
	old_value = gitg_diff_view_file_selectable_get_source_view (self);
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (old_value != value) {
#line 1803 "gitg-diff-view-file-selectable.c"
		GtkSourceView* _tmp0_;
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (self->priv->_source_view);
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
		self->priv->_source_view = _tmp0_;
#line 40 "../libgitg/gitg-diff-view-file-selectable.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_diff_view_file_selectable_properties[GITG_DIFF_VIEW_FILE_SELECTABLE_SOURCE_VIEW_PROPERTY]);
#line 1813 "gitg-diff-view-file-selectable.c"
	}
}

gboolean
gitg_diff_view_file_selectable_get_has_selection (GitgDiffViewFileSelectable* self)
{
	gboolean result;
#line 45 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = self->priv->_has_selection;
#line 45 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1827 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_set_has_selection (GitgDiffViewFileSelectable* self,
                                                  gboolean value)
{
	gboolean old_value;
#line 45 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_if_fail (self != NULL);
#line 45 "../libgitg/gitg-diff-view-file-selectable.vala"
	old_value = gitg_diff_view_file_selectable_get_has_selection (self);
#line 45 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (old_value != value) {
#line 45 "../libgitg/gitg-diff-view-file-selectable.vala"
		self->priv->_has_selection = value;
#line 45 "../libgitg/gitg-diff-view-file-selectable.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_diff_view_file_selectable_properties[GITG_DIFF_VIEW_FILE_SELECTABLE_HAS_SELECTION_PROPERTY]);
#line 1845 "gitg-diff-view-file-selectable.c"
	}
}

static GdkCursor*
gitg_diff_view_file_selectable_get_cursor_ptr (GitgDiffViewFileSelectable* self)
{
	GdkCursor* result;
	GdkCursor* _tmp0_;
	GdkCursor* _tmp4_;
	GdkCursor* _tmp5_;
#line 102 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->d_cursor_ptr;
#line 104 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp0_ == NULL) {
#line 1862 "gitg-diff-view-file-selectable.c"
		GtkSourceView* _tmp1_;
		GdkDisplay* _tmp2_;
		GdkCursor* _tmp3_;
#line 106 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp1_ = self->priv->_source_view;
#line 106 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp2_ = gtk_widget_get_display ((GtkWidget*) _tmp1_);
#line 106 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_LEFT_PTR);
#line 106 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (self->priv->d_cursor_ptr);
#line 106 "../libgitg/gitg-diff-view-file-selectable.vala"
		self->priv->d_cursor_ptr = _tmp3_;
#line 1876 "gitg-diff-view-file-selectable.c"
	}
#line 109 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = self->priv->d_cursor_ptr;
#line 109 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 109 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = _tmp5_;
#line 109 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1886 "gitg-diff-view-file-selectable.c"
}

static GdkCursor*
gitg_diff_view_file_selectable_get_cursor_hand (GitgDiffViewFileSelectable* self)
{
	GdkCursor* result;
	GdkCursor* _tmp0_;
	GdkCursor* _tmp4_;
	GdkCursor* _tmp5_;
#line 115 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->d_cursor_hand;
#line 117 "../libgitg/gitg-diff-view-file-selectable.vala"
	if (_tmp0_ == NULL) {
#line 1902 "gitg-diff-view-file-selectable.c"
		GtkSourceView* _tmp1_;
		GdkDisplay* _tmp2_;
		GdkCursor* _tmp3_;
#line 119 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp1_ = self->priv->_source_view;
#line 119 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp2_ = gtk_widget_get_display ((GtkWidget*) _tmp1_);
#line 119 "../libgitg/gitg-diff-view-file-selectable.vala"
		_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_HAND1);
#line 119 "../libgitg/gitg-diff-view-file-selectable.vala"
		_g_object_unref0 (self->priv->d_cursor_hand);
#line 119 "../libgitg/gitg-diff-view-file-selectable.vala"
		self->priv->d_cursor_hand = _tmp3_;
#line 1916 "gitg-diff-view-file-selectable.c"
	}
#line 122 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = self->priv->d_cursor_hand;
#line 122 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 122 "../libgitg/gitg-diff-view-file-selectable.vala"
	result = _tmp5_;
#line 122 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1926 "gitg-diff-view-file-selectable.c"
}

static gboolean
_gitg_diff_view_file_selectable_button_press_event_on_view_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                          GdkEventButton* event,
                                                                                          gpointer self)
{
	gboolean result;
	result = gitg_diff_view_file_selectable_button_press_event_on_view ((GitgDiffViewFileSelectable*) self, event);
#line 72 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1938 "gitg-diff-view-file-selectable.c"
}

static gboolean
_gitg_diff_view_file_selectable_motion_notify_event_on_view_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                            GdkEventMotion* event,
                                                                                            gpointer self)
{
	gboolean result;
	result = gitg_diff_view_file_selectable_motion_notify_event_on_view ((GitgDiffViewFileSelectable*) self, event);
#line 73 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1950 "gitg-diff-view-file-selectable.c"
}

static gboolean
_gitg_diff_view_file_selectable_leave_notify_event_on_view_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                                          GdkEventCrossing* event,
                                                                                          gpointer self)
{
	gboolean result;
	result = gitg_diff_view_file_selectable_leave_notify_event_on_view ((GitgDiffViewFileSelectable*) self, event);
#line 74 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1962 "gitg-diff-view-file-selectable.c"
}

static gboolean
_gitg_diff_view_file_selectable_enter_notify_event_on_view_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                                          GdkEventCrossing* event,
                                                                                          gpointer self)
{
	gboolean result;
	result = gitg_diff_view_file_selectable_enter_notify_event_on_view ((GitgDiffViewFileSelectable*) self, event);
#line 75 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1974 "gitg-diff-view-file-selectable.c"
}

static gboolean
_gitg_diff_view_file_selectable_button_release_event_on_view_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                              GdkEventButton* event,
                                                                                              gpointer self)
{
	gboolean result;
	result = gitg_diff_view_file_selectable_button_release_event_on_view ((GitgDiffViewFileSelectable*) self, event);
#line 76 "../libgitg/gitg-diff-view-file-selectable.vala"
	return result;
#line 1986 "gitg-diff-view-file-selectable.c"
}

static void
_gitg_diff_view_file_selectable___lambda51_ (GitgDiffViewFileSelectable* self)
{
	GdkCursor* _tmp0_;
	GdkCursor* _tmp1_;
	GdkCursor* _tmp2_;
#line 79 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = gitg_diff_view_file_selectable_get_cursor_ptr (self);
#line 79 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = _tmp0_;
#line 79 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = _tmp1_;
#line 79 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_update_cursor (self, _tmp2_);
#line 79 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (_tmp2_);
#line 2005 "gitg-diff-view-file-selectable.c"
}

static void
__gitg_diff_view_file_selectable___lambda51__gtk_widget_realize (GtkWidget* _sender,
                                                                 gpointer self)
{
#line 78 "../libgitg/gitg-diff-view-file-selectable.vala"
	_gitg_diff_view_file_selectable___lambda51_ ((GitgDiffViewFileSelectable*) self);
#line 2014 "gitg-diff-view-file-selectable.c"
}

static void
_gitg_diff_view_file_selectable___lambda52_ (GitgDiffViewFileSelectable* self)
{
	GdkCursor* _tmp0_;
	GdkCursor* _tmp1_;
	GdkCursor* _tmp2_;
#line 83 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = gitg_diff_view_file_selectable_get_cursor_ptr (self);
#line 83 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = _tmp0_;
#line 83 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = _tmp1_;
#line 83 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_update_cursor (self, _tmp2_);
#line 83 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (_tmp2_);
#line 2033 "gitg-diff-view-file-selectable.c"
}

static void
__gitg_diff_view_file_selectable___lambda52__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 82 "../libgitg/gitg-diff-view-file-selectable.vala"
	_gitg_diff_view_file_selectable___lambda52_ ((GitgDiffViewFileSelectable*) self);
#line 2043 "gitg-diff-view-file-selectable.c"
}

static void
_gitg_diff_view_file_selectable_update_theme_gtk_widget_style_updated (GtkWidget* _sender,
                                                                       gpointer self)
{
#line 88 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_update_theme ((GitgDiffViewFileSelectable*) self);
#line 2052 "gitg-diff-view-file-selectable.c"
}

static GObject *
gitg_diff_view_file_selectable_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GitgDiffViewFileSelectable * self;
	GtkSourceView* _tmp0_;
	GtkSourceView* _tmp1_;
	GtkSourceView* _tmp2_;
	GtkSourceView* _tmp3_;
	GtkSourceView* _tmp4_;
	GtkSourceView* _tmp5_;
	GtkSourceView* _tmp6_;
	GtkSourceView* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextTag* _tmp10_;
	GtkTextTag* _tmp11_;
	GtkSourceView* _tmp12_;
	GeeHashMap* _tmp13_;
	GtkTextIter start = {0};
	GtkSourceView* _tmp14_;
	GtkTextBuffer* _tmp15_;
	GtkTextBuffer* _tmp16_;
	GtkTextIter _tmp17_ = {0};
	GtkSourceView* _tmp18_;
	GtkTextBuffer* _tmp19_;
	GtkTextBuffer* _tmp20_;
	GtkTextIter _tmp21_;
	GtkTextMark* _tmp22_;
	GtkTextMark* _tmp23_;
	GtkSourceView* _tmp24_;
	GtkTextBuffer* _tmp25_;
	GtkTextBuffer* _tmp26_;
	GtkTextIter _tmp27_;
	GtkTextMark* _tmp28_;
	GtkTextMark* _tmp29_;
#line 70 "../libgitg/gitg-diff-view-file-selectable.vala"
	parent_class = G_OBJECT_CLASS (gitg_diff_view_file_selectable_parent_class);
#line 70 "../libgitg/gitg-diff-view-file-selectable.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 70 "../libgitg/gitg-diff-view-file-selectable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE, GitgDiffViewFileSelectable);
#line 72 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = self->priv->_source_view;
#line 72 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_signal_connect_object ((GtkWidget*) _tmp0_, "button-press-event", (GCallback) _gitg_diff_view_file_selectable_button_press_event_on_view_gtk_widget_button_press_event, self, 0);
#line 73 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp1_ = self->priv->_source_view;
#line 73 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_signal_connect_object ((GtkWidget*) _tmp1_, "motion-notify-event", (GCallback) _gitg_diff_view_file_selectable_motion_notify_event_on_view_gtk_widget_motion_notify_event, self, 0);
#line 74 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp2_ = self->priv->_source_view;
#line 74 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_signal_connect_object ((GtkWidget*) _tmp2_, "leave-notify-event", (GCallback) _gitg_diff_view_file_selectable_leave_notify_event_on_view_gtk_widget_leave_notify_event, self, 0);
#line 75 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp3_ = self->priv->_source_view;
#line 75 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_signal_connect_object ((GtkWidget*) _tmp3_, "enter-notify-event", (GCallback) _gitg_diff_view_file_selectable_enter_notify_event_on_view_gtk_widget_enter_notify_event, self, 0);
#line 76 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp4_ = self->priv->_source_view;
#line 76 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_signal_connect_object ((GtkWidget*) _tmp4_, "button-release-event", (GCallback) _gitg_diff_view_file_selectable_button_release_event_on_view_gtk_widget_button_release_event, self, 0);
#line 78 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp5_ = self->priv->_source_view;
#line 78 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_signal_connect_object ((GtkWidget*) _tmp5_, "realize", (GCallback) __gitg_diff_view_file_selectable___lambda51__gtk_widget_realize, self, 0);
#line 82 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp6_ = self->priv->_source_view;
#line 82 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_signal_connect_object ((GObject*) _tmp6_, "notify::state-flags", (GCallback) __gitg_diff_view_file_selectable___lambda52__g_object_notify, self, 0);
#line 86 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp7_ = self->priv->_source_view;
#line 86 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp8_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp7_);
#line 86 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp9_ = _tmp8_;
#line 86 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp10_ = gtk_text_buffer_create_tag (_tmp9_, "selection", NULL);
#line 86 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 86 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_selection_tag);
#line 86 "../libgitg/gitg-diff-view-file-selectable.vala"
	self->priv->d_selection_tag = _tmp11_;
#line 88 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp12_ = self->priv->_source_view;
#line 88 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_signal_connect_object ((GtkWidget*) _tmp12_, "style-updated", (GCallback) _gitg_diff_view_file_selectable_update_theme_gtk_widget_style_updated, self, 0);
#line 89 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_update_theme (self);
#line 91 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp13_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_BOOLEAN, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 91 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_originally_selected);
#line 91 "../libgitg/gitg-diff-view-file-selectable.vala"
	self->priv->d_originally_selected = _tmp13_;
#line 94 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp14_ = self->priv->_source_view;
#line 94 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp15_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp14_);
#line 94 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp16_ = _tmp15_;
#line 94 "../libgitg/gitg-diff-view-file-selectable.vala"
	gtk_text_buffer_get_start_iter (_tmp16_, &_tmp17_);
#line 94 "../libgitg/gitg-diff-view-file-selectable.vala"
	start = _tmp17_;
#line 96 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp18_ = self->priv->_source_view;
#line 96 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp19_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp18_);
#line 96 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp20_ = _tmp19_;
#line 96 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp21_ = start;
#line 96 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp22_ = gtk_text_buffer_create_mark (_tmp20_, NULL, &_tmp21_, FALSE);
#line 96 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 96 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_start_selection_mark);
#line 96 "../libgitg/gitg-diff-view-file-selectable.vala"
	self->priv->d_start_selection_mark = _tmp23_;
#line 97 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp24_ = self->priv->_source_view;
#line 97 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp25_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp24_);
#line 97 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp26_ = _tmp25_;
#line 97 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp27_ = start;
#line 97 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp28_ = gtk_text_buffer_create_mark (_tmp26_, NULL, &_tmp27_, FALSE);
#line 97 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp29_ = _g_object_ref0 (_tmp28_);
#line 97 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_end_selection_mark);
#line 97 "../libgitg/gitg-diff-view-file-selectable.vala"
	self->priv->d_end_selection_mark = _tmp29_;
#line 70 "../libgitg/gitg-diff-view-file-selectable.vala"
	return obj;
#line 2198 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_class_init (GitgDiffViewFileSelectableClass * klass,
                                           gpointer klass_data)
{
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	gitg_diff_view_file_selectable_parent_class = g_type_class_peek_parent (klass);
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_type_class_adjust_private_offset (klass, &GitgDiffViewFileSelectable_private_offset);
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_diff_view_file_selectable_get_property;
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_diff_view_file_selectable_set_property;
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	G_OBJECT_CLASS (klass)->constructor = gitg_diff_view_file_selectable_constructor;
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_diff_view_file_selectable_finalize;
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DIFF_VIEW_FILE_SELECTABLE_SOURCE_VIEW_PROPERTY, gitg_diff_view_file_selectable_properties[GITG_DIFF_VIEW_FILE_SELECTABLE_SOURCE_VIEW_PROPERTY] = g_param_spec_object ("source-view", "source-view", "source-view", gtk_source_view_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_DIFF_VIEW_FILE_SELECTABLE_HAS_SELECTION_PROPERTY, gitg_diff_view_file_selectable_properties[GITG_DIFF_VIEW_FILE_SELECTABLE_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2221 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_instance_init (GitgDiffViewFileSelectable * self,
                                              gpointer klass)
{
	gchar* _tmp0_;
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	self->priv = gitg_diff_view_file_selectable_get_instance_private (self);
#line 28 "../libgitg/gitg-diff-view-file-selectable.vala"
	_tmp0_ = g_strdup ("selection");
#line 28 "../libgitg/gitg-diff-view-file-selectable.vala"
	self->priv->d_selection_category = _tmp0_;
#line 2235 "gitg-diff-view-file-selectable.c"
}

static void
gitg_diff_view_file_selectable_finalize (GObject * obj)
{
	GitgDiffViewFileSelectable * self;
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE, GitgDiffViewFileSelectable);
#line 28 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_free0 (self->priv->d_selection_category);
#line 29 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_selection_tag);
#line 31 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_start_selection_mark);
#line 32 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_end_selection_mark);
#line 33 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_originally_selected);
#line 34 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_cursor_ptr);
#line 35 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->d_cursor_hand);
#line 38 "../libgitg/gitg-diff-view-file-selectable.vala"
	_g_object_unref0 (self->priv->_source_view);
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	G_OBJECT_CLASS (gitg_diff_view_file_selectable_parent_class)->finalize (obj);
#line 2262 "gitg-diff-view-file-selectable.c"
}

 G_GNUC_NO_INLINE static GType
gitg_diff_view_file_selectable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GitgDiffViewFileSelectableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_diff_view_file_selectable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgDiffViewFileSelectable), 0, (GInstanceInitFunc) gitg_diff_view_file_selectable_instance_init, NULL };
	GType gitg_diff_view_file_selectable_type_id;
	gitg_diff_view_file_selectable_type_id = g_type_register_static (G_TYPE_OBJECT, "GitgDiffViewFileSelectable", &g_define_type_info, 0);
	GitgDiffViewFileSelectable_private_offset = g_type_add_instance_private (gitg_diff_view_file_selectable_type_id, sizeof (GitgDiffViewFileSelectablePrivate));
	return gitg_diff_view_file_selectable_type_id;
}

GType
gitg_diff_view_file_selectable_get_type (void)
{
	static gsize gitg_diff_view_file_selectable_type_id__once = 0;
	if (g_once_init_enter (&gitg_diff_view_file_selectable_type_id__once)) {
		GType gitg_diff_view_file_selectable_type_id;
		gitg_diff_view_file_selectable_type_id = gitg_diff_view_file_selectable_get_type_once ();
		g_once_init_leave (&gitg_diff_view_file_selectable_type_id__once, gitg_diff_view_file_selectable_type_id);
	}
	return gitg_diff_view_file_selectable_type_id__once;
}

static void
_vala_gitg_diff_view_file_selectable_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	GitgDiffViewFileSelectable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE, GitgDiffViewFileSelectable);
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	switch (property_id) {
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		case GITG_DIFF_VIEW_FILE_SELECTABLE_SOURCE_VIEW_PROPERTY:
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		g_value_set_object (value, gitg_diff_view_file_selectable_get_source_view (self));
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		break;
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		case GITG_DIFF_VIEW_FILE_SELECTABLE_HAS_SELECTION_PROPERTY:
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		g_value_set_boolean (value, gitg_diff_view_file_selectable_get_has_selection (self));
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		break;
#line 2309 "gitg-diff-view-file-selectable.c"
		default:
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		break;
#line 2315 "gitg-diff-view-file-selectable.c"
	}
}

static void
_vala_gitg_diff_view_file_selectable_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	GitgDiffViewFileSelectable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_DIFF_VIEW_FILE_SELECTABLE, GitgDiffViewFileSelectable);
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
	switch (property_id) {
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		case GITG_DIFF_VIEW_FILE_SELECTABLE_SOURCE_VIEW_PROPERTY:
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_set_source_view (self, g_value_get_object (value));
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		break;
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		case GITG_DIFF_VIEW_FILE_SELECTABLE_HAS_SELECTION_PROPERTY:
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		gitg_diff_view_file_selectable_set_has_selection (self, g_value_get_boolean (value));
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		break;
#line 2341 "gitg-diff-view-file-selectable.c"
		default:
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../libgitg/gitg-diff-view-file-selectable.vala"
		break;
#line 2347 "gitg-diff-view-file-selectable.c"
	}
}

