/* gitg-hook.c generated by valac 0.56.17, the Vala compiler
 * generated from gitg-hook.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2013 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include "libgitg/gitg-platform-support.h"
#include <libgit2-glib/ggit.h>

#define GITG_HOOK_CONFIG_HOOKS_PATH "core.hooksPath"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GITG_HOOK_0_PROPERTY,
	GITG_HOOK_ENVIRONMENT_PROPERTY,
	GITG_HOOK_NAME_PROPERTY,
	GITG_HOOK_WORKING_DIRECTORY_PROPERTY,
	GITG_HOOK_OUTPUT_PROPERTY,
	GITG_HOOK_NUM_PROPERTIES
};
static GParamSpec* gitg_hook_properties[GITG_HOOK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block18Data Block18Data;
typedef struct _Block19Data Block19Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
typedef struct _Block20Data Block20Data;
typedef struct _GitgHookRunData GitgHookRunData;

struct _GitgHookPrivate {
	GeeHashMap* _environment;
	gchar* _name;
	gchar** d_arguments;
	gint d_arguments_length1;
	gint _d_arguments_size_;
	GFile* _working_directory;
	gchar** d_output;
	gint d_output_length1;
	gint _d_output_size_;
};

struct _Block18Data {
	int _ref_count_;
	GitgHook* self;
	GDataInputStream* stream;
};

struct _Block19Data {
	int _ref_count_;
	GitgHook* self;
	GMainLoop* m;
	GError* e;
	gint status;
};

struct _Block20Data {
	int _ref_count_;
	GitgHook* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	gint status;
	gpointer _async_data_;
};

struct _GitgHookRunData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GitgHook* self;
	GgitRepository* repository;
	gint result;
	Block20Data* _data20_;
	gchar** _tmp0_;
	GFile* wd;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* script;
	GFile* _tmp5_;
	gchar** args;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp7_;
	gint args_length1;
	gint _args_size_;
	GFile* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** a_collection;
	gint a_collection_length1;
	gint _a_collection_size_;
	gint a_it;
	gchar* _tmp11_;
	gchar* a;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** env;
	gint _tmp14_;
	gchar** _tmp15_;
	gint env_length1;
	gint _env_size_;
	GPid pid;
	gint pstdout;
	gint pstderr;
	GFile* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	GPid _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	GError* _inner_error0_;
};

static gint GitgHook_private_offset;
static gpointer gitg_hook_parent_class = NULL;

static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static gchar** gitg_hook_flat_environment (GitgHook* self,
                                    gint* result_length1);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add10 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void gitg_hook_stream_read_async (GitgHook* self,
                                  GDataInputStream* stream);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void __lambda12_ (Block18Data* _data18_,
                  GObject* obj,
                  GAsyncResult* res);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void ___lambda12__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void gitg_hook_read_from_fd (GitgHook* self,
                             gint fd);
static GFile* gitg_hook_hook_file (GitgHook* self,
                            GgitRepository* repository);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void __lambda14_ (Block19Data* _data19_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda14__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void gitg_hook_run_data_free (gpointer _data);
static gboolean gitg_hook_run_co (GitgHookRunData* _data_);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static gboolean _gitg_hook_run_co_gsource_func (gpointer self);
static void _vala_array_add12 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void __lambda13_ (Block20Data* _data20_,
                  GPid p,
                  gint st);
static void ___lambda13__gchild_watch_func (GPid pid,
                                     gint wait_status,
                                     gpointer self);
static gchar** _vala_array_dup16 (gchar** self,
                           gssize length);
static GObject * gitg_hook_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void gitg_hook_finalize (GObject * obj);
static GType gitg_hook_get_type_once (void);
static void _vala_gitg_hook_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_gitg_hook_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
gitg_hook_get_instance_private (GitgHook* self)
{
	return G_STRUCT_MEMBER_P (self, GitgHook_private_offset);
}

GitgHook*
gitg_hook_construct (GType object_type,
                     const gchar* name)
{
	GitgHook * self = NULL;
#line 44 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 46 "../libgitg/gitg-hook.vala"
	self = (GitgHook*) g_object_new (object_type, "name", name, NULL);
#line 44 "../libgitg/gitg-hook.vala"
	return self;
#line 254 "gitg-hook.c"
}

GitgHook*
gitg_hook_new (const gchar* name)
{
#line 44 "../libgitg/gitg-hook.vala"
	return gitg_hook_construct (GITG_TYPE_HOOK, name);
#line 262 "gitg-hook.c"
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 51 "../libgitg/gitg-hook.vala"
	if ((*length) == (*size)) {
#line 51 "../libgitg/gitg-hook.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 51 "../libgitg/gitg-hook.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 277 "gitg-hook.c"
	}
#line 51 "../libgitg/gitg-hook.vala"
	(*array)[(*length)++] = value;
#line 51 "../libgitg/gitg-hook.vala"
	(*array)[*length] = NULL;
#line 283 "gitg-hook.c"
}

void
gitg_hook_add_argument (GitgHook* self,
                        const gchar* arg)
{
	gchar* _tmp0_;
#line 49 "../libgitg/gitg-hook.vala"
	g_return_if_fail (self != NULL);
#line 49 "../libgitg/gitg-hook.vala"
	g_return_if_fail (arg != NULL);
#line 51 "../libgitg/gitg-hook.vala"
	_tmp0_ = g_strdup (arg);
#line 51 "../libgitg/gitg-hook.vala"
	_vala_array_add8 (&self->priv->d_arguments, &self->priv->d_arguments_length1, &self->priv->_d_arguments_size_, _tmp0_);
#line 299 "gitg-hook.c"
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 70 "../libgitg/gitg-hook.vala"
	if ((*length) == (*size)) {
#line 70 "../libgitg/gitg-hook.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 70 "../libgitg/gitg-hook.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 314 "gitg-hook.c"
	}
#line 70 "../libgitg/gitg-hook.vala"
	(*array)[(*length)++] = value;
#line 70 "../libgitg/gitg-hook.vala"
	(*array)[*length] = NULL;
#line 320 "gitg-hook.c"
}

static void
_vala_array_add10 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 76 "../libgitg/gitg-hook.vala"
	if ((*length) == (*size)) {
#line 76 "../libgitg/gitg-hook.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 76 "../libgitg/gitg-hook.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 335 "gitg-hook.c"
	}
#line 76 "../libgitg/gitg-hook.vala"
	(*array)[(*length)++] = value;
#line 76 "../libgitg/gitg-hook.vala"
	(*array)[*length] = NULL;
#line 341 "gitg-hook.c"
}

static gchar**
gitg_hook_flat_environment (GitgHook* self,
                            gint* result_length1)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar** env = NULL;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint env_length1;
	gint _env_size_;
	gchar** ret = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GeeHashMap* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gchar** _tmp10_;
	gint ret_length1;
	gint _ret_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** _tmp34_;
	gint _tmp34__length1;
	gchar** result;
#line 54 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../libgitg/gitg-hook.vala"
	_tmp0_ = self->priv->_environment;
#line 56 "../libgitg/gitg-hook.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 56 "../libgitg/gitg-hook.vala"
	_tmp2_ = _tmp1_;
#line 56 "../libgitg/gitg-hook.vala"
	if (_tmp2_ == 0) {
#line 380 "gitg-hook.c"
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 58 "../libgitg/gitg-hook.vala"
		_tmp3_ = NULL;
#line 58 "../libgitg/gitg-hook.vala"
		_tmp3__length1 = 0;
#line 58 "../libgitg/gitg-hook.vala"
		if (result_length1) {
#line 58 "../libgitg/gitg-hook.vala"
			*result_length1 = _tmp3__length1;
#line 391 "gitg-hook.c"
		}
#line 58 "../libgitg/gitg-hook.vala"
		result = _tmp3_;
#line 58 "../libgitg/gitg-hook.vala"
		return result;
#line 397 "gitg-hook.c"
	}
#line 61 "../libgitg/gitg-hook.vala"
	_tmp5_ = _tmp4_ = g_listenv ();
#line 61 "../libgitg/gitg-hook.vala"
	env = _tmp5_;
#line 61 "../libgitg/gitg-hook.vala"
	env_length1 = _vala_array_length (_tmp4_);
#line 61 "../libgitg/gitg-hook.vala"
	_env_size_ = env_length1;
#line 63 "../libgitg/gitg-hook.vala"
	_tmp6_ = env;
#line 63 "../libgitg/gitg-hook.vala"
	_tmp6__length1 = env_length1;
#line 63 "../libgitg/gitg-hook.vala"
	_tmp7_ = self->priv->_environment;
#line 63 "../libgitg/gitg-hook.vala"
	_tmp8_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp7_);
#line 63 "../libgitg/gitg-hook.vala"
	_tmp9_ = _tmp8_;
#line 63 "../libgitg/gitg-hook.vala"
	_tmp10_ = g_new0 (gchar*, (_tmp6__length1 + _tmp9_) + 1);
#line 63 "../libgitg/gitg-hook.vala"
	ret = _tmp10_;
#line 63 "../libgitg/gitg-hook.vala"
	ret_length1 = _tmp6__length1 + _tmp9_;
#line 63 "../libgitg/gitg-hook.vala"
	_ret_size_ = ret_length1;
#line 64 "../libgitg/gitg-hook.vala"
	ret_length1 = 0;
#line 66 "../libgitg/gitg-hook.vala"
	_tmp11_ = env;
#line 66 "../libgitg/gitg-hook.vala"
	_tmp11__length1 = env_length1;
#line 431 "gitg-hook.c"
	{
		gchar** e_collection = NULL;
		gint e_collection_length1 = 0;
		gint _e_collection_size_ = 0;
		gint e_it = 0;
#line 66 "../libgitg/gitg-hook.vala"
		e_collection = _tmp11_;
#line 66 "../libgitg/gitg-hook.vala"
		e_collection_length1 = _tmp11__length1;
#line 66 "../libgitg/gitg-hook.vala"
		for (e_it = 0; e_it < e_collection_length1; e_it = e_it + 1) {
#line 443 "gitg-hook.c"
			gchar* _tmp12_;
			gchar* e = NULL;
#line 66 "../libgitg/gitg-hook.vala"
			_tmp12_ = g_strdup (e_collection[e_it]);
#line 66 "../libgitg/gitg-hook.vala"
			e = _tmp12_;
#line 450 "gitg-hook.c"
			{
				GeeHashMap* _tmp13_;
				const gchar* _tmp14_;
#line 68 "../libgitg/gitg-hook.vala"
				_tmp13_ = self->priv->_environment;
#line 68 "../libgitg/gitg-hook.vala"
				_tmp14_ = e;
#line 68 "../libgitg/gitg-hook.vala"
				if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp13_, _tmp14_)) {
#line 460 "gitg-hook.c"
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
#line 70 "../libgitg/gitg-hook.vala"
					_tmp15_ = e;
#line 70 "../libgitg/gitg-hook.vala"
					_tmp16_ = e;
#line 70 "../libgitg/gitg-hook.vala"
					_tmp17_ = g_getenv (_tmp16_);
#line 70 "../libgitg/gitg-hook.vala"
					_tmp18_ = g_strdup_printf ("%s=%s", _tmp15_, _tmp17_);
#line 70 "../libgitg/gitg-hook.vala"
					_vala_array_add9 (&ret, &ret_length1, &_ret_size_, _tmp18_);
#line 475 "gitg-hook.c"
				}
#line 66 "../libgitg/gitg-hook.vala"
				_g_free0 (e);
#line 479 "gitg-hook.c"
			}
		}
	}
	{
		GeeIterator* _e_it = NULL;
		GeeHashMap* _tmp19_;
		GeeSet* _tmp20_;
		GeeSet* _tmp21_;
		GeeSet* _tmp22_;
		GeeIterator* _tmp23_;
		GeeIterator* _tmp24_;
#line 74 "../libgitg/gitg-hook.vala"
		_tmp19_ = self->priv->_environment;
#line 74 "../libgitg/gitg-hook.vala"
		_tmp20_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp19_);
#line 74 "../libgitg/gitg-hook.vala"
		_tmp21_ = _tmp20_;
#line 74 "../libgitg/gitg-hook.vala"
		_tmp22_ = _tmp21_;
#line 74 "../libgitg/gitg-hook.vala"
		_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 74 "../libgitg/gitg-hook.vala"
		_tmp24_ = _tmp23_;
#line 74 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (_tmp22_);
#line 74 "../libgitg/gitg-hook.vala"
		_e_it = _tmp24_;
#line 74 "../libgitg/gitg-hook.vala"
		while (TRUE) {
#line 509 "gitg-hook.c"
			GeeIterator* _tmp25_;
			gchar* e = NULL;
			GeeIterator* _tmp26_;
			gpointer _tmp27_;
			const gchar* _tmp28_;
			GeeHashMap* _tmp29_;
			const gchar* _tmp30_;
			gpointer _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
#line 74 "../libgitg/gitg-hook.vala"
			_tmp25_ = _e_it;
#line 74 "../libgitg/gitg-hook.vala"
			if (!gee_iterator_next (_tmp25_)) {
#line 74 "../libgitg/gitg-hook.vala"
				break;
#line 526 "gitg-hook.c"
			}
#line 74 "../libgitg/gitg-hook.vala"
			_tmp26_ = _e_it;
#line 74 "../libgitg/gitg-hook.vala"
			_tmp27_ = gee_iterator_get (_tmp26_);
#line 74 "../libgitg/gitg-hook.vala"
			e = (gchar*) _tmp27_;
#line 76 "../libgitg/gitg-hook.vala"
			_tmp28_ = e;
#line 76 "../libgitg/gitg-hook.vala"
			_tmp29_ = self->priv->_environment;
#line 76 "../libgitg/gitg-hook.vala"
			_tmp30_ = e;
#line 76 "../libgitg/gitg-hook.vala"
			_tmp31_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp29_, _tmp30_);
#line 76 "../libgitg/gitg-hook.vala"
			_tmp32_ = (gchar*) _tmp31_;
#line 76 "../libgitg/gitg-hook.vala"
			_tmp33_ = g_strdup_printf ("%s=%s", _tmp28_, _tmp32_);
#line 76 "../libgitg/gitg-hook.vala"
			_vala_array_add10 (&ret, &ret_length1, &_ret_size_, _tmp33_);
#line 76 "../libgitg/gitg-hook.vala"
			_g_free0 (_tmp32_);
#line 74 "../libgitg/gitg-hook.vala"
			_g_free0 (e);
#line 552 "gitg-hook.c"
		}
#line 74 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (_e_it);
#line 556 "gitg-hook.c"
	}
#line 79 "../libgitg/gitg-hook.vala"
	_tmp34_ = ret;
#line 79 "../libgitg/gitg-hook.vala"
	_tmp34__length1 = ret_length1;
#line 79 "../libgitg/gitg-hook.vala"
	if (result_length1) {
#line 79 "../libgitg/gitg-hook.vala"
		*result_length1 = _tmp34__length1;
#line 566 "gitg-hook.c"
	}
#line 79 "../libgitg/gitg-hook.vala"
	result = _tmp34_;
#line 79 "../libgitg/gitg-hook.vala"
	env = (_vala_array_free (env, env_length1, (GDestroyNotify) g_free), NULL);
#line 79 "../libgitg/gitg-hook.vala"
	return result;
#line 574 "gitg-hook.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 82 "../libgitg/gitg-hook.vala"
	return self ? g_object_ref (self) : NULL;
#line 582 "gitg-hook.c"
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 82 "../libgitg/gitg-hook.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 82 "../libgitg/gitg-hook.vala"
	return _data18_;
#line 592 "gitg-hook.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 82 "../libgitg/gitg-hook.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 602 "gitg-hook.c"
		GitgHook* self;
#line 82 "../libgitg/gitg-hook.vala"
		self = _data18_->self;
#line 82 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (_data18_->stream);
#line 82 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (self);
#line 82 "../libgitg/gitg-hook.vala"
		g_slice_free (Block18Data, _data18_);
#line 612 "gitg-hook.c"
	}
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 93 "../libgitg/gitg-hook.vala"
	if ((*length) == (*size)) {
#line 93 "../libgitg/gitg-hook.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 93 "../libgitg/gitg-hook.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 628 "gitg-hook.c"
	}
#line 93 "../libgitg/gitg-hook.vala"
	(*array)[(*length)++] = value;
#line 93 "../libgitg/gitg-hook.vala"
	(*array)[*length] = NULL;
#line 634 "gitg-hook.c"
}

static void
__lambda12_ (Block18Data* _data18_,
             GObject* obj,
             GAsyncResult* res)
{
	GitgHook* self;
	GError* _inner_error0_ = NULL;
#line 84 "../libgitg/gitg-hook.vala"
	self = _data18_->self;
#line 84 "../libgitg/gitg-hook.vala"
	g_return_if_fail (res != NULL);
#line 648 "gitg-hook.c"
	{
		gchar* s = NULL;
		gchar* _tmp0_;
#line 87 "../libgitg/gitg-hook.vala"
		_tmp0_ = g_data_input_stream_read_line_finish (_data18_->stream, res, NULL, &_inner_error0_);
#line 87 "../libgitg/gitg-hook.vala"
		s = _tmp0_;
#line 87 "../libgitg/gitg-hook.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 658 "gitg-hook.c"
			goto __catch0_g_error;
		}
#line 89 "../libgitg/gitg-hook.vala"
		if (s != NULL) {
#line 91 "../libgitg/gitg-hook.vala"
			if (g_utf8_validate (s, (gssize) -1, NULL)) {
#line 665 "gitg-hook.c"
				gchar* _tmp1_;
#line 93 "../libgitg/gitg-hook.vala"
				_tmp1_ = g_strdup (s);
#line 93 "../libgitg/gitg-hook.vala"
				_vala_array_add11 (&self->priv->d_output, &self->priv->d_output_length1, &self->priv->_d_output_size_, _tmp1_);
#line 671 "gitg-hook.c"
			}
#line 97 "../libgitg/gitg-hook.vala"
			gitg_hook_stream_read_async (self, _data18_->stream);
#line 675 "gitg-hook.c"
		}
#line 85 "../libgitg/gitg-hook.vala"
		_g_free0 (s);
#line 679 "gitg-hook.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 85 "../libgitg/gitg-hook.vala"
		g_clear_error (&_inner_error0_);
#line 686 "gitg-hook.c"
	}
	__finally0:
#line 85 "../libgitg/gitg-hook.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../libgitg/gitg-hook.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../libgitg/gitg-hook.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../libgitg/gitg-hook.vala"
		return;
#line 697 "gitg-hook.c"
	}
}

static void
___lambda12__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 84 "../libgitg/gitg-hook.vala"
	__lambda12_ (self, source_object, res);
#line 84 "../libgitg/gitg-hook.vala"
	block18_data_unref (self);
#line 710 "gitg-hook.c"
}

static void
gitg_hook_stream_read_async (GitgHook* self,
                             GDataInputStream* stream)
{
	Block18Data* _data18_;
	GDataInputStream* _tmp0_;
#line 82 "../libgitg/gitg-hook.vala"
	g_return_if_fail (self != NULL);
#line 82 "../libgitg/gitg-hook.vala"
	g_return_if_fail (stream != NULL);
#line 82 "../libgitg/gitg-hook.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 82 "../libgitg/gitg-hook.vala"
	_data18_->_ref_count_ = 1;
#line 82 "../libgitg/gitg-hook.vala"
	_data18_->self = g_object_ref (self);
#line 82 "../libgitg/gitg-hook.vala"
	_tmp0_ = _g_object_ref0 (stream);
#line 82 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (_data18_->stream);
#line 82 "../libgitg/gitg-hook.vala"
	_data18_->stream = _tmp0_;
#line 84 "../libgitg/gitg-hook.vala"
	g_data_input_stream_read_line_async (_data18_->stream, G_PRIORITY_HIGH_IDLE, NULL, ___lambda12__gasync_ready_callback, block18_data_ref (_data18_));
#line 82 "../libgitg/gitg-hook.vala"
	block18_data_unref (_data18_);
#line 82 "../libgitg/gitg-hook.vala"
	_data18_ = NULL;
#line 741 "gitg-hook.c"
}

static void
gitg_hook_read_from_fd (GitgHook* self,
                        gint fd)
{
	GInputStream* stream = NULL;
	GInputStream* _tmp0_;
	GDataInputStream* dstream = NULL;
	GDataInputStream* _tmp1_;
#line 104 "../libgitg/gitg-hook.vala"
	g_return_if_fail (self != NULL);
#line 106 "../libgitg/gitg-hook.vala"
	_tmp0_ = gitg_platform_support_new_input_stream_from_fd (fd, TRUE);
#line 106 "../libgitg/gitg-hook.vala"
	stream = _tmp0_;
#line 107 "../libgitg/gitg-hook.vala"
	_tmp1_ = g_data_input_stream_new (stream);
#line 107 "../libgitg/gitg-hook.vala"
	dstream = _tmp1_;
#line 109 "../libgitg/gitg-hook.vala"
	gitg_hook_stream_read_async (self, dstream);
#line 104 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (dstream);
#line 104 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (stream);
#line 768 "gitg-hook.c"
}

static GFile*
gitg_hook_hook_file (GitgHook* self,
                     GgitRepository* repository)
{
	GgitConfig* _tmp0_ = NULL;
	GgitConfig* _tmp1_;
	GgitConfig* config = NULL;
	GgitConfig* _tmp2_;
	gchar* hooks_path = NULL;
	GFile* hooksdir = NULL;
	const gchar* _tmp12_;
	GFile* _tmp13_;
	GFile* script = NULL;
	GFile* _tmp14_;
	const gchar* _tmp15_;
	GFile* _tmp16_;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 112 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (repository != NULL, NULL);
#line 114 "../libgitg/gitg-hook.vala"
	_tmp1_ = ggit_repository_get_config (repository, &_inner_error0_);
#line 114 "../libgitg/gitg-hook.vala"
	_tmp0_ = _tmp1_;
#line 114 "../libgitg/gitg-hook.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../libgitg/gitg-hook.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "../libgitg/gitg-hook.vala"
		g_clear_error (&_inner_error0_);
#line 114 "../libgitg/gitg-hook.vala"
		return NULL;
#line 805 "gitg-hook.c"
	}
#line 114 "../libgitg/gitg-hook.vala"
	_tmp2_ = ggit_config_snapshot (_tmp0_, &_inner_error0_);
#line 114 "../libgitg/gitg-hook.vala"
	config = _tmp2_;
#line 114 "../libgitg/gitg-hook.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 114 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (_tmp0_);
#line 114 "../libgitg/gitg-hook.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 114 "../libgitg/gitg-hook.vala"
		g_clear_error (&_inner_error0_);
#line 114 "../libgitg/gitg-hook.vala"
		return NULL;
#line 821 "gitg-hook.c"
	}
#line 115 "../libgitg/gitg-hook.vala"
	hooks_path = NULL;
#line 825 "gitg-hook.c"
	{
		const gchar* _tmp3_ = NULL;
		GgitConfig* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 117 "../libgitg/gitg-hook.vala"
		_tmp4_ = config;
#line 117 "../libgitg/gitg-hook.vala"
		_tmp5_ = ggit_config_get_string (_tmp4_, GITG_HOOK_CONFIG_HOOKS_PATH, &_inner_error0_);
#line 117 "../libgitg/gitg-hook.vala"
		_tmp3_ = _tmp5_;
#line 117 "../libgitg/gitg-hook.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 839 "gitg-hook.c"
			goto __catch0_g_error;
		}
#line 117 "../libgitg/gitg-hook.vala"
		_tmp6_ = g_strdup (_tmp3_);
#line 117 "../libgitg/gitg-hook.vala"
		_g_free0 (hooks_path);
#line 117 "../libgitg/gitg-hook.vala"
		hooks_path = _tmp6_;
#line 848 "gitg-hook.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GFile* _tmp7_;
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 116 "../libgitg/gitg-hook.vala"
		g_clear_error (&_inner_error0_);
#line 119 "../libgitg/gitg-hook.vala"
		_tmp7_ = ggit_repository_get_location (repository);
#line 119 "../libgitg/gitg-hook.vala"
		_tmp8_ = _tmp7_;
#line 119 "../libgitg/gitg-hook.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 119 "../libgitg/gitg-hook.vala"
		_tmp10_ = _tmp9_;
#line 119 "../libgitg/gitg-hook.vala"
		_tmp11_ = g_strdup_printf ("%s/hooks", _tmp10_);
#line 119 "../libgitg/gitg-hook.vala"
		_g_free0 (hooks_path);
#line 119 "../libgitg/gitg-hook.vala"
		hooks_path = _tmp11_;
#line 119 "../libgitg/gitg-hook.vala"
		_g_free0 (_tmp10_);
#line 119 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (_tmp8_);
#line 878 "gitg-hook.c"
	}
	__finally0:
#line 116 "../libgitg/gitg-hook.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../libgitg/gitg-hook.vala"
		_g_free0 (hooks_path);
#line 116 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (config);
#line 116 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (_tmp0_);
#line 116 "../libgitg/gitg-hook.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../libgitg/gitg-hook.vala"
		g_clear_error (&_inner_error0_);
#line 116 "../libgitg/gitg-hook.vala"
		return NULL;
#line 895 "gitg-hook.c"
	}
#line 121 "../libgitg/gitg-hook.vala"
	_tmp12_ = hooks_path;
#line 121 "../libgitg/gitg-hook.vala"
	_tmp13_ = g_file_new_for_path (_tmp12_);
#line 121 "../libgitg/gitg-hook.vala"
	hooksdir = _tmp13_;
#line 122 "../libgitg/gitg-hook.vala"
	_tmp14_ = hooksdir;
#line 122 "../libgitg/gitg-hook.vala"
	_tmp15_ = self->priv->_name;
#line 122 "../libgitg/gitg-hook.vala"
	_tmp16_ = g_file_resolve_relative_path (_tmp14_, _tmp15_);
#line 122 "../libgitg/gitg-hook.vala"
	script = _tmp16_;
#line 124 "../libgitg/gitg-hook.vala"
	result = script;
#line 124 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (hooksdir);
#line 124 "../libgitg/gitg-hook.vala"
	_g_free0 (hooks_path);
#line 124 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (config);
#line 124 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (_tmp0_);
#line 124 "../libgitg/gitg-hook.vala"
	return result;
#line 923 "gitg-hook.c"
}

gboolean
gitg_hook_exists_in (GitgHook* self,
                     GgitRepository* repository)
{
	GFile* script = NULL;
	GFile* _tmp0_;
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 127 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 127 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (repository != NULL, FALSE);
#line 129 "../libgitg/gitg-hook.vala"
	_tmp0_ = gitg_hook_hook_file (self, repository);
#line 129 "../libgitg/gitg-hook.vala"
	script = _tmp0_;
#line 943 "gitg-hook.c"
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp1_;
#line 133 "../libgitg/gitg-hook.vala"
		_tmp1_ = g_file_query_info (script, G_FILE_ATTRIBUTE_ACCESS_CAN_EXECUTE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 133 "../libgitg/gitg-hook.vala"
		info = _tmp1_;
#line 133 "../libgitg/gitg-hook.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 953 "gitg-hook.c"
			goto __catch0_g_error;
		}
#line 136 "../libgitg/gitg-hook.vala"
		result = g_file_info_get_attribute_boolean (info, G_FILE_ATTRIBUTE_ACCESS_CAN_EXECUTE);
#line 136 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (info);
#line 136 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (script);
#line 136 "../libgitg/gitg-hook.vala"
		return result;
#line 964 "gitg-hook.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 131 "../libgitg/gitg-hook.vala"
		g_clear_error (&_inner_error0_);
#line 140 "../libgitg/gitg-hook.vala"
		result = FALSE;
#line 140 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (script);
#line 140 "../libgitg/gitg-hook.vala"
		return result;
#line 977 "gitg-hook.c"
	}
	__finally0:
#line 131 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (script);
#line 131 "../libgitg/gitg-hook.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../libgitg/gitg-hook.vala"
	g_clear_error (&_inner_error0_);
#line 131 "../libgitg/gitg-hook.vala"
	return _tmp2_;
#line 988 "gitg-hook.c"
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 144 "../libgitg/gitg-hook.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 144 "../libgitg/gitg-hook.vala"
	return _data19_;
#line 998 "gitg-hook.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 144 "../libgitg/gitg-hook.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 1008 "gitg-hook.c"
		GitgHook* self;
#line 144 "../libgitg/gitg-hook.vala"
		self = _data19_->self;
#line 144 "../libgitg/gitg-hook.vala"
		_g_error_free0 (_data19_->e);
#line 144 "../libgitg/gitg-hook.vala"
		_g_main_loop_unref0 (_data19_->m);
#line 144 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (self);
#line 144 "../libgitg/gitg-hook.vala"
		g_slice_free (Block19Data, _data19_);
#line 1020 "gitg-hook.c"
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 157 "../libgitg/gitg-hook.vala"
	return self ? g_error_copy (self) : NULL;
#line 1029 "gitg-hook.c"
}

static void
__lambda14_ (Block19Data* _data19_,
             GObject* obj,
             GAsyncResult* res)
{
	GitgHook* self;
	GMainLoop* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 150 "../libgitg/gitg-hook.vala"
	self = _data19_->self;
#line 150 "../libgitg/gitg-hook.vala"
	g_return_if_fail (res != NULL);
#line 1044 "gitg-hook.c"
	{
		gint _tmp0_ = 0;
#line 153 "../libgitg/gitg-hook.vala"
		_tmp0_ = gitg_hook_run_finish (self, res, &_inner_error0_);
#line 153 "../libgitg/gitg-hook.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 153 "../libgitg/gitg-hook.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1053 "gitg-hook.c"
				goto __catch0_g_spawn_error;
			}
#line 153 "../libgitg/gitg-hook.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 153 "../libgitg/gitg-hook.vala"
			g_clear_error (&_inner_error0_);
#line 153 "../libgitg/gitg-hook.vala"
			return;
#line 1062 "gitg-hook.c"
		}
#line 153 "../libgitg/gitg-hook.vala"
		_data19_->status = _tmp0_;
#line 1066 "gitg-hook.c"
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		GError* _tmp2_;
#line 151 "../libgitg/gitg-hook.vala"
		err = _inner_error0_;
#line 151 "../libgitg/gitg-hook.vala"
		_inner_error0_ = NULL;
#line 157 "../libgitg/gitg-hook.vala"
		_tmp1_ = err;
#line 157 "../libgitg/gitg-hook.vala"
		_tmp2_ = _g_error_copy0 (_tmp1_);
#line 157 "../libgitg/gitg-hook.vala"
		_g_error_free0 (_data19_->e);
#line 157 "../libgitg/gitg-hook.vala"
		_data19_->e = _tmp2_;
#line 151 "../libgitg/gitg-hook.vala"
		_g_error_free0 (err);
#line 1088 "gitg-hook.c"
	}
	__finally0:
#line 151 "../libgitg/gitg-hook.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../libgitg/gitg-hook.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../libgitg/gitg-hook.vala"
		g_clear_error (&_inner_error0_);
#line 151 "../libgitg/gitg-hook.vala"
		return;
#line 1099 "gitg-hook.c"
	}
#line 160 "../libgitg/gitg-hook.vala"
	_tmp3_ = _data19_->m;
#line 160 "../libgitg/gitg-hook.vala"
	g_main_loop_quit (_tmp3_);
#line 1105 "gitg-hook.c"
}

static void
___lambda14__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 150 "../libgitg/gitg-hook.vala"
	__lambda14_ (self, source_object, res);
#line 150 "../libgitg/gitg-hook.vala"
	block19_data_unref (self);
#line 1117 "gitg-hook.c"
}

gint
gitg_hook_run_sync (GitgHook* self,
                    GgitRepository* repository,
                    GError** error)
{
	Block19Data* _data19_;
	GMainLoop* _tmp0_;
	GMainLoop* _tmp1_;
	GError* _tmp2_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 144 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 144 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (repository != NULL, 0);
#line 144 "../libgitg/gitg-hook.vala"
	_data19_ = g_slice_new0 (Block19Data);
#line 144 "../libgitg/gitg-hook.vala"
	_data19_->_ref_count_ = 1;
#line 144 "../libgitg/gitg-hook.vala"
	_data19_->self = g_object_ref (self);
#line 146 "../libgitg/gitg-hook.vala"
	_tmp0_ = g_main_loop_new (NULL, FALSE);
#line 146 "../libgitg/gitg-hook.vala"
	_data19_->m = _tmp0_;
#line 147 "../libgitg/gitg-hook.vala"
	_data19_->e = NULL;
#line 148 "../libgitg/gitg-hook.vala"
	_data19_->status = 0;
#line 150 "../libgitg/gitg-hook.vala"
	gitg_hook_run (self, repository, ___lambda14__gasync_ready_callback, block19_data_ref (_data19_));
#line 163 "../libgitg/gitg-hook.vala"
	_tmp1_ = _data19_->m;
#line 163 "../libgitg/gitg-hook.vala"
	g_main_loop_run (_tmp1_);
#line 165 "../libgitg/gitg-hook.vala"
	_tmp2_ = _data19_->e;
#line 165 "../libgitg/gitg-hook.vala"
	if (_tmp2_ != NULL) {
#line 1159 "gitg-hook.c"
		GError* _tmp3_;
		GError* _tmp4_;
#line 167 "../libgitg/gitg-hook.vala"
		_tmp3_ = _data19_->e;
#line 167 "../libgitg/gitg-hook.vala"
		_tmp4_ = _g_error_copy0 (_tmp3_);
#line 167 "../libgitg/gitg-hook.vala"
		_inner_error0_ = _tmp4_;
#line 167 "../libgitg/gitg-hook.vala"
		if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 1170 "gitg-hook.c"
			gint _tmp5_ = -1;
#line 167 "../libgitg/gitg-hook.vala"
			g_propagate_error (error, _inner_error0_);
#line 167 "../libgitg/gitg-hook.vala"
			block19_data_unref (_data19_);
#line 167 "../libgitg/gitg-hook.vala"
			_data19_ = NULL;
#line 167 "../libgitg/gitg-hook.vala"
			return _tmp5_;
#line 1180 "gitg-hook.c"
		} else {
			gint _tmp6_ = -1;
#line 167 "../libgitg/gitg-hook.vala"
			block19_data_unref (_data19_);
#line 167 "../libgitg/gitg-hook.vala"
			_data19_ = NULL;
#line 167 "../libgitg/gitg-hook.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 167 "../libgitg/gitg-hook.vala"
			g_clear_error (&_inner_error0_);
#line 167 "../libgitg/gitg-hook.vala"
			return _tmp6_;
#line 1193 "gitg-hook.c"
		}
	}
#line 170 "../libgitg/gitg-hook.vala"
	result = _data19_->status;
#line 170 "../libgitg/gitg-hook.vala"
	block19_data_unref (_data19_);
#line 170 "../libgitg/gitg-hook.vala"
	_data19_ = NULL;
#line 170 "../libgitg/gitg-hook.vala"
	return result;
#line 1204 "gitg-hook.c"
}

static void
gitg_hook_run_data_free (gpointer _data)
{
	GitgHookRunData* _data_;
	_data_ = _data;
#line 23 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (_data_->repository);
#line 23 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../libgitg/gitg-hook.vala"
	g_slice_free (GitgHookRunData, _data_);
#line 1218 "gitg-hook.c"
}

void
gitg_hook_run (GitgHook* self,
               GgitRepository* repository,
               GAsyncReadyCallback _callback_,
               gpointer _user_data_)
{
	GitgHookRunData* _data_;
	GitgHook* _tmp0_;
	GgitRepository* _tmp1_;
#line 23 "../libgitg/gitg-hook.vala"
	g_return_if_fail (self != NULL);
#line 23 "../libgitg/gitg-hook.vala"
	g_return_if_fail (repository != NULL);
#line 23 "../libgitg/gitg-hook.vala"
	_data_ = g_slice_new0 (GitgHookRunData);
#line 23 "../libgitg/gitg-hook.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../libgitg/gitg-hook.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gitg_hook_run_data_free);
#line 23 "../libgitg/gitg-hook.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../libgitg/gitg-hook.vala"
	_data_->self = _tmp0_;
#line 23 "../libgitg/gitg-hook.vala"
	_tmp1_ = _g_object_ref0 (repository);
#line 23 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (_data_->repository);
#line 23 "../libgitg/gitg-hook.vala"
	_data_->repository = _tmp1_;
#line 23 "../libgitg/gitg-hook.vala"
	gitg_hook_run_co (_data_);
#line 1252 "gitg-hook.c"
}

gint
gitg_hook_run_finish (GitgHook* self,
                      GAsyncResult* _res_,
                      GError** error)
{
	gint result;
	GitgHookRunData* _data_;
#line 23 "../libgitg/gitg-hook.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 23 "../libgitg/gitg-hook.vala"
	if (NULL == _data_) {
#line 1266 "gitg-hook.c"
		gint _tmp0_ = 0;
#line 23 "../libgitg/gitg-hook.vala"
		return _tmp0_;
#line 1270 "gitg-hook.c"
	}
#line 23 "../libgitg/gitg-hook.vala"
	result = _data_->result;
#line 23 "../libgitg/gitg-hook.vala"
	return result;
#line 1276 "gitg-hook.c"
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 173 "../libgitg/gitg-hook.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 173 "../libgitg/gitg-hook.vala"
	return _data20_;
#line 1286 "gitg-hook.c"
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 173 "../libgitg/gitg-hook.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 1296 "gitg-hook.c"
		GitgHook* self;
#line 173 "../libgitg/gitg-hook.vala"
		self = _data20_->self;
#line 173 "../libgitg/gitg-hook.vala"
		(_data20_->callback_target_destroy_notify == NULL) ? NULL : (_data20_->callback_target_destroy_notify (_data20_->callback_target), NULL);
#line 173 "../libgitg/gitg-hook.vala"
		_data20_->callback = NULL;
#line 173 "../libgitg/gitg-hook.vala"
		_data20_->callback_target = NULL;
#line 173 "../libgitg/gitg-hook.vala"
		_data20_->callback_target_destroy_notify = NULL;
#line 173 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (self);
#line 173 "../libgitg/gitg-hook.vala"
		g_slice_free (Block20Data, _data20_);
#line 1312 "gitg-hook.c"
	}
}

static gboolean
_gitg_hook_run_co_gsource_func (gpointer self)
{
	gboolean result;
	result = gitg_hook_run_co (self);
#line 175 "../libgitg/gitg-hook.vala"
	return result;
#line 1323 "gitg-hook.c"
}

static void
_vala_array_add12 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 196 "../libgitg/gitg-hook.vala"
	if ((*length) == (*size)) {
#line 196 "../libgitg/gitg-hook.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 196 "../libgitg/gitg-hook.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1338 "gitg-hook.c"
	}
#line 196 "../libgitg/gitg-hook.vala"
	(*array)[(*length)++] = value;
#line 196 "../libgitg/gitg-hook.vala"
	(*array)[*length] = NULL;
#line 1344 "gitg-hook.c"
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 200 "../libgitg/gitg-hook.vala"
	if ((*length) == (*size)) {
#line 200 "../libgitg/gitg-hook.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 200 "../libgitg/gitg-hook.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1359 "gitg-hook.c"
	}
#line 200 "../libgitg/gitg-hook.vala"
	(*array)[(*length)++] = value;
#line 200 "../libgitg/gitg-hook.vala"
	(*array)[*length] = NULL;
#line 1365 "gitg-hook.c"
}

static void
__lambda13_ (Block20Data* _data20_,
             GPid p,
             gint st)
{
	GitgHook* self;
	GSourceFunc _tmp0_;
	gpointer _tmp0__target;
#line 225 "../libgitg/gitg-hook.vala"
	self = _data20_->self;
#line 226 "../libgitg/gitg-hook.vala"
	_data20_->status = st;
#line 228 "../libgitg/gitg-hook.vala"
	g_spawn_close_pid (p);
#line 229 "../libgitg/gitg-hook.vala"
	_tmp0_ = _data20_->callback;
#line 229 "../libgitg/gitg-hook.vala"
	_tmp0__target = _data20_->callback_target;
#line 229 "../libgitg/gitg-hook.vala"
	_tmp0_ (_tmp0__target);
#line 1388 "gitg-hook.c"
}

static void
___lambda13__gchild_watch_func (GPid pid,
                                gint wait_status,
                                gpointer self)
{
#line 225 "../libgitg/gitg-hook.vala"
	__lambda13_ (self, pid, wait_status);
#line 1398 "gitg-hook.c"
}

static gboolean
gitg_hook_run_co (GitgHookRunData* _data_)
{
#line 173 "../libgitg/gitg-hook.vala"
	switch (_data_->_state_) {
#line 173 "../libgitg/gitg-hook.vala"
		case 0:
#line 1408 "gitg-hook.c"
		goto _state_0;
#line 173 "../libgitg/gitg-hook.vala"
		case 1:
#line 1412 "gitg-hook.c"
		goto _state_1;
		default:
#line 173 "../libgitg/gitg-hook.vala"
		g_assert_not_reached ();
#line 1417 "gitg-hook.c"
	}
	_state_0:
#line 173 "../libgitg/gitg-hook.vala"
	_data_->_data20_ = g_slice_new0 (Block20Data);
#line 173 "../libgitg/gitg-hook.vala"
	_data_->_data20_->_ref_count_ = 1;
#line 173 "../libgitg/gitg-hook.vala"
	_data_->_data20_->self = g_object_ref (_data_->self);
#line 173 "../libgitg/gitg-hook.vala"
	_data_->_data20_->_async_data_ = _data_;
#line 175 "../libgitg/gitg-hook.vala"
	_data_->_data20_->callback = _gitg_hook_run_co_gsource_func;
#line 175 "../libgitg/gitg-hook.vala"
	_data_->_data20_->callback_target = _data_;
#line 175 "../libgitg/gitg-hook.vala"
	_data_->_data20_->callback_target_destroy_notify = NULL;
#line 177 "../libgitg/gitg-hook.vala"
	_data_->_tmp0_ = g_new0 (gchar*, 256 + 1);
#line 177 "../libgitg/gitg-hook.vala"
	_data_->self->priv->d_output = (_vala_array_free (_data_->self->priv->d_output, _data_->self->priv->d_output_length1, (GDestroyNotify) g_free), NULL);
#line 177 "../libgitg/gitg-hook.vala"
	_data_->self->priv->d_output = _data_->_tmp0_;
#line 177 "../libgitg/gitg-hook.vala"
	_data_->self->priv->d_output_length1 = 256;
#line 177 "../libgitg/gitg-hook.vala"
	_data_->self->priv->_d_output_size_ = _data_->self->priv->d_output_length1;
#line 178 "../libgitg/gitg-hook.vala"
	_data_->self->priv->d_output_length1 = 0;
#line 182 "../libgitg/gitg-hook.vala"
	_data_->_tmp1_ = _data_->self->priv->_working_directory;
#line 182 "../libgitg/gitg-hook.vala"
	if (_data_->_tmp1_ == NULL) {
#line 184 "../libgitg/gitg-hook.vala"
		_data_->_tmp2_ = _data_->self->priv->_working_directory;
#line 184 "../libgitg/gitg-hook.vala"
		_data_->_tmp3_ = _g_object_ref0 (_data_->_tmp2_);
#line 184 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (_data_->wd);
#line 184 "../libgitg/gitg-hook.vala"
		_data_->wd = _data_->_tmp3_;
#line 1458 "gitg-hook.c"
	} else {
#line 188 "../libgitg/gitg-hook.vala"
		_data_->_tmp4_ = ggit_repository_get_workdir (_data_->repository);
#line 188 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (_data_->wd);
#line 188 "../libgitg/gitg-hook.vala"
		_data_->wd = _data_->_tmp4_;
#line 1466 "gitg-hook.c"
	}
#line 191 "../libgitg/gitg-hook.vala"
	_data_->_tmp5_ = gitg_hook_hook_file (_data_->self, _data_->repository);
#line 191 "../libgitg/gitg-hook.vala"
	_data_->script = _data_->_tmp5_;
#line 192 "../libgitg/gitg-hook.vala"
	_data_->_tmp6_ = _data_->self->priv->d_arguments;
#line 192 "../libgitg/gitg-hook.vala"
	_data_->_tmp6__length1 = _data_->self->priv->d_arguments_length1;
#line 192 "../libgitg/gitg-hook.vala"
	_data_->_tmp7_ = g_new0 (gchar*, (_data_->_tmp6__length1 + 1) + 1);
#line 192 "../libgitg/gitg-hook.vala"
	_data_->args = _data_->_tmp7_;
#line 192 "../libgitg/gitg-hook.vala"
	_data_->args_length1 = _data_->_tmp6__length1 + 1;
#line 192 "../libgitg/gitg-hook.vala"
	_data_->_args_size_ = _data_->args_length1;
#line 194 "../libgitg/gitg-hook.vala"
	_data_->args_length1 = 0;
#line 196 "../libgitg/gitg-hook.vala"
	_data_->_tmp8_ = _data_->script;
#line 196 "../libgitg/gitg-hook.vala"
	_data_->_tmp9_ = g_file_get_path (_data_->_tmp8_);
#line 196 "../libgitg/gitg-hook.vala"
	_vala_array_add12 (&_data_->args, &_data_->args_length1, &_data_->_args_size_, _data_->_tmp9_);
#line 198 "../libgitg/gitg-hook.vala"
	_data_->_tmp10_ = _data_->self->priv->d_arguments;
#line 198 "../libgitg/gitg-hook.vala"
	_data_->_tmp10__length1 = _data_->self->priv->d_arguments_length1;
#line 1496 "gitg-hook.c"
	{
#line 198 "../libgitg/gitg-hook.vala"
		_data_->a_collection_length1 = 0;
#line 198 "../libgitg/gitg-hook.vala"
		_data_->_a_collection_size_ = 0;
#line 198 "../libgitg/gitg-hook.vala"
		_data_->a_collection = _data_->_tmp10_;
#line 198 "../libgitg/gitg-hook.vala"
		_data_->a_collection_length1 = _data_->_tmp10__length1;
#line 198 "../libgitg/gitg-hook.vala"
		for (_data_->a_it = 0; _data_->a_it < _data_->a_collection_length1; _data_->a_it = _data_->a_it + 1) {
#line 198 "../libgitg/gitg-hook.vala"
			_data_->_tmp11_ = g_strdup (_data_->a_collection[_data_->a_it]);
#line 198 "../libgitg/gitg-hook.vala"
			_data_->a = _data_->_tmp11_;
#line 1512 "gitg-hook.c"
			{
#line 200 "../libgitg/gitg-hook.vala"
				_data_->_tmp12_ = _data_->a;
#line 200 "../libgitg/gitg-hook.vala"
				_data_->_tmp13_ = g_strdup (_data_->_tmp12_);
#line 200 "../libgitg/gitg-hook.vala"
				_vala_array_add13 (&_data_->args, &_data_->args_length1, &_data_->_args_size_, _data_->_tmp13_);
#line 198 "../libgitg/gitg-hook.vala"
				_g_free0 (_data_->a);
#line 1522 "gitg-hook.c"
			}
		}
	}
#line 203 "../libgitg/gitg-hook.vala"
	_data_->_tmp14_ = 0;
#line 203 "../libgitg/gitg-hook.vala"
	_data_->_tmp15_ = gitg_hook_flat_environment (_data_->self, &_data_->_tmp14_);
#line 203 "../libgitg/gitg-hook.vala"
	_data_->env = _data_->_tmp15_;
#line 203 "../libgitg/gitg-hook.vala"
	_data_->env_length1 = _data_->_tmp14_;
#line 203 "../libgitg/gitg-hook.vala"
	_data_->_env_size_ = _data_->env_length1;
#line 210 "../libgitg/gitg-hook.vala"
	_data_->_tmp16_ = _data_->wd;
#line 210 "../libgitg/gitg-hook.vala"
	_data_->_tmp17_ = g_file_get_path (_data_->_tmp16_);
#line 210 "../libgitg/gitg-hook.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 210 "../libgitg/gitg-hook.vala"
	_data_->_tmp19_ = _data_->args;
#line 210 "../libgitg/gitg-hook.vala"
	_data_->_tmp19__length1 = _data_->args_length1;
#line 210 "../libgitg/gitg-hook.vala"
	_data_->_tmp20_ = 0;
#line 210 "../libgitg/gitg-hook.vala"
	_data_->_tmp21_ = 0;
#line 210 "../libgitg/gitg-hook.vala"
	_data_->_tmp22_ = 0;
#line 210 "../libgitg/gitg-hook.vala"
	g_spawn_async_with_pipes (_data_->_tmp18_, _data_->_tmp19_, _data_->env, G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_data_->_tmp20_, NULL, &_data_->_tmp21_, &_data_->_tmp22_, &_data_->_inner_error0_);
#line 210 "../libgitg/gitg-hook.vala"
	_data_->pid = _data_->_tmp20_;
#line 210 "../libgitg/gitg-hook.vala"
	_data_->pstdout = _data_->_tmp21_;
#line 210 "../libgitg/gitg-hook.vala"
	_data_->pstderr = _data_->_tmp22_;
#line 210 "../libgitg/gitg-hook.vala"
	_g_free0 (_data_->_tmp18_);
#line 210 "../libgitg/gitg-hook.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 210 "../libgitg/gitg-hook.vala"
		if (_data_->_inner_error0_->domain == G_SPAWN_ERROR) {
#line 210 "../libgitg/gitg-hook.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 210 "../libgitg/gitg-hook.vala"
			_data_->env = (_vala_array_free (_data_->env, _data_->env_length1, (GDestroyNotify) g_free), NULL);
#line 210 "../libgitg/gitg-hook.vala"
			_data_->args = (_vala_array_free (_data_->args, _data_->args_length1, (GDestroyNotify) g_free), NULL);
#line 210 "../libgitg/gitg-hook.vala"
			_g_object_unref0 (_data_->script);
#line 210 "../libgitg/gitg-hook.vala"
			_g_object_unref0 (_data_->wd);
#line 210 "../libgitg/gitg-hook.vala"
			block20_data_unref (_data_->_data20_);
#line 210 "../libgitg/gitg-hook.vala"
			_data_->_data20_ = NULL;
#line 210 "../libgitg/gitg-hook.vala"
			g_object_unref (_data_->_async_result);
#line 210 "../libgitg/gitg-hook.vala"
			return FALSE;
#line 1584 "gitg-hook.c"
		} else {
#line 210 "../libgitg/gitg-hook.vala"
			_data_->env = (_vala_array_free (_data_->env, _data_->env_length1, (GDestroyNotify) g_free), NULL);
#line 210 "../libgitg/gitg-hook.vala"
			_data_->args = (_vala_array_free (_data_->args, _data_->args_length1, (GDestroyNotify) g_free), NULL);
#line 210 "../libgitg/gitg-hook.vala"
			_g_object_unref0 (_data_->script);
#line 210 "../libgitg/gitg-hook.vala"
			_g_object_unref0 (_data_->wd);
#line 210 "../libgitg/gitg-hook.vala"
			block20_data_unref (_data_->_data20_);
#line 210 "../libgitg/gitg-hook.vala"
			_data_->_data20_ = NULL;
#line 210 "../libgitg/gitg-hook.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 210 "../libgitg/gitg-hook.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 210 "../libgitg/gitg-hook.vala"
			g_object_unref (_data_->_async_result);
#line 210 "../libgitg/gitg-hook.vala"
			return FALSE;
#line 1606 "gitg-hook.c"
		}
	}
#line 220 "../libgitg/gitg-hook.vala"
	gitg_hook_read_from_fd (_data_->self, _data_->pstdout);
#line 221 "../libgitg/gitg-hook.vala"
	gitg_hook_read_from_fd (_data_->self, _data_->pstderr);
#line 223 "../libgitg/gitg-hook.vala"
	_data_->_data20_->status = 0;
#line 225 "../libgitg/gitg-hook.vala"
	g_child_watch_add_full (G_PRIORITY_LOW, _data_->pid, ___lambda13__gchild_watch_func, block20_data_ref (_data_->_data20_), block20_data_unref);
#line 232 "../libgitg/gitg-hook.vala"
	_data_->_state_ = 1;
#line 232 "../libgitg/gitg-hook.vala"
	return FALSE;
#line 1621 "gitg-hook.c"
	_state_1:
	;
#line 234 "../libgitg/gitg-hook.vala"
	_data_->result = _data_->_data20_->status;
#line 234 "../libgitg/gitg-hook.vala"
	_data_->env = (_vala_array_free (_data_->env, _data_->env_length1, (GDestroyNotify) g_free), NULL);
#line 234 "../libgitg/gitg-hook.vala"
	_data_->args = (_vala_array_free (_data_->args, _data_->args_length1, (GDestroyNotify) g_free), NULL);
#line 234 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (_data_->script);
#line 234 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (_data_->wd);
#line 234 "../libgitg/gitg-hook.vala"
	block20_data_unref (_data_->_data20_);
#line 234 "../libgitg/gitg-hook.vala"
	_data_->_data20_ = NULL;
#line 234 "../libgitg/gitg-hook.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 234 "../libgitg/gitg-hook.vala"
	if (_data_->_state_ != 0) {
#line 234 "../libgitg/gitg-hook.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 234 "../libgitg/gitg-hook.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1646 "gitg-hook.c"
		}
	}
#line 234 "../libgitg/gitg-hook.vala"
	g_object_unref (_data_->_async_result);
#line 234 "../libgitg/gitg-hook.vala"
	return FALSE;
#line 1653 "gitg-hook.c"
}

GeeHashMap*
gitg_hook_get_environment (GitgHook* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 27 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../libgitg/gitg-hook.vala"
	_tmp0_ = self->priv->_environment;
#line 27 "../libgitg/gitg-hook.vala"
	result = _tmp0_;
#line 27 "../libgitg/gitg-hook.vala"
	return result;
#line 1669 "gitg-hook.c"
}

void
gitg_hook_set_environment (GitgHook* self,
                           GeeHashMap* value)
{
	GeeHashMap* old_value;
#line 27 "../libgitg/gitg-hook.vala"
	g_return_if_fail (self != NULL);
#line 27 "../libgitg/gitg-hook.vala"
	old_value = gitg_hook_get_environment (self);
#line 27 "../libgitg/gitg-hook.vala"
	if (old_value != value) {
#line 1683 "gitg-hook.c"
		GeeHashMap* _tmp0_;
#line 27 "../libgitg/gitg-hook.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (self->priv->_environment);
#line 27 "../libgitg/gitg-hook.vala"
		self->priv->_environment = _tmp0_;
#line 27 "../libgitg/gitg-hook.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_hook_properties[GITG_HOOK_ENVIRONMENT_PROPERTY]);
#line 1693 "gitg-hook.c"
	}
}

const gchar*
gitg_hook_get_name (GitgHook* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../libgitg/gitg-hook.vala"
	_tmp0_ = self->priv->_name;
#line 28 "../libgitg/gitg-hook.vala"
	result = _tmp0_;
#line 28 "../libgitg/gitg-hook.vala"
	return result;
#line 1710 "gitg-hook.c"
}

void
gitg_hook_set_name (GitgHook* self,
                    const gchar* value)
{
	gchar* old_value;
#line 28 "../libgitg/gitg-hook.vala"
	g_return_if_fail (self != NULL);
#line 28 "../libgitg/gitg-hook.vala"
	old_value = gitg_hook_get_name (self);
#line 28 "../libgitg/gitg-hook.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1724 "gitg-hook.c"
		gchar* _tmp0_;
#line 28 "../libgitg/gitg-hook.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../libgitg/gitg-hook.vala"
		_g_free0 (self->priv->_name);
#line 28 "../libgitg/gitg-hook.vala"
		self->priv->_name = _tmp0_;
#line 28 "../libgitg/gitg-hook.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_hook_properties[GITG_HOOK_NAME_PROPERTY]);
#line 1734 "gitg-hook.c"
	}
}

GFile*
gitg_hook_get_working_directory (GitgHook* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 30 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../libgitg/gitg-hook.vala"
	_tmp0_ = self->priv->_working_directory;
#line 30 "../libgitg/gitg-hook.vala"
	result = _tmp0_;
#line 30 "../libgitg/gitg-hook.vala"
	return result;
#line 1751 "gitg-hook.c"
}

void
gitg_hook_set_working_directory (GitgHook* self,
                                 GFile* value)
{
	GFile* old_value;
#line 30 "../libgitg/gitg-hook.vala"
	g_return_if_fail (self != NULL);
#line 30 "../libgitg/gitg-hook.vala"
	old_value = gitg_hook_get_working_directory (self);
#line 30 "../libgitg/gitg-hook.vala"
	if (old_value != value) {
#line 1765 "gitg-hook.c"
		GFile* _tmp0_;
#line 30 "../libgitg/gitg-hook.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../libgitg/gitg-hook.vala"
		_g_object_unref0 (self->priv->_working_directory);
#line 30 "../libgitg/gitg-hook.vala"
		self->priv->_working_directory = _tmp0_;
#line 30 "../libgitg/gitg-hook.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_hook_properties[GITG_HOOK_WORKING_DIRECTORY_PROPERTY]);
#line 1775 "gitg-hook.c"
	}
}

static gchar**
_vala_array_dup16 (gchar** self,
                   gssize length)
{
#line 36 "../libgitg/gitg-hook.vala"
	if (length >= 0) {
#line 1785 "gitg-hook.c"
		gchar** result;
		gssize i;
#line 36 "../libgitg/gitg-hook.vala"
		result = g_new0 (gchar*, length + 1);
#line 36 "../libgitg/gitg-hook.vala"
		for (i = 0; i < length; i++) {
#line 1792 "gitg-hook.c"
			gchar* _tmp0_;
#line 36 "../libgitg/gitg-hook.vala"
			_tmp0_ = g_strdup (self[i]);
#line 36 "../libgitg/gitg-hook.vala"
			result[i] = _tmp0_;
#line 1798 "gitg-hook.c"
		}
#line 36 "../libgitg/gitg-hook.vala"
		return result;
#line 1802 "gitg-hook.c"
	}
#line 36 "../libgitg/gitg-hook.vala"
	return NULL;
#line 1806 "gitg-hook.c"
}

gchar**
gitg_hook_get_output (GitgHook* self,
                      gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 36 "../libgitg/gitg-hook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../libgitg/gitg-hook.vala"
	_tmp0_ = self->priv->d_output;
#line 36 "../libgitg/gitg-hook.vala"
	_tmp0__length1 = self->priv->d_output_length1;
#line 36 "../libgitg/gitg-hook.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup16 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 36 "../libgitg/gitg-hook.vala"
	_tmp1__length1 = _tmp0__length1;
#line 36 "../libgitg/gitg-hook.vala"
	_tmp2_ = _tmp1_;
#line 36 "../libgitg/gitg-hook.vala"
	_tmp2__length1 = _tmp1__length1;
#line 36 "../libgitg/gitg-hook.vala"
	if (result_length1) {
#line 36 "../libgitg/gitg-hook.vala"
		*result_length1 = _tmp2__length1;
#line 1838 "gitg-hook.c"
	}
#line 36 "../libgitg/gitg-hook.vala"
	result = _tmp2_;
#line 36 "../libgitg/gitg-hook.vala"
	return result;
#line 1844 "gitg-hook.c"
}

static GObject *
gitg_hook_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GitgHook * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 39 "../libgitg/gitg-hook.vala"
	parent_class = G_OBJECT_CLASS (gitg_hook_parent_class);
#line 39 "../libgitg/gitg-hook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../libgitg/gitg-hook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_HOOK, GitgHook);
#line 41 "../libgitg/gitg-hook.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 41 "../libgitg/gitg-hook.vala"
	_tmp1_ = _tmp0_;
#line 41 "../libgitg/gitg-hook.vala"
	gitg_hook_set_environment (self, _tmp1_);
#line 41 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (_tmp1_);
#line 39 "../libgitg/gitg-hook.vala"
	return obj;
#line 1873 "gitg-hook.c"
}

static void
gitg_hook_class_init (GitgHookClass * klass,
                      gpointer klass_data)
{
#line 23 "../libgitg/gitg-hook.vala"
	gitg_hook_parent_class = g_type_class_peek_parent (klass);
#line 23 "../libgitg/gitg-hook.vala"
	g_type_class_adjust_private_offset (klass, &GitgHook_private_offset);
#line 23 "../libgitg/gitg-hook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_hook_get_property;
#line 23 "../libgitg/gitg-hook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_hook_set_property;
#line 23 "../libgitg/gitg-hook.vala"
	G_OBJECT_CLASS (klass)->constructor = gitg_hook_constructor;
#line 23 "../libgitg/gitg-hook.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_hook_finalize;
#line 23 "../libgitg/gitg-hook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_HOOK_ENVIRONMENT_PROPERTY, gitg_hook_properties[GITG_HOOK_ENVIRONMENT_PROPERTY] = g_param_spec_object ("environment", "environment", "environment", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../libgitg/gitg-hook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_HOOK_NAME_PROPERTY, gitg_hook_properties[GITG_HOOK_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../libgitg/gitg-hook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_HOOK_WORKING_DIRECTORY_PROPERTY, gitg_hook_properties[GITG_HOOK_WORKING_DIRECTORY_PROPERTY] = g_param_spec_object ("working-directory", "working-directory", "working-directory", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../libgitg/gitg-hook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_HOOK_OUTPUT_PROPERTY, gitg_hook_properties[GITG_HOOK_OUTPUT_PROPERTY] = g_param_spec_boxed ("output", "output", "output", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1900 "gitg-hook.c"
}

static void
gitg_hook_instance_init (GitgHook * self,
                         gpointer klass)
{
#line 23 "../libgitg/gitg-hook.vala"
	self->priv = gitg_hook_get_instance_private (self);
#line 1909 "gitg-hook.c"
}

static void
gitg_hook_finalize (GObject * obj)
{
	GitgHook * self;
#line 23 "../libgitg/gitg-hook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_HOOK, GitgHook);
#line 27 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (self->priv->_environment);
#line 28 "../libgitg/gitg-hook.vala"
	_g_free0 (self->priv->_name);
#line 29 "../libgitg/gitg-hook.vala"
	self->priv->d_arguments = (_vala_array_free (self->priv->d_arguments, self->priv->d_arguments_length1, (GDestroyNotify) g_free), NULL);
#line 30 "../libgitg/gitg-hook.vala"
	_g_object_unref0 (self->priv->_working_directory);
#line 32 "../libgitg/gitg-hook.vala"
	self->priv->d_output = (_vala_array_free (self->priv->d_output, self->priv->d_output_length1, (GDestroyNotify) g_free), NULL);
#line 23 "../libgitg/gitg-hook.vala"
	G_OBJECT_CLASS (gitg_hook_parent_class)->finalize (obj);
#line 1930 "gitg-hook.c"
}

 G_GNUC_NO_INLINE static GType
gitg_hook_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GitgHookClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_hook_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgHook), 0, (GInstanceInitFunc) gitg_hook_instance_init, NULL };
	GType gitg_hook_type_id;
	gitg_hook_type_id = g_type_register_static (G_TYPE_OBJECT, "GitgHook", &g_define_type_info, 0);
	GitgHook_private_offset = g_type_add_instance_private (gitg_hook_type_id, sizeof (GitgHookPrivate));
	return gitg_hook_type_id;
}

GType
gitg_hook_get_type (void)
{
	static gsize gitg_hook_type_id__once = 0;
	if (g_once_init_enter (&gitg_hook_type_id__once)) {
		GType gitg_hook_type_id;
		gitg_hook_type_id = gitg_hook_get_type_once ();
		g_once_init_leave (&gitg_hook_type_id__once, gitg_hook_type_id);
	}
	return gitg_hook_type_id__once;
}

static void
_vala_gitg_hook_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	GitgHook * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_HOOK, GitgHook);
#line 23 "../libgitg/gitg-hook.vala"
	switch (property_id) {
#line 23 "../libgitg/gitg-hook.vala"
		case GITG_HOOK_ENVIRONMENT_PROPERTY:
#line 23 "../libgitg/gitg-hook.vala"
		g_value_set_object (value, gitg_hook_get_environment (self));
#line 23 "../libgitg/gitg-hook.vala"
		break;
#line 23 "../libgitg/gitg-hook.vala"
		case GITG_HOOK_NAME_PROPERTY:
#line 23 "../libgitg/gitg-hook.vala"
		g_value_set_string (value, gitg_hook_get_name (self));
#line 23 "../libgitg/gitg-hook.vala"
		break;
#line 23 "../libgitg/gitg-hook.vala"
		case GITG_HOOK_WORKING_DIRECTORY_PROPERTY:
#line 23 "../libgitg/gitg-hook.vala"
		g_value_set_object (value, gitg_hook_get_working_directory (self));
#line 23 "../libgitg/gitg-hook.vala"
		break;
#line 23 "../libgitg/gitg-hook.vala"
		case GITG_HOOK_OUTPUT_PROPERTY:
#line 1985 "gitg-hook.c"
		{
			int length;
#line 23 "../libgitg/gitg-hook.vala"
			g_value_take_boxed (value, gitg_hook_get_output (self, &length));
#line 1990 "gitg-hook.c"
		}
#line 23 "../libgitg/gitg-hook.vala"
		break;
#line 1994 "gitg-hook.c"
		default:
#line 23 "../libgitg/gitg-hook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../libgitg/gitg-hook.vala"
		break;
#line 2000 "gitg-hook.c"
	}
}

static void
_vala_gitg_hook_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	GitgHook * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_HOOK, GitgHook);
#line 23 "../libgitg/gitg-hook.vala"
	switch (property_id) {
#line 23 "../libgitg/gitg-hook.vala"
		case GITG_HOOK_ENVIRONMENT_PROPERTY:
#line 23 "../libgitg/gitg-hook.vala"
		gitg_hook_set_environment (self, g_value_get_object (value));
#line 23 "../libgitg/gitg-hook.vala"
		break;
#line 23 "../libgitg/gitg-hook.vala"
		case GITG_HOOK_NAME_PROPERTY:
#line 23 "../libgitg/gitg-hook.vala"
		gitg_hook_set_name (self, g_value_get_string (value));
#line 23 "../libgitg/gitg-hook.vala"
		break;
#line 23 "../libgitg/gitg-hook.vala"
		case GITG_HOOK_WORKING_DIRECTORY_PROPERTY:
#line 23 "../libgitg/gitg-hook.vala"
		gitg_hook_set_working_directory (self, g_value_get_object (value));
#line 23 "../libgitg/gitg-hook.vala"
		break;
#line 2032 "gitg-hook.c"
		default:
#line 23 "../libgitg/gitg-hook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../libgitg/gitg-hook.vala"
		break;
#line 2038 "gitg-hook.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

